************************************************************************
        subroutine whzhMat2(p,m2i0,m2i)
************************************************************************
*	WH/ZH production qq -> lnH/llH  with q any (anti-)quark
*	
*       squared amplitudes for 
*	    parton1(p1) + parton2(p2) --> f(p3) + f'(p4) + H(p5)
*-----------------------------------------------------------------------
*       20.5.10 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
        real*8 p(6,0:3),k(6,0:3),m2aqq(5,5),m2qaq(5,5)
        real*8 m2aqq0(5,5),m2qaq0(5,5)
        real*8 m2i(-5:5,-5:5),m2i0(-5:5,-5:5)
	integer i1,i2,i3,i4
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

      integer selprocess
      common/selprocess/selprocess

c moved to crosssection 6.03.07 AD
c Cache for loop integrals
c        call fastinit(6)

	do i1=-4,4
           do i2=-4,4
              m2i0(i1,i2) = 0d0
              m2i(i1,i2) = 0d0
           enddo
        enddo
c*** initializations
	do 100 i1=1,4
	do 100 i2=1,4
	  m2aqq0(i1,i2)  = 0d0
	  m2qaq0(i1,i2)  = 0d0
	  m2aqq(i1,i2)   = 0d0
	  m2qaq(i1,i2)   = 0d0
100	continue

        do i1=0,3
          k(3,i1) = p(3,i1)
          k(4,i1) = p(4,i1)
          k(5,i1) = p(5,i1)
        enddo

c qbar-q --> qbar-q
        do i1=0,3
          k(1,i1) = p(1,i1)
          k(2,i1) = p(2,i1)
        enddo
	call setprods3(k)
	call whzhMat2aqq(m2aqq,m2aqq0,-1,-2,4,3)

c q-qbar --> q-qbar
        do i1=0,3
          k(1,i1) = p(2,i1)
          k(2,i1) = p(1,i1)
        enddo
	call setprods3(k)
	call whzhMat2aqq(m2qaq,m2qaq0,-1,-2,4,3)

c final assignments
        do 200 i1=1,4
        do 200 i2=1,4
          m2i(i1,i2)   = 0d0
          m2i0(i1,i2)  = 0d0

          m2i0(-i1,i2) = m2aqq0(i1,i2)
          m2i(-i1,i2)  =  m2aqq(i1,i2)
          m2i0(i1,-i2) = m2qaq0(i2,i1)
          m2i(i1,-i2)  =  m2qaq(i2,i1)

          if (selprocess.eq.3.or.selprocess.eq.4)then
             if (i1.ne.i2) then
                m2i0(-i1,i2) = 0d0
                m2i(-i1,i2) = 0d0
                m2i0(i1,-i2) = 0d0
                m2i(i1,-i2) = 0d0
             endif
          endif

c	  if ((m2i0(i1,i2).ne.0d0).and.
c     &	      (abs(m2i(i1,i2)/m2i0(i1,i2)).gt.1d3)) then
c	    m2i0(i1,i2) = 0d0
c	    m2i(i1,i2)  = 0d0
c	  endif
200     continue

	end

************************************************************************
        subroutine whzhMat2aqq(m2aqq,m2aqq0,l1,l2,l4,l3)
************************************************************************
*       squared amplitudes for 
*	    anti-q(p1) + q(p2) --> f(p3) + f'(p4) + H(p5)
*
*       from generic amplitudes for
*	    H(p) --> fa(k1) + anti-fb(k2) + fc(k3) + anti-fd(k4)
*	         CC: f1     + anti-f2     + f3     + anti-f4     
*	         NC: f1     + anti-f1     + f3     + anti-f3     
*	             f2     + anti-f2     + f3     + anti-f3     
*	             f1     + anti-f1     + f4     + anti-f4     
*
*	fermions: f1,f4 = generic   up-type fermions
*	          f2,f3 = generic down-type fermions
*-----------------------------------------------------------------------
*       13.11.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 Fs0(13,-1:1,-1:1),Ft0(13,-1:1,-1:1)
	complex*16 Fs1(13,-1:1,-1:1),Ft1(13,-1:1,-1:1)
	complex*16 Fsgd(13,-1:1,-1:1),Ftgd(13,-1:1,-1:1)
	complex*16 Fsgnd(13,-1:1,-1:1),Ftgnd(13,-1:1,-1:1)
	complex*16 Fshvv0(13,-1:1,-1:1),Fthvv0(13,-1:1,-1:1)
	complex*16 Fshvv1(13,-1:1,-1:1),Fthvv1(13,-1:1,-1:1)
	complex*16 mats0,matt0,wmats0,wmatt0
	complex*16 mats1,matt1,wmats1,wmatt1
	complex*16 matsgd,mattgd,wmatsgd,wmattgd
	complex*16 matshvv0,matthvv0,wmatshvv0,wmatthvv0
	complex*16 matshvv1,matthvv1,wmatshvv1,wmatthvv1
	complex*16 v,cv
	complex*16 m1243(13,-1:1,-1:1),m4312(13,-1:1,-1:1)
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
	complex*16 guu,gdd,gnn,gll     
	complex*16 sp(-4:4,-4:4),csp(-4:4,-4:4)
        real*8 p(6,0:3),m2aqq(5,5),m2aqq0(5,5),vp(-4:4,-4:4)
	integer l1,l2,l3,l4
	integer i1,i2,i3,i4,j,j1,j2,f1,f2,f3,f4,g1,g2,g3,g4
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        integer qhvv

	common/prods3/sp,csp,vp
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/qf/qu,qd,ql,qn,qf(4),mu,mu2,md,md2,mlep,mlep2,
     &            guu(-1:1),gdd(-1:1),gnn(-1:1),gll(-1:1)
        common/hh2/chh2
        common/hvv/rsm,d,db,dt,dtb,lambdahvv,
     &             a1hww,a2hww,a3hww,a1haa,a2haa,a3haa,
     &             a1haz,a2haz,a3haz,a1hzz,a2hzz,a3hzz,qhvv

      integer selprocess
      common/selprocess/selprocess
 

	el6 = el**6

c invariants
        s   = vp(l1,l2)
	s12 = vp(l3,l4)
	t11 = vp(l1,l3)
	t21 = vp(l2,l3)
	t12 = vp(l1,l4)
	t22 = vp(l2,l4)
	s23 = t11+t21+s
	s13 = t12+t22+s
	t13 = t21+t22+s12
	t23 = t11+t12+s12

c standard matrix elements
c qbar q -> qbar q
        call calcsmeH4f(m1243,l1,l2,l4,l3)
        call calcsmeH4f(m4312,l4,l3,l1,l2)

c qbar-q scattering
c
c   s-channel:                          
c
c   fa(p1) \_          / fd(p3)        
c          |\        |/               
c            \       /-              
c             *vvvvv*               
c           _/       \             
c           /|        \|          
c   fb(p2) /          -\ fc(p4)  


	if (selprocess.eq.2) then

c Type: ubar d -> nubar l-
c-------------------------

c*** generic amplitudes
	call setFnull(Fs0)
	call setFnull(Fs1)
	call setFnull(Fsgd)
	call setFnull(Fsgnd)
	call setFnull(Fshvv0)
	call setFnull(Fshvv1)

c ubar-d -W-> cbar-s    (k1->-p1,k2->-p2,k3->p4,k4->p3)   
	call calcform_HWW4f(Fs0,Fs1,Fsgd,Fsgnd,Fshvv0,Fshvv1,
     &			      s,t12,t11,t22,t21,s12,t13,t23,s23,s13)

c*** individual channels
	do 200 i1=-1,1,2
	do 200 i2=-1,1,2
	do 200 i4=-1,1,2
	  mats0   = 0d0
	  mats1   = 0d0
	  matsgd  = 0d0
	  matshvv0 = 0d0
	  matshvv1 = 0d0
	  if (i1.eq.-i2) then
      	    mats0  = mats0 + m1243(1,i2,i4)*Fs0(1,i2,i4)
            if (qhvv.eq.0) then
      	      matsgd = matsgd + m1243(1,i2,i4)*Fsgd(1,i2,i4)
	    else
	      do j=1,13
      	        matshvv0 = matshvv0 + m1243(j,i2,i4)*Fshvv0(j,i2,i4)
      	        matshvv1 = matshvv1 + m1243(j,i2,i4)*Fshvv1(j,i2,i4)
	      enddo
	    endif
	    do j=1,13
      	      mats1 = mats1 + m1243(j,i2,i4)*Fs1(j,i2,i4)
	    enddo
	  endif
	
 	do 200 g1=1,2
 	do 200 g2=1,2
 	  wmats0   = cv(g1,g2)*mats0
 	  wmats1   = cv(g1,g2)*mats1
          if (qhvv.eq.0) then
 	    wmatsgd  = cv(g1,g2)*matsgd
	  else
 	    wmatshvv0   = cv(g1,g2)*matshvv0
 	    wmatshvv1   = cv(g1,g2)*matshvv1
	  endif
 	  f1 = 2*g1
 	  f2 = 2*g2-1
          if (qhvv.eq.0) then
 	    m2aqq0(f1,f2) = m2aqq0(f1,f2) + el6*(
     &		+ 3d0*abs(wmats0)**2 ) 
 	    m2aqq(f1,f2) = m2aqq(f1,f2) + el6*(
     &		+ qborn*( 3d0*abs(wmats0)**2 ) 
     &		+ 2d0*dreal(+3d0*( wmatsgd*dconjg(wmats0) ) ) )
	  else
 	    m2aqq0(f1,f2) = m2aqq0(f1,f2) + el6*(
     &		+ 3d0*abs(wmatshvv0)**2 ) 
 	    m2aqq(f1,f2) = m2aqq(f1,f2) + el6*(
     &		+ qborn*( 3d0*abs(wmatshvv0)**2 ) 
     &		+ 2d0*dreal(+3d0*( wmatshvv1*dconjg(wmatshvv0) ) ) )
	  endif
 	  m2aqq(f1,f2) = m2aqq(f1,f2) + el6*(
     &		+ 2d0*dreal( 3d0*( wmats1 *dconjg(wmats0) ) ) )
200	continue

c>sk        print *, 'm2aqq0(',f1,f2,') = ', m2aqq0(f1,f2)

	elseif (selprocess.eq.1) then

c Type: dbar u -> l+ nubar
c-------------------------

c*** generic amplitudes
	call setFnull(Fs0)
	call setFnull(Fs1)
	call setFnull(Fsgd)
	call setFnull(Fsgnd)
	call setFnull(Fshvv0)
	call setFnull(Fshvv1)

c dbar-u -W-> sbar-c    (k3->-p1,k4->-p2,k1->p4,k2->p3)   
	call calcform_HWW4f(Fs0,Fs1,Fsgd,Fsgnd,Fshvv0,Fshvv1,
     &		              s12,t12,t22,t11,t21,s,s23,s13,t13,t23)

	do 205 i1=-1,1,2
	do 205 i2=-1,1,2
	do 205 i4=-1,1,2
	  mats0   = 0d0
	  mats1   = 0d0
	  matsgd  = 0d0
	  matshvv0 = 0d0
	  matshvv1 = 0d0
	  if (i1.eq.-i2) then
      	    mats0 = mats0 + m4312(1,i4,i2)*Fs0(1,i4,i2)
            if (qhvv.eq.0) then
      	      matsgd = matsgd + m4312(1,i4,i2)*Fsgd(1,i4,i2)
	    else
	      do j=1,13
      	      matshvv0 = matshvv0 + m4312(j,i4,i2)*Fshvv0(j,i4,i2)
      	      matshvv1 = matshvv1 + m4312(j,i4,i2)*Fshvv1(j,i4,i2)
	      enddo
	    endif
	    do j=1,13
      	      mats1 = mats1 + m4312(j,i4,i2)*Fs1(j,i4,i2)
	    enddo
	  endif

 	do 205 g1=1,2
 	do 205 g2=1,2
 	  wmats0  = v(g2,g1)*mats0
 	  wmats1  = v(g2,g1)*mats1
          if (qhvv.eq.0) then
 	    wmatsgd = v(g2,g1)*matsgd
	  else
 	    wmatshvv0  = v(g2,g1)*matshvv0
 	    wmatshvv1  = v(g2,g1)*matshvv1
	  endif
 	  f1 = 2*g1-1
 	  f2 = 2*g2
          if (qhvv.eq.0) then
 	    m2aqq0(f1,f2) = m2aqq0(f1,f2) + el6*(
     &		+ 3d0*abs(wmats0)**2 ) 
 	    m2aqq(f1,f2) = m2aqq(f1,f2) + el6*(
     &		+ qborn*( 3d0*abs(wmats0)**2 ) 
     &		+ 2d0*dreal(+3d0*( wmatsgd*dconjg(wmats0) ) ) )
	  else
 	    m2aqq0(f1,f2) = m2aqq0(f1,f2) + el6*(
     &		+ 3d0*abs(wmatshvv0)**2 ) 
 	    m2aqq(f1,f2) = m2aqq(f1,f2) + el6*(
     &		+ qborn*( 3d0*abs(wmatshvv0)**2 ) 
     &		+ 2d0*dreal(+3d0*( wmatshvv1*dconjg(wmatshvv0) ) ) )
	  endif
 	    m2aqq(f1,f2) = m2aqq(f1,f2) + el6*(
     &		+ 2d0*dreal( 3d0*( wmats1 *dconjg(wmats0) ) ) )
205	continue

	elseif (selprocess.eq.3) then

c Type: ubar u -> l+ l-
c---------------------- 

c*** generic amplitudes
	call setFnull(Fs0)
	call setFnull(Fs1)
	call setFnull(Fsgd)
	call setFnull(Fsgnd)
	call setFnull(Fshvv0)
	call setFnull(Fshvv1)

c ubar-u -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
	call calcform_HZZ1133(Fs0,Fs1,Fsgd,Fsgnd,Fshvv0,Fshvv1,
     &			        s,t12,t11,t22,t21,s12,t13,t23,s23,s13)

	  do 202 i1=-1,1,2
	  do 202 i2=-1,1,2
	  do 202 i4=-1,1,2
	    mats0   = 0d0
	    mats1   = 0d0
	    matsgd  = 0d0
	    matshvv0 = 0d0
	    matshvv1 = 0d0
	    if (i1.eq.-i2) then
      	      mats0 = mats0 + m1243(1,i2,i4)*Fs0(1,i2,i4)
              if (qhvv.eq.0) then
      	        matsgd = matsgd + m1243(1,i2,i4)*Fsgd(1,i2,i4)
	      else
	      do j=1,13
      		matshvv0 = matshvv0 + m1243(j,i2,i4)*Fshvv0(j,i2,i4)
      		matshvv1 = matshvv1 + m1243(j,i2,i4)*Fshvv1(j,i2,i4)
	      enddo
	      endif
	      do j=1,13
      		mats1 = mats1 + m1243(j,i2,i4)*Fs1(j,i2,i4)
	      enddo
	    endif

            if (qhvv.eq.0) then
 	      m2aqq0(2,2) = m2aqq0(2,2) + el6*(
     &		            +3d0*abs(mats0)**2 )
 	      m2aqq(2,2) = m2aqq(2,2) + el6*(
     &		+ qborn*(  3d0*abs(mats0)**2 )
     &		+ 2d0*dreal(+3d0*( matsgd *dconjg(mats0) ) ) )
	    else
 	      m2aqq0(2,2) = m2aqq0(2,2) + el6*(
     &		            +3d0*abs(matshvv0)**2 )
 	      m2aqq(2,2) = m2aqq(2,2) + el6*(
     &		+ qborn*(  3d0*abs(matshvv0)**2 )
     &		+ 2d0*dreal(+3d0*( matshvv1 *dconjg(matshvv0) ) ) )
	    endif
 	    m2aqq(2,2) = m2aqq(2,2) + el6*(
     &		+ 2d0*dreal( 3d0*( mats1  *dconjg(mats0) ) ) )
202	  continue
	  m2aqq0(4,4) = m2aqq0(2,2) 
	  m2aqq(4,4)  = m2aqq(2,2)

c Type: dbar d -> l+ l-
c----------------------

c*** generic amplitudes
	call setFnull(Fs0)
	call setFnull(Fs1)
	call setFnull(Fsgd)
	call setFnull(Fsgnd)
	call setFnull(Fshvv0)
	call setFnull(Fshvv1)

c dbar-d -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
	call calcform_HZZ2233(Fs0,Fs1,Fsgd,Fsgnd,Fshvv0,Fshvv1,
     &			s,t12,t11,t22,t21,s12,t13,t23,s23,s13)

	  do 203 i1=-1,1,2
	  do 203 i2=-1,1,2
	  do 203 i4=-1,1,2
	    mats0   = 0d0
	    mats1   = 0d0
	    matsgd  = 0d0
	    matshvv0 = 0d0
	    matshvv1 = 0d0
	    if (i1.eq.-i2) then
      	      mats0 = mats0 + m1243(1,i2,i4)*Fs0(1,i2,i4)
              if (qhvv.eq.0) then
      	        matsgd = matsgd + m1243(1,i2,i4)*Fsgd(1,i2,i4)
	      else
	      do j=1,13
      		matshvv0 = matshvv0 + m1243(j,i2,i4)*Fshvv0(j,i2,i4)
      		matshvv1 = matshvv1 + m1243(j,i2,i4)*Fshvv1(j,i2,i4)
	      enddo
	      endif
	      do j=1,13
      		mats1 = mats1 + m1243(j,i2,i4)*Fs1(j,i2,i4)
	      enddo
	    endif
            if (qhvv.eq.0) then
	      m2aqq0(1,1) = m2aqq0(1,1) + el6*(
     &	  	  + 3d0*abs(mats0)**2 )
	      m2aqq(1,1) = m2aqq(1,1) + el6*(
     &		  + 3d0*qborn*abs(mats0)**2 
     &		  + 2d0*dreal(+3d0*( matsgd*dconjg(mats0) ) ) )
	    else
	      m2aqq0(1,1) = m2aqq0(1,1) + el6*(
     &	  	  + 3d0*abs(matshvv0)**2 )
	      m2aqq(1,1) = m2aqq(1,1) + el6*(
     &		  + 3d0*qborn*abs(matshvv0)**2 
     &		  + 2d0*dreal(+3d0*( matshvv1*dconjg(matshvv0) ) ) )
	    endif
	    m2aqq(1,1) = m2aqq(1,1) + el6*(
     &		+ 2d0*dreal( 3d0*( mats1 *dconjg(mats0) ) ) )
203	  continue
	  m2aqq0(3,3) = m2aqq0(1,1) 
	  m2aqq(3,3)  = m2aqq(1,1)

	elseif (selprocess.eq.4) then

c Type: ubar u -> anti-nu_l nu_l
c------------------------------- 

c*** generic amplitudes
	call setFnull(Fs0)
	call setFnull(Fs1)
	call setFnull(Fsgd)
	call setFnull(Fsgnd)
	call setFnull(Fshvv0)
	call setFnull(Fshvv1)

c ubar-u -Z-> cbar-c    (k3->-p1,k4->-p2,k1->p4,k2->p3)
          call calcform_HZZ1144(Fs0,Fs1,Fsgd,Fsgnd,Fshvv0,Fshvv1,
     &                  s12,t12,t22,t11,t21,s,s23,s13,t13,t23)

	  do 207 i1=-1,1,2
	  do 207 i2=-1,1,2
	  do 207 i4=-1,1,2
	    mats0   = 0d0
	    mats1   = 0d0
	    matsgd  = 0d0
	    matshvv0 = 0d0
	    matshvv1 = 0d0
	    if (i1.eq.-i2) then
              mats0 = mats0 + m4312(1,i4,i2)*Fs0(1,i4,i2)
              if (qhvv.eq.0) then
                matsgd = matsgd + m4312(1,i4,i2)*Fsgd(1,i4,i2)
	      else
	      do j=1,13
                matshvv0 = matshvv0 + m4312(j,i4,i2)*Fshvv0(j,i4,i2)
                matshvv1 = matshvv1 + m4312(j,i4,i2)*Fshvv1(j,i4,i2)
	      enddo
	      endif
	      do j=1,13
                mats1 = mats1 + m4312(j,i4,i2)*Fs1(j,i4,i2)
	      enddo
	    endif

            if (qhvv.eq.0) then
 	      m2aqq0(2,2) = m2aqq0(2,2) + el6*(
     &		            +3d0*abs(mats0)**2 )
 	      m2aqq(2,2) = m2aqq(2,2) + el6*(
     &		  + qborn*(  3d0*abs(mats0)**2 )
     &		  + 2d0*dreal(+3d0*( matsgd *dconjg(mats0) ) ) )
	    else
 	      m2aqq0(2,2) = m2aqq0(2,2) + el6*(
     &		            +3d0*abs(matshvv0)**2 )
 	      m2aqq(2,2) = m2aqq(2,2) + el6*(
     &		  + qborn*(  3d0*abs(matshvv0)**2 )
     &		  + 2d0*dreal(+3d0*( matshvv1 *dconjg(matshvv0) ) ) )
	    endif
 	    m2aqq(2,2) = m2aqq(2,2) + el6*(
     &		+ 2d0*dreal( 3d0*( mats1  *dconjg(mats0) ) ) )
207	  continue
	  m2aqq0(4,4) = m2aqq0(2,2) 
	  m2aqq(4,4)  = m2aqq(2,2)

c Type: dbar d -> anti-nu_l nu_l
c-------------------------------

c*** generic amplitudes
	call setFnull(Fs0)
	call setFnull(Fs1)
	call setFnull(Fsgd)
	call setFnull(Fsgnd)
	call setFnull(Fshvv0)
	call setFnull(Fshvv1)

c dbar-d -Z-> cbar-c  (k3->-p1,k4->-p2,k1->p4,k2->p3)
        call calcform_HZZ1133(Fs0,Fs1,Fsgd,Fsgnd,Fshvv0,Fshvv1,
     &                          s12,t12,t22,t11,t21,s,s23,s13,t13,t23)

	  do 208 i1=-1,1,2
	  do 208 i2=-1,1,2
	  do 208 i4=-1,1,2
	    mats0   = 0d0
	    mats1   = 0d0
	    matsgd  = 0d0
	    matshvv0 = 0d0
	    matshvv1 = 0d0
	    if (i1.eq.-i2) then
              mats0 = mats0 + m4312(1,i4,i2)*Fs0(1,i4,i2)
              if (qhvv.eq.0) then
                matsgd = matsgd + m4312(1,i4,i2)*Fsgd(1,i4,i2)
	      else
	      do j=1,13
                matshvv0 = matshvv0 + m4312(j,i4,i2)*Fshvv0(j,i4,i2)
                matshvv1 = matshvv1 + m4312(j,i4,i2)*Fshvv1(j,i4,i2)
	      enddo
	      endif
	      do j=1,13
                mats1 = mats1 + m4312(j,i4,i2)*Fs1(j,i4,i2)
	      enddo
	    endif
            if (qhvv.eq.0) then
	      m2aqq0(1,1) = m2aqq0(1,1) + el6*(
     &		  + 3d0*abs(mats0)**2 )
	      m2aqq(1,1) = m2aqq(1,1) + el6*(
     &		  + 3d0*qborn*abs(mats0)**2 
     &		  + 2d0*dreal(+3d0*( matsgd*dconjg(mats0) ) ) )
	    else
	      m2aqq0(1,1) = m2aqq0(1,1) + el6*(
     &		  + 3d0*abs(matshvv0)**2 )
	      m2aqq(1,1) = m2aqq(1,1) + el6*(
     &		  + 3d0*qborn*abs(matshvv0)**2 
     &		  + 2d0*dreal(+3d0*( matshvv1*dconjg(matshvv0) ) ) )
	    endif
	    m2aqq(1,1) = m2aqq(1,1) + el6*(
     &		+ 2d0*dreal( 3d0*( mats1 *dconjg(mats0) ) ) )
208	  continue
	  m2aqq0(3,3) = m2aqq0(1,1) 
	  m2aqq(3,3)  = m2aqq(1,1)

	endif

	end

************************************************************************
        subroutine whzhMat2born(p,m2i0,qbcalc,qqhvv)
************************************************************************
*       Born structures needed for subtraction function for
*	    parton1(p1) + parton2(p2) --> f(p3) + f'(p4) + H(p5)
*	qbcalc = 0/1: b-quarks ex-/in-cluded in evaluation
*
*       Note: qqhvv=0  -> pure SM
*             qqhvv>0  -> inclusion of anomalous HVV couplings !
*
*-----------------------------------------------------------------------
*       20.06.10 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
	complex*16 pws,pws12,pwt11,pwt22,pwt12,pwt21
	complex*16 pzs,pzs12,pzt11,pzt22,pzt12,pzt21
        real*8 p(6,0:3)
        real*8 m2aqq0ss(5,5),m2qaq0ss(5,5)
        real*8 m2qq0ss(5,5),m2aqaq0ss(5,5)
        real*8 m2i0(-5:5,-5:5)
	integer i1,i2,i3,i4,i,j,qb,qbcalc
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        integer qqhvv

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

      integer selprocess
      common/selprocess/selprocess

        data m2aqq0ss/25*0/
        data m2qaq0ss/25*0/

c energies and angles
        eb1  = p(1,0)
        eb2  = p(2,0)
	e1   = p(3,0)
	e2   = p(4,0)
	cth1 = p(3,3)/p(3,0)
	cth2 = p(4,3)/p(4,0)
	if (p(1,3).lt.0d0) then
	  cth1 = -cth1
	  cth2 = -cth2
	endif
	sth1 = sqrt(p(3,1)**2+p(3,2)**2)/p(3,0)
	sth2 = sqrt(p(4,1)**2+p(4,2)**2)/p(4,0)
        if (cth1.gt.0d0) then
          c22th1 = (1d0+cth1)*.5d0
          s22th1 = sth1**2/(4d0*c22th1)
        else
          s22th1 = (1d0-cth1)*.5d0
          c22th1 = sth1**2/(4d0*s22th1)
        endif
        if (cth2.gt.0d0) then
          c22th2 = (1d0+cth2)*.5d0
          s22th2 = sth2**2/(4d0*c22th2)
        else
          s22th2 = (1d0-cth2)*.5d0
          c22th2 = sth2**2/(4d0*s22th2)
        endif

c invariants
        s    = 4d0*eb1*eb2
        t11  = -4d0*eb1*e1*s22th1
        t12  = -4d0*eb1*e2*s22th2
        t21  = -4d0*eb2*e1*c22th1
        t22  = -4d0*eb2*e2*c22th2
c        s12  = mh2-s+4d0*e1*eb1*s22th1+4d0*e1*eb2*c22th1
c     &		    +4d0*e2*eb1*s22th2+4d0*e2*eb2*c22th2
	s12  = 2d0*( p(3,0)*p(4,0)-p(3,1)*p(4,1)
     &	            -p(3,2)*p(4,2)-p(3,3)*p(4,3))

c propagators
        if(qwidth.eq.1) then
          pws12 = 1d0/(s12-cmw2)
          pzs12 = 1d0/(s12-cmz2)
          pws = 1d0/(s-cmw2)
          pzs = 1d0/(s-cmz2)
        else

          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s12.lt.0d0))) then
            pws12 = 1d0/(s12-mw2)
            pzs12 = 1d0/(s12-mz2)
          else
            pws12 = 1d0/(s12-cmw2)
            pzs12 = 1d0/(s12-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s.lt.0d0))) then
            pws = 1d0/(s-mw2)
            pzs = 1d0/(s-mz2)
          else
            pws = 1d0/(s-cmw2)
            pzs = 1d0/(s-cmz2)
          endif

        endif
          
c*** initializations
	do 100 i1=1,5
	do 100 i2=1,5
	  m2aqq0ss(i1,i2)  = 0d0
	  m2qaq0ss(i1,i2)  = 0d0
100	continue

	qb = qbcalc
	if ((qbini.eq.0).and.(qbfin.eq.0)) qb = 0
c>sk        print *, 'qbcalc = ',qbcalc,'   qb = ',qb

	if (qqhvv.eq.0) then

c qbar-q --> lbar-l
	  call whzhMat2aqqborn(m2aqq0ss,
     &			 s,s12,t11,t21,t12,t22,pws,pws12,pzs,pzs12,qb)
c q-qbar --> lbar-l
	  call whzhMat2aqqborn(m2qaq0ss,
     &			 s,s12,t12,t22,t11,t21,pws,pws12,pzs,pzs12,qb)

	else

          call setprods3(p)
c qbar-q --> lbar-l
          call whzhMat2aqqbornhvv(m2aqq0ss,-1,-2,3,4,qb)
c q-qbar --> lbar-l
          call whzhMat2aqqbornhvv(m2qaq0ss,-2,-1,3,4,qb)

	endif

c final assignments
        do 200 i1=1,4+qbini
        do 200 i2=1,4+qbini
	  m2i0(-i1,i2) = m2aqq0ss(i1,i2)
          m2i0(i1,-i2) = m2qaq0ss(i2,i1)
          if (selprocess.eq.3.or.selprocess.eq.4)then
             if (i1.ne.i2) then
                m2i0(-i1,i2) = 0d0
                m2i0(i1,-i2) = 0d0
             endif
          endif
200     continue

	end

************************************************************************
        subroutine whzhMat2aqqborn(m2aqq0ss,
     &			s,s12,t11,t21,t12,t22,pws,pws12,pzs,pzs12,qb)
************************************************************************
*       generic Born structures needed for subtraction function for
*	    anti-q(p1) + q(p2) --> f(p3) + f'(p4) + H(p5)
*
*       from generic amplitudes for
*	    H(p) --> fa(k1) + anti-fb(k2) + fc(k3) + anti-fd(k4)
*	         CC: f1     + anti-f2     + f3     + anti-f4     
*	         NC: f1     + anti-f1     + f3     + anti-f3     
*	             f2     + anti-f2     + f3     + anti-f3     
*	             f1     + anti-f1     + f4     + anti-f4     
*
*	fermions: f1,f4 = generic   up-type fermions
*	          f2,f3 = generic down-type fermions
*-----------------------------------------------------------------------
*       13.10.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 pre,pres,pret,mats0,matt0,wmats0,wmatt0
	complex*16 v,cv
	complex*16 pws,pws12,pwt11,pwt22
	complex*16 pzs,pzs12,pzt11,pzt22
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
	complex*16 guu,gdd,gnn,gll     
	real*8 m1243sq(-1:1,-1:1),m4213sq(-1:1,-1:1)
        real*8 m2aqq0ss(5,5)
	integer ia,ib,ic,id,selprocess
	integer i1,i2,i3,i4,j,j1,j2,f1,f2,f3,f4,g1,g2,g3,g4,qb
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
	logical checkss12,checkt11t22

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/qf/qu,qd,ql,qn,qf(4),mu,mu2,md,md2,mlep,mlep2,
     &            guu(-1:1),gdd(-1:1),gnn(-1:1),gll(-1:1)
        common/selprocess/selprocess

c>sk        print *, '   qb = ',qb

	el3 = el**3

        m1243sq(1,1)   = 4D0*t12*t21
        m1243sq(-1,1)  = 4D0*t11*t22
        m1243sq(1,-1)  = m1243sq(-1,1)
        m1243sq(-1,-1) = m1243sq(1,1)

        M4213sq(1,1)   = m1243sq(1,1)
        M4213sq(-1,1)  = 4D0*s*s12
        M4213sq(1,-1)  = M4213sq(-1,1)
        M4213sq(-1,-1) = m1243sq(-1,-1)


	checkss12   = ((  s*qschan.gt.0d0).or.(  s*qtchan.lt.0d0)).and.
     &	              ((s12*qschan.gt.0d0).or.(s12*qtchan.lt.0d0))

c qbar-q scattering
c
c   s-channel:                         
c
c   fa(p1) \_          / fd(p3)       
c          |\        |/               
c            \       /-               
c             *vvvvv*                 
c           _/       \                
c           /|        \|              
c   fb(p2) /          -\ fc(p4)       

	if (selprocess.eq.2) then

c Type: ubar-d -> nbar l-
c------------------------

c*** generic amplitudes
	pres = 0d0

c ubar-d -W-> cbar-s    (k1->-p1,k2->-p2,k3->p4,k4->p3)   
        if (checkss12) pres = qw*el3*PWS12*PWS*XMW/(2D0*XSW*XSW2)

c*** individual channels
 	do 200 g1=1,2
 	do 200 g2=1,2+qb
 	  f1 = 2*g1
 	  f2 = 2*g2-1

	  mats0  = -pres
	  fac    = m4213sq(-1,-1)
 	  wmats0 = cv(g1,g2)*mats0

 	  m2aqq0ss(f1,f2) = fac*3d0*abs(wmats0)**2 *qch2 

200	continue

	elseif (selprocess.eq.1) then

c Type: dbar-u -> l+ n
c----------------------

c*** generic amplitudes
	pres = 0d0

c dbar-u -W-> sbar-c    (k3->-p1,k4->-p2,k1->p4,k2->p3)   
	if (checkss12) pres = qw*el3*PWS12*PWS*XMW/(2D0*XSW*XSW2)

 	do 205 g1=1,2+qb
 	do 205 g2=1,2
 	  f1 = 2*g1-1
 	  f2 = 2*g2

	  mats0  = -pres
	  fac    = m4213sq(-1,-1)
 	  wmats0 = v(g2,g1)*mats0

 	  m2aqq0ss(f1,f2) = fac*3d0*abs(wmats0)**2 *qch2 
205	continue

	elseif (selprocess.eq.3) then

c Type: ubar-u -> l+l-
c--------------------- 

c*** generic amplitudes
	pres = 0d0

c ubar-u -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
        if (checkss12) pres = qz*el3*PZS*PZS12*XMW/(XSW*XCW2)

 	do 202 g1=1,2
 	do 202 g2=1,2
 	  f1 = 2*g1
 	  f2 = 2*g2

	  m2aqq0ss(f1,f2) = 0d0
	  if (f1.ne.f2) goto 202
	do 302 i1=1,4

	  if (i1.eq.1) then
	    mats0  = pres*guu(+1)*gll(-1)
	    fac    = m1243sq(-1,+1)
	  elseif (i1.eq.2) then
	    mats0  = pres*guu(-1)*gll(-1)
	    fac    = m1243sq(-1,-1)
	  elseif (i1.eq.3) then
	    mats0  = pres*guu(+1)*gll(+1)
	    fac    = m1243sq(+1,+1)
	  elseif (i1.eq.4) then
	    mats0  = pres*guu(-1)*gll(+1)
	    fac    = m1243sq(+1,-1)
	  endif

 	  m2aqq0ss(f1,f2) = m2aqq0ss(f1,f2) 
     &	                    + fac*3d0*abs(mats0)**2 *qch2 

302	continue
202	continue


c Type: dbar-d -> l+l-
c---------------------

c*** generic amplitudes
	pres = 0d0

c dbar-d -Z-> dbar-d  (k1->-p1,k2->-p2,k3->p4,k4->p3)
	if (checkss12) pres = qz*el3*PZS*PZS12*XMW/(XSW*XCW2)

c>sk 	do 203 g1=1,2
c>sk 	do 203 g2=1,2
 	do 203 g1=1,2+qb
 	do 203 g2=1,2+qb
 	  f1 = 2*g1-1
 	  f2 = 2*g2-1

	  m2aqq0ss(f1,f2) = 0d0
	  if (f1.ne.f2) goto 203
	do 303 i1=1,4

	  if (i1.eq.1) then
	    mats0  = pres*gdd(+1)*gll(-1)
	    fac    = m1243sq(-1,+1)
	  elseif (i1.eq.2) then
	    mats0  = pres*gdd(-1)*gll(-1)
	    fac    = m1243sq(-1,-1)
	  elseif (i1.eq.3) then
	    mats0  = pres*gdd(+1)*gll(+1)
	    fac    = m1243sq(+1,+1)
	  elseif (i1.eq.4) then
	    mats0  = pres*gdd(-1)*gll(+1)
	    fac    = m1243sq(+1,-1)
	  endif

c          print *, '  g1=',g1,'  g2=',g2,'  f1=',f1,'  f2=',f2
c          print *,'fac = ',fac
c          print *,'mats0 = ',mats0

	  m2aqq0ss(f1,f2) = m2aqq0ss(f1,f2) 
     &	                    + fac*3d0*abs(mats0)**2 *qch2 
c>sk          print *,'m2aqq0ss(',f1,f2,')=',m2aqq0ss(f1,f2)

303	continue
203	continue

	elseif (selprocess.eq.4) then

c Type: ubar u -> anti-nu_l nu_l
c------------------------------- 

c*** generic amplitudes
	pres = 0d0

c ubar-u -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
        if (checkss12) pres = qz*el3*PZS*PZS12*XMW/(XSW*XCW2)

 	do 207 g1=1,2
 	do 207 g2=1,2
 	  f1 = 2*g1
 	  f2 = 2*g2

	  m2aqq0ss(f1,f2) = 0d0
	  if (f1.ne.f2) goto 207
	do 307 i1=1,4

	  if (i1.eq.1) then
	    mats0  = pres*guu(+1)*gnn(-1)
	    fac    = m1243sq(-1,+1)
	  elseif (i1.eq.2) then
	    mats0  = pres*guu(-1)*gnn(-1)
	    fac    = m1243sq(-1,-1)
	  elseif (i1.eq.3) then
	    mats0  = pres*guu(+1)*gnn(+1)
	    fac    = m1243sq(+1,+1)
	  elseif (i1.eq.4) then
	    mats0  = pres*guu(-1)*gnn(+1)
	    fac    = m1243sq(+1,-1)
	  endif

 	  m2aqq0ss(f1,f2) = m2aqq0ss(f1,f2) 
     &	                    + fac*3d0*abs(mats0)**2 *qch2 
307	continue
207	continue


c Type: dbar d -> anti-nu_l nu_l
c-------------------------------

c*** generic amplitudes
	pres = 0d0

c dbar-d -Z-> dbar-d  (k1->-p1,k2->-p2,k3->p4,k4->p3)
	if (checkss12) pres = qz*el3*PZS*PZS12*XMW/(XSW*XCW2)

c>sk 	do 208 g1=1,2
c>sk 	do 208 g2=1,2
 	do 208 g1=1,2+qb
 	do 208 g2=1,2+qb
 	  f1 = 2*g1-1
 	  f2 = 2*g2-1

	  m2aqq0ss(f1,f2) = 0d0
	  if (f1.ne.f2) goto 208
	do 308 i1=1,4

	  if (i1.eq.1) then
	    mats0  = pres*gdd(+1)*gnn(-1)
	    fac    = m1243sq(-1,+1)
	  elseif (i1.eq.2) then
	    mats0  = pres*gdd(-1)*gnn(-1)
	    fac    = m1243sq(-1,-1)
	  elseif (i1.eq.3) then
	    mats0  = pres*gdd(+1)*gnn(+1)
	    fac    = m1243sq(+1,+1)
	  elseif (i1.eq.4) then
	    mats0  = pres*gdd(-1)*gnn(+1)
	    fac    = m1243sq(+1,-1)
	  endif

	  m2aqq0ss(f1,f2) = m2aqq0ss(f1,f2) 
     &	                    + fac*3d0*abs(mats0)**2 *qch2 

308	continue
208	continue

	endif

	end

************************************************************************
        subroutine whzhMat2aqqbornhvv(m2aqq0ss,q1,q2,q3,q4,qb)
************************************************************************
*       generic Born structures needed for subtraction function for
*	    anti-q(p1) + q(p2) --> f(p3) + f'(p4) + H(p5)
*
*       including anomalous HVV couplings !!!
*
*       from generic amplitudes for
*	    H(p) --> fa(k1) + anti-fb(k2) + fc(k3) + anti-fd(k4)
*	         CC: f1     + anti-f2     + f3     + anti-f4     
*	         NC: f1     + anti-f1     + f3     + anti-f3     
*	             f2     + anti-f2     + f3     + anti-f3     
*	             f1     + anti-f1     + f4     + anti-f4     
*
*	fermions: f1,f4 = generic   up-type fermions
*	          f2,f3 = generic down-type fermions
*-----------------------------------------------------------------------
*       18.6.12 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 msH4f(-1:1,-1:1)
        complex*16 sp(-4:4,-4:4),csp(-4:4,-4:4)
	complex*16 pre,pres,pret,mats0,matt0,wmats0,wmatt0
	complex*16 v,cv
	complex*16 pws,pws12,pwt11,pwt22
	complex*16 pzs,pzs12,pzt11,pzt22
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
	complex*16 guu,gdd,gnn,gll     
	real*8 m1243sq(-1:1,-1:1),m4213sq(-1:1,-1:1)
        real*8 m2aqq0ss(5,5)
        real*8 vp(-4:4,-4:4)
	integer ia,ib,ic,id,selprocess,q1,q2,q3,q4
	integer i1,i2,i3,i4,j,j1,j2,f1,f2,f3,f4,g1,g2,g3,g4,qb
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
	logical checkss12,checkt11t22

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/qf/qu,qd,ql,qn,qf(4),mu,mu2,md,md2,mlep,mlep2,
     &            guu(-1:1),gdd(-1:1),gnn(-1:1),gll(-1:1)
        common/selprocess/selprocess
        common/prods3/sp,csp,vp

c>sk        print *, '   qb = ',qb

	fac = el**6

c invariants
        s   = vp(q1,q2)
        s12 = vp(q3,q4)

        call fixahvv(s,s12,
     &             a1hwws,a2hwws,a3hwws,a1haas,a2haas,a3haas,
     &             a1hazs,a2hazs,a3hazs,a1hzzs,a2hzzs,a3hzzs)

	checkss12   = ((  s*qschan.gt.0d0).or.(  s*qtchan.lt.0d0)).and.
     &	              ((s12*qschan.gt.0d0).or.(s12*qtchan.lt.0d0))

c qbar-q scattering
c
c   s-channel:                         
c
c   fa(p1) \_          / fd(p3)       
c          |\        |/               
c            \       /-               
c             *vvvvv*                 
c           _/       \                
c           /|        \|              
c   fb(p2) /          -\ fc(p4)       

	if (selprocess.eq.2) then

c Type: ubar-d -> nbar l-
c------------------------

c*** generic amplitudes
        do i1=-1,1,2
        do i2=-1,1,2
          msH4f(i1,i2) = 0d0
        enddo
        enddo

c ubar-d -W-> cbar-s    (k1->-p1,k2->-p2,k3->p4,k4->p3)   
        if (qw.eq.1) call M_WW_hvv(msH4f,q1,q2,q4,q3,
     &                    a1hwws,a2hwws,a3hwws)

c*** individual channels
 	do 200 g1=1,2
 	do 200 g2=1,2+qb
 	  f1 = 2*g1
 	  f2 = 2*g2-1

	  mats0  = msH4f(-1,-1)
 	  wmats0 = cv(g1,g2)*mats0

 	  m2aqq0ss(f1,f2) = fac*3d0*abs(wmats0)**2 *qch2 

200	continue

	elseif (selprocess.eq.1) then

c Type: dbar-u -> l+ n
c----------------------

c*** generic amplitudes
        do i1=-1,1,2
        do i2=-1,1,2
          msH4f(i1,i2) = 0d0
        enddo
        enddo

c dbar-u -W-> sbar-c    (k3->-p1,k4->-p2,k1->p4,k2->p3)   
        if (qw.eq.1) call M_WW_hvv(msH4f,q4,q3,q1,q2,
     &                    a1hwws,a2hwws,a3hwws)

 	do 205 g1=1,2+qb
 	do 205 g2=1,2
 	  f1 = 2*g1-1
 	  f2 = 2*g2

	  mats0  = msH4f(-1,-1)
 	  wmats0 = v(g2,g1)*mats0

 	  m2aqq0ss(f1,f2) = fac*3d0*abs(wmats0)**2 *qch2 
205	continue

	elseif (selprocess.eq.3) then

c Type: ubar-u -> l+l-
c--------------------- 

c*** generic amplitudes
        do i1=-1,1,2
        do i2=-1,1,2
          msH4f(i1,i2) = 0d0
        enddo
        enddo

c ubar-u -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
        if (qz.eq.1) call M_ZZ_hvv(msH4f,guu,gll,qu,ql,q1,q2,q4,q3,
     &                    a1haas,a2haas,a3haas,a1hazs,a2hazs,a3hazs,
     &                    a1hzzs,a2hzzs,a3hzzs)

 	do 202 g1=1,2
 	do 202 g2=1,2
 	  f1 = 2*g1
 	  f2 = 2*g2

	  m2aqq0ss(f1,f2) = 0d0
	  if (f1.ne.f2) goto 202

        do 302 i2=-1,1,2
        do 302 i3=-1,1,2

          mats0  = msH4f(i2,i3)

 	  m2aqq0ss(f1,f2) = m2aqq0ss(f1,f2) 
     &	                    + fac*3d0*abs(mats0)**2 *qch2 

302	continue
202	continue


c Type: dbar-d -> l+l-
c---------------------

c*** generic amplitudes
        do i1=-1,1,2
        do i2=-1,1,2
          msH4f(i1,i2) = 0d0
        enddo
        enddo

c dbar-d -Z-> dbar-d  (k1->-p1,k2->-p2,k3->p4,k4->p3)
        if (qz.eq.1) call M_ZZ_hvv(msH4f,gdd,gll,qd,ql,q1,q2,q4,q3,
     &                    a1haas,a2haas,a3haas,a1hazs,a2hazs,a3hazs,
     &                    a1hzzs,a2hzzs,a3hzzs)


 	do 203 g1=1,2+qb
 	do 203 g2=1,2+qb
 	  f1 = 2*g1-1
 	  f2 = 2*g2-1

	  m2aqq0ss(f1,f2) = 0d0
	  if (f1.ne.f2) goto 203

        do 303 i2=-1,1,2
        do 303 i3=-1,1,2

          mats0  = msH4f(i2,i3)

	  m2aqq0ss(f1,f2) = m2aqq0ss(f1,f2) 
     &	                    + fac*3d0*abs(mats0)**2 *qch2 

303	continue
203	continue

	elseif (selprocess.eq.4) then

c Type: ubar u -> anti-nu_l nu_l
c------------------------------- 

c*** generic amplitudes
        do i1=-1,1,2
        do i2=-1,1,2
          msH4f(i1,i2) = 0d0
        enddo
        enddo

c ubar-u -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
        if (qz.eq.1) call M_ZZ_hvv(msH4f,guu,gnn,qu,qn,q1,q2,q4,q3,
     &                    a1haas,a2haas,a3haas,a1hazs,a2hazs,a3hazs,
     &                    a1hzzs,a2hzzs,a3hzzs)

 	do 207 g1=1,2
 	do 207 g2=1,2
 	  f1 = 2*g1
 	  f2 = 2*g2

	  m2aqq0ss(f1,f2) = 0d0
	  if (f1.ne.f2) goto 207

        do 307 i2=-1,1,2
        do 307 i3=-1,1,2

          mats0  = msH4f(i2,i3)

 	  m2aqq0ss(f1,f2) = m2aqq0ss(f1,f2) 
     &	                    + fac*3d0*abs(mats0)**2 *qch2 
307	continue
207	continue


c Type: dbar d -> anti-nu_l nu_l
c-------------------------------

c*** generic amplitudes
        do i1=-1,1,2
        do i2=-1,1,2
          msH4f(i1,i2) = 0d0
        enddo
        enddo

c dbar-d -Z-> dbar-d  (k1->-p1,k2->-p2,k3->p4,k4->p3)
        if (qz.eq.1) call M_ZZ_hvv(msH4f,gdd,gnn,qd,qn,q1,q2,q4,q3,
     &                    a1haas,a2haas,a3haas,a1hazs,a2hazs,a3hazs,
     &                    a1hzzs,a2hzzs,a3hzzs)

 	do 208 g1=1,2+qb
 	do 208 g2=1,2+qb
 	  f1 = 2*g1-1
 	  f2 = 2*g2-1

	  m2aqq0ss(f1,f2) = 0d0
	  if (f1.ne.f2) goto 208

        do 308 i2=-1,1,2
        do 308 i3=-1,1,2

          mats0  = msH4f(i2,i3)

	  m2aqq0ss(f1,f2) = m2aqq0ss(f1,f2) 
     &	                    + fac*3d0*abs(mats0)**2 *qch2 

308	continue
208	continue

	endif

	end

************************************************************************
        subroutine whzhMat2endp(p,m2i,m2if)
************************************************************************
*       Endpoint contribution for subtraction function for
*	    parton1(p1) + parton2(p2) --> f(p3) + f'(p4) + H(p5)
*-----------------------------------------------------------------------
*       13.10.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv,guu,gdd,gnn,gll
        real*8 p(6,0:3),qp(-4:4),mp2(-4:4),s(6,6)
        real*8 m2i0(-5:5,-5:5),m2i(-5:5,-5:5)
        real*8 m2if0(-5:5,-5:5,-5:5,-5:5),m2if(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_22(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_33(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_44(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_nd(-5:5,-5:5,-5:5,-5:5)
	integer i1,i2,i3,i4,j1,j2,i,j,k
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        common/qf/qu,qd,ql,qn,qf(4),mu,mu2,md,md2,mlep,mlep2,
     &            guu(-1:1),gdd(-1:1),gnn(-1:1),gll(-1:1)
        common/constsub/constff,constfi,constif,constii
        COMMON/IR/LAMBDA,LAMBDA2

        L(p2,mi2,mj2) =  (log(mi2/p2)+log(mj2/p2)+2d0)*log(lambda2/p2)
     &                  -log(mi2/p2)**2/2d0+log(mi2/p2)/2d0
     &                  -log(mj2/p2)**2/2d0+log(mj2/p2)/2d0

	qp(1) = qd
	qp(2) = qu
	qp(3) = qd
	qp(4) = qu
	mp2(1) = md2
	mp2(2) = mu2
	mp2(3) = md2
	mp2(4) = mu2
	do i=1,4
	  qp(-i)  = -qp(i)
	  mp2(-i) = mp2(i)
	enddo

	cii = 2d0*constii+1d0
	cff = 2d0*constff+1d0
	cfi = constif+constfi+1d0

	do 100 i=1,5
	do 100 j=1,5
	  s(i,j) = 2d0*( p(i,0)*p(j,0)-p(i,1)*p(j,1)
     &		        -p(i,2)*p(j,2)-p(i,3)*p(j,3) )
100	continue

c        call whzhMat2born(p,m2i0,m2if0,
c     &               m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)

        do 200 i1=-4,4
        do 200 i2=-4,4
          m2i(i1,i2) = 0d0
          if (i1*i2.eq.0) goto 200
        do 300 j1=1,4
        do 300 j2=1,4
	  i3 = sign(j1,i1)
	  i4 = sign(j2,i2)
	  if (nint(qp(i1)+qp(i2)-qp(i3)-qp(i4)).ne.0) goto 300
	  m2if(i1,i2,i3,i4) = 0d0
	  if (qbos.ne.0) m2if(i1,i2,i3,i4) = m2if(i1,i2,i3,i4)
     &	    -alpha/2d0/pi*m2if0(i1,i2,i3,i4)*(
     &	       qp(i1)*qp(i2)*(L(s(1,2),mp2(i1),mp2(i2))+cii)
     &	      +qp(i3)*qp(i4)*(L(s(3,4),mp2(i3),mp2(i4))+cff)
     &	      -qp(i1)*qp(i3)*(L(s(1,3),mp2(i1),mp2(i3))+cfi)
     &	      -qp(i2)*qp(i4)*(L(s(2,4),mp2(i2),mp2(i4))+cfi)
     &	      -qp(i1)*qp(i4)*(L(s(1,4),mp2(i1),mp2(i4))+cfi)
     &	      -qp(i2)*qp(i3)*(L(s(2,3),mp2(i2),mp2(i3))+cfi) )
	  if (qqcddiag.ne.0) m2if(i1,i2,i3,i4) = m2if(i1,i2,i3,i4)
     &	    -alphas*2d0/3d0/pi*(
     &	      + ( sign(1,i1*i2)*(L(s(1,2),mp2(i1),mp2(i2))+cii)
     &	         +sign(1,i3*i4)*(L(s(3,4),mp2(i3),mp2(i4))+cff) )
     &	        *m2if0_22(i1,i2,i3,i4)
     &	      - ( sign(1,i1*i3)*(L(s(1,3),mp2(i1),mp2(i3))+cfi)
     &	         +sign(1,i2*i4)*(L(s(2,4),mp2(i2),mp2(i4))+cfi) )
     &	        *m2if0_33(i1,i2,i3,i4) 				  
     &	      - ( sign(1,i1*i4)*(L(s(1,4),mp2(i1),mp2(i4))+cfi)
     &	         +sign(1,i2*i3)*(L(s(2,3),mp2(i2),mp2(i3))+cfi) )
     &	        *m2if0_44(i1,i2,i3,i4)	   			  )
	  if (qqcdnondiag.ne.0) m2if(i1,i2,i3,i4) = m2if(i1,i2,i3,i4)
     &      -alphas*2d0/3d0/pi*m2if0_nd(i1,i2,i3,i4)*(
     &         sign(1,i1*i2)*(L(s(1,2),mp2(i1),mp2(i2))+cii)
     &        +sign(1,i3*i4)*(L(s(3,4),mp2(i3),mp2(i4))+cff)
     &        -sign(1,i1*i3)*(L(s(1,3),mp2(i1),mp2(i3))+cfi)
     &        -sign(1,i2*i4)*(L(s(2,4),mp2(i2),mp2(i4))+cfi) 
     &        -sign(1,i1*i4)*(L(s(1,4),mp2(i1),mp2(i4))+cfi)
     &        -sign(1,i2*i3)*(L(s(2,3),mp2(i2),mp2(i3))+cfi) )
          m2i(i1,i2) = m2i(i1,i2) + m2if(i1,i2,i3,i4)
300     continue
200     continue

	end
