********************************************************************************
        function dcs(x,wgt)
********************************************************************************
*       Differential cross section
*-------------------------------------------------------------------------------
*       6.1.2006 Stefan Dittmaier
********************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
        real*8 x(10),p(6,0:3),pdf1(-6:6),pdf2(-6:6)
        real*8 m2i(-5:5,-5:5),m2i0(-5:5,-5:5)
        real*8 m2if(-5:5,-5:5,-5:5,-5:5),m2if0(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_22(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_33(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_44(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_nd(-5:5,-5:5,-5:5,-5:5)
        integer i1,i2
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/GEVFB/GEVFB
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/ppecms/ppecms
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	eps = 1d-10

        x5 = eps + (1d0-2d0*eps)*x(5)
        x6 = eps + (1d0-2d0*eps)*x(6)

        tau0  = (mh/ppecms)**2
        tau   = tau0**x5
        xp1   = tau**x6
        jacx  = tau*log(tau0)*log(tau)
c       tau   = tau0+x5*(1d0-tau0)
c       xp1   = tau+(1d0-tau)*x6
c       jacx  = (1d0-tau0)*(1d0-tau)/xp1

        tau   = tau0**x5
        xp1   = tau+(1d0-tau)*x6
        jacx  = -tau*log(tau0)*(1d0-tau)/xp1
        xp2   = tau/xp1
        ecms  = sqrt(tau)*ppecms

        call phsp3gen(ecms,p,x,jac)

cxxx
c pT cuts on jets
c	ptjetmin = 10d0
c	if ((e1*sth1.lt.ptjetmin).or.(e2*sth2.lt.ptjetmin)) then
c	  dcs = 0d0
c	  return
c	endif

        jac   = jac*4d0*pi*jacx

c squared matrix elements
	if (qborn.eq.-1) then
          call Mat2born(p,m2i,m2if,
     &		     m2if0_22,m2if0_33,m2if0_44,m2if0_nd,1)
	else
          call Mat2(p,m2i0,m2if0,m2i,m2if)
	endif

c PDFs
	mfact = mh
        call wpdf_sd(xp1,mfact,pdf1,pdf_phot1,1)
        call wpdf_sd(xp2,mfact,pdf2,pdf_phot2,1)

c weighted |M|^2
	wmat2 = 0d0
	do 100 i1=-4,4
	do 100 i2=-4,4
	  if (i1*i2.eq.0) goto 100
	  wmat2 = wmat2 + m2i(i1,i2)*pdf1(i1)*pdf2(i2) 
100	continue

        dcs = GEVFB/pi**4/256d0/ecms**2*jac*wmat2/36d0

	end

********************************************************************************
        subroutine phsp3gen(ecms,p,x,jac)
********************************************************************************
*       2->3 phase-space point in partonic CMS
*-------------------------------------------------------------------------------
*       6.1.2006 Stefan Dittmaier
********************************************************************************
        implicit real*8 (a-z)
        complex*16 eiph1,eiph2,eiph3
	complex*16 v,cv
        real*8 x(10),p(6,0:3)
        integer i1,i2

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)

	eps = 1d-10

        x1 = eps + (1d0-2d0*eps)*x(1)
        x2 = eps + (1d0-2d0*eps)*x(2)
        x3 = eps + (1d0-2d0*eps)*x(3)
        x4 = eps + (1d0-2d0*eps)*x(4)

        e3max = ecms/2d0+mh2/2d0/ecms
        e3    = mh+(e3max-mh)*x4
        jac3  = e3max-mh
        beta3 = sqrt(1d0-mh2/e3**2)
        e2min = (ecms-e3-e3*beta3)/2d0
        e2max = (ecms-e3+e3*beta3)/2d0
        e2    = e2min+(e2max-e2min)*x3
        jac2  = e2max-e2min
        e1    = ecms-e3-e2

        eiph3 = 1d0
        cth3  = 2d0*x1-1d0
        sth3  = sqrt(1d0-cth3**2)
        chi   = 2d0*pi*x2
        cchi  = cos(chi)
        schi  = sin(chi)
        cal   = (ecms*(ecms-2d0*(e3+e2))+2d0*e3*e2+mh2)
     &          /2d0/e3/e2/beta3
        sal   = sqrt(1d0-cal**2)
        cth2  = cal*cth3-cchi*sal*sth3
        sth2  = sqrt(1d0-cth2**2)
        eiph2 = ( cal*sth3+sal*(cchi*cth3+dcmplx(0d0,1d0)*schi) )/sth2
        cth1  = -(e3*beta3*cth3+e2*cth2)/e1
        sth1  = sqrt(1d0-cth1**2)
        eiph1 = -(e3*beta3*sth3+e2*eiph2*sth2)/e1/sth1

        jac   = jac2*jac3

c four-momenta
	p(1,0) = ecms/2d0
	p(1,1) = 0d0
	p(1,2) = 0d0
	p(1,3) = ecms/2d0
	p(2,0) = ecms/2d0
	p(2,1) = 0d0
	p(2,2) = 0d0
	p(2,3) =-ecms/2d0
	p(3,0) = e1
	p(3,1) = e1*sth1*dreal(eiph1)
	p(3,2) = e1*sth1*dimag(eiph1)
	p(3,3) = e1*cth1
	p(4,0) = e2
	p(4,1) = e2*sth2*dreal(eiph2)
	p(4,2) = e2*sth2*dimag(eiph2)
	p(4,3) = e2*cth2
	p(5,0) = e3
	p(5,1) = e3*beta3*sth3*dreal(eiph3)
	p(5,2) = e3*beta3*sth3*dimag(eiph3)
	p(5,3) = e3*beta3*cth3

	end

************************************************************************
        subroutine setFnull(F)
************************************************************************
*       13.11.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 F(13,-1:1,-1:1)
	integer i1,i2,j

	do 101 j=1,13
	do 101 i1=-1,1,2
	do 101 i2=-1,1,2
	  F(j,i1,i2) = 0d0
101	continue

	end

************************************************************************
        subroutine Mat2(p,m2i0,m2if0,m2i,m2if)
************************************************************************
*       squared amplitudes for 
*	    parton1(p1) + parton2(p2) --> f(p3) + f'(p4) + H(p5)
*
*	Born + QCD corrs + EW corrs (virtual + subtraction endpoint)
*
*	Note: anomalous HVV couplings optionally included (qhvv>0)
*	      for Born and diagonal QCD corrections only
*
*-----------------------------------------------------------------------
*       13.11.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
        real*8 p(6,0:3),m2aqq(5,5,5,5),m2qaq(5,5,5,5)
        real*8 m2qq(5,5,5,5),m2aqaq(5,5,5,5)
        real*8 m2aqq0(5,5,5,5),m2qaq0(5,5,5,5)
        real*8 m2qq0(5,5,5,5),m2aqaq0(5,5,5,5)
        real*8 m2i(-5:5,-5:5),m2i0(-5:5,-5:5)
        real*8 m2if(-5:5,-5:5,-5:5,-5:5),m2if0(-5:5,-5:5,-5:5,-5:5)
	integer i1,i2,i3,i4
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

c moved to crosssection 6.03.07 AD
c Cache for loop integrals
c        call fastinit(6)

c calculate kinematical invariants
	call setprods3(p)

c*** initializations
	do 100 i1=1,4
	do 100 i2=1,4
	do 100 i3=1,4
	do 100 i4=1,4
	  m2aqq0(i1,i2,i3,i4)  = 0d0
	  m2qaq0(i1,i2,i3,i4)  = 0d0
	  m2qq0(i1,i2,i3,i4)   = 0d0
	  m2aqaq0(i1,i2,i3,i4) = 0d0
	  m2aqq(i1,i2,i3,i4)   = 0d0
	  m2qaq(i1,i2,i3,i4)   = 0d0
	  m2qq(i1,i2,i3,i4)    = 0d0
	  m2aqaq(i1,i2,i3,i4)  = 0d0
100	continue

c qbar-q --> qbar-q
	call Mat2aqq(m2aqq,m2aqq0,-1,-2,4,3)

c q-q    --> q-q
	call Mat2aqq(m2qq,m2qq0,3,-2,4,-1)

c q-qbar --> q-qbar
	call Mat2aqq(m2qaq,m2qaq0,-2,-1,3,4)

c qbar-qbar --> qbar-qbar
	call Mat2aqq(m2aqaq,m2aqaq0,-1,4,-2,3)

c add final states for fixed initial states
        do 200 i1=-4,4
        do 200 i2=-4,4
          m2i(i1,i2) = 0d0
          m2i0(i1,i2) = 0d0
          if (i1*i2.eq.0) goto 200
        do 300 i3=1,4
        do 300 i4=1,4
          if ((i1.lt.0).and.(i2.gt.0)) then
            m2if0(i1,i2,-i3,i4) = m2aqq0(-i1,i2,i3,i4)
            m2if(i1,i2,-i3,i4)   = m2aqq(-i1,i2,i3,i4)
            m2i0(i1,i2) = m2i0(i1,i2) + m2if0(i1,i2,-i3,i4)
            m2i(i1,i2)   = m2i(i1,i2)   + m2if(i1,i2,-i3,i4)
	  endif
          if ((i1.gt.0).and.(i2.lt.0)) then
            m2if0(i1,i2,i3,-i4) = m2qaq0(-i2,i1,i4,i3)
            m2if(i1,i2,i3,-i4)   = m2qaq(-i2,i1,i4,i3)
            m2i0(i1,i2) = m2i0(i1,i2) + m2if0(i1,i2,i3,-i4)
            m2i(i1,i2)   = m2i(i1,i2)   + m2if(i1,i2,i3,-i4)
	  endif
          if ((i1.gt.0).and.(i2.gt.0)) then
            m2if0(i1,i2,i3,i4) = m2qq0(i3,i2,i1,i4)/2d0
            m2if(i1,i2,i3,i4)   = m2qq(i3,i2,i1,i4)/2d0
            m2i0(i1,i2) = m2i0(i1,i2) + m2if0(i1,i2,i3,i4)
            m2i(i1,i2)   = m2i(i1,i2)   + m2if(i1,i2,i3,i4)
	  endif
          if ((i1.lt.0).and.(i2.lt.0)) then
            m2if0(i1,i2,-i3,-i4) = m2aqaq0(-i1,i4,i3,-i2)/2d0
            m2if(i1,i2,-i3,-i4)   = m2aqaq(-i1,i4,i3,-i2)/2d0
            m2i0(i1,i2) = m2i0(i1,i2) + m2if0(i1,i2,-i3,-i4)
            m2i(i1,i2)   = m2i(i1,i2)   + m2if(i1,i2,-i3,-i4)
	  endif
300     continue
	if ((m2i0(i1,i2).ne.0d0).and.
     &	    (abs(m2i(i1,i2)/m2i0(i1,i2)).gt.1d3)) then
	  m2i0(i1,i2) = 0d0
	  m2i(i1,i2)  = 0d0
	endif
200     continue

	end

************************************************************************
        subroutine Mat2aqq(m2aqq,m2aqq0,l1,l2,l4,l3)
************************************************************************
*       squared amplitudes for 
*	    anti-q(p1) + q(p2) --> f(p3) + f'(p4) + H(p5)
*
*       from generic amplitudes for
*	    H(p) --> fa(k1) + anti-fb(k2) + fc(k3) + anti-fd(k4)
*	         CC: f1     + anti-f2     + f3     + anti-f4     
*	         NC: f1     + anti-f1     + f3     + anti-f3     
*	             f2     + anti-f2     + f3     + anti-f3     
*	             f1     + anti-f1     + f4     + anti-f4     
*
*	fermions: f1,f4 = generic   up-type fermions
*	          f2,f3 = generic down-type fermions
*-----------------------------------------------------------------------
*       13.11.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 Fs0(13,-1:1,-1:1),Ft0(13,-1:1,-1:1)
	complex*16 Fs1(13,-1:1,-1:1),Ft1(13,-1:1,-1:1)
	complex*16 Fsgd(13,-1:1,-1:1),Ftgd(13,-1:1,-1:1)
	complex*16 Fsgnd(13,-1:1,-1:1),Ftgnd(13,-1:1,-1:1)
	complex*16 Fshvv0(13,-1:1,-1:1),Fthvv0(13,-1:1,-1:1)
	complex*16 Fshvv1(13,-1:1,-1:1),Fthvv1(13,-1:1,-1:1)
	complex*16 mats0,matt0,wmats0,wmatt0
	complex*16 mats1,matt1,wmats1,wmatt1
	complex*16 matsgd,mattgd,wmatsgd,wmattgd
	complex*16 matsgnd,mattgnd,wmatsgnd,wmattgnd
	complex*16 matshvv0,matthvv0,wmatshvv0,wmatthvv0
	complex*16 matshvv1,matthvv1,wmatshvv1,wmatthvv1
	complex*16 v,cv
	complex*16 m1243(13,-1:1,-1:1),m4213(13,-1:1,-1:1)
	complex*16 m4312(13,-1:1,-1:1),m1342(13,-1:1,-1:1)
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
	complex*16 guu,gdd,gnn,gll     
	complex*16 sp(-4:4,-4:4),csp(-4:4,-4:4)
        real*8 p(6,0:3),m2aqq(5,5,5,5),m2aqq0(5,5,5,5),vp(-4:4,-4:4)
	integer l1,l2,l3,l4
	integer i1,i2,i3,i4,j,j1,j2,f1,f2,f3,f4,g1,g2,g3,g4
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        integer qhvv
	logical checkss12,checkt11t22

	common/prods3/sp,csp,vp
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/qf/qu,qd,ql,qn,qf(4),mu,mu2,md,md2,mlep,mlep2,
     &            guu(-1:1),gdd(-1:1),gnn(-1:1),gll(-1:1)
        common/hh2/chh2
        common/hvv/rsm,d,db,dt,dtb,lambdahvv,
     &             a1hww,a2hww,a3hww,a1haa,a2haa,a3haa,
     &             a1haz,a2haz,a3haz,a1hzz,a2hzz,a3hzz,qhvv

	el6 = el**6

c invariants
        s   = vp(l1,l2)
	s12 = vp(l3,l4)
	t11 = vp(l1,l3)
	t21 = vp(l2,l3)
	t12 = vp(l1,l4)
	t22 = vp(l2,l4)
	s23 = t11+t21+s
	s13 = t12+t22+s
	t13 = t21+t22+s12
	t23 = t11+t12+s12

	checkss12   = ((  s*qschan.gt.0d0).or.(  s*qtchan.lt.0d0)).and.
     &	              ((s12*qschan.gt.0d0).or.(s12*qtchan.lt.0d0))
	checkt11t22 = ((t11*qschan.gt.0d0).or.(t11*qtchan.lt.0d0)).and.
     &	              ((t22*qschan.gt.0d0).or.(t22*qtchan.lt.0d0))

c 2-loop heavy-Higgs factors
	if ((s*qtchan.lt.0d0).and.(s12*qtchan.lt.0d0)) then
	  chh2s = qch2*qhh2*chh2
	else
	  chh2s = 0d0
	endif
	if ((t11*qtchan.lt.0d0).and.(t22*qtchan.lt.0d0)) then
	  chh2t = qch2*qhh2*chh2
	else
	  chh2t = 0d0
	endif

c standard matrix elements
c qbar q -> qbar q
        call calcsmeH4f(m1243,l1,l2,l4,l3)
        call calcsmeH4f(m4312,l4,l3,l1,l2)
        call calcsmeH4f(m1342,l1,l3,l4,l2)
        call calcsmeH4f(m4213,l4,l2,l1,l3)

c qbar-q scattering
c
c   s-channel:                             t-channel:
c
c   fa(p1) \_          / fd(p3)            fa(p1) --<--*--<-- fb(p3)
c          |\        |/                                >
c            \       /-                                >
c             *vvvvv*                                  >
c           _/       \                                 >
c           /|        \|                               >
c   fb(p2) /          -\ fc(p4)            fd(p2) -->--*-->-- fc(p4)


c Type: ubar-d -> ubar-d
c-----------------------

c*** generic amplitudes
	call setFnull(Fs0)
	call setFnull(Ft0)
	call setFnull(Fs1)
	call setFnull(Ft1)
	call setFnull(Fsgd)
	call setFnull(Ftgd)
	call setFnull(Fsgnd)
	call setFnull(Ftgnd)
	call setFnull(Fshvv0)
	call setFnull(Fshvv1)
	call setFnull(Fthvv0)
	call setFnull(Fthvv1)

c ubar-d -W-> cbar-s    (k1->-p1,k2->-p2,k3->p4,k4->p3)   
	if ((qw.eq.1).and.checkss12) 
     &	  call calcform_HWW4f(Fs0,Fs1,Fsgd,Fsgnd,Fshvv0,Fshvv1,
     &			      s,t12,t11,t22,t21,s12,t13,t23,s23,s13)

c ubar-s -Z-> ubar-s    (k1->-p1,k2->p3,k3->p4,k4->-p2)   
	if ((qz.eq.1).and.checkt11t22) 
     &	  call calcform_HZZ1133(Ft0,Ft1,Ftgd,Ftgnd,Fthvv0,Fthvv1,
     &			        t11,t12,s,s12,t21,t22,t13,s13,s23,t23)

c*** individual channels
	do 200 i1=-1,1,2
	do 200 i2=-1,1,2
	do 200 i4=-1,1,2
	  mats0   = 0d0
	  matt0   = 0d0
	  mats1   = 0d0
	  matt1   = 0d0
	  matsgd  = 0d0
	  mattgd  = 0d0
	  matsgnd = 0d0
	  mattgnd = 0d0
	  matshvv0 = 0d0
	  matthvv0 = 0d0
	  matshvv1 = 0d0
	  matthvv1 = 0d0
	  if (i1.eq.-i2) then
      	    mats0  = mats0 + m1243(1,i2,i4)*Fs0(1,i2,i4)
      	    if (qhvv.eq.0) then
      	      matsgd = matsgd + m1243(1,i2,i4)*Fsgd(1,i2,i4)
	    else
	      do j=1,13
                matshvv0  = matshvv0 + m1243(j,i2,i4)*Fshvv0(j,i2,i4)
                matshvv1  = matshvv1 + m1243(j,i2,i4)*Fshvv1(j,i2,i4)
	      enddo
	    endif
	    do j=1,13
      	      mats1 = mats1 + m1243(j,i2,i4)*Fs1(j,i2,i4)
      	      matsgnd = matsgnd + m1243(j,i2,i4)*Fsgnd(j,i2,i4)
	    enddo
	  endif
	  if (i2.eq.i4) then
      	    matt0  = matt0 + m1342(1,-i1,i2)*Ft0(1,-i1,i2)
      	    if (qhvv.eq.0) then
      	      mattgd = mattgd + m1342(1,-i1,i2)*Ftgd(1,-i1,i2)
	    else
	      do j=1,13
      	        matthvv0  = matthvv0 + m1342(j,-i1,i2)*Fthvv0(j,-i1,i2)
      	        matthvv1  = matthvv1 + m1342(j,-i1,i2)*Fthvv1(j,-i1,i2)
	      enddo
	    endif
	    do j=1,13
      	      matt1 = matt1 + m1342(j,-i1,i2)*Ft1(j,-i1,i2)
      	      mattgnd = mattgnd + m1342(j,-i1,i2)*Ftgnd(j,-i1,i2)
	    enddo
	  endif

 	do 200 g1=1,2
 	do 200 g2=1,2
 	do 200 g3=1,2
 	do 200 g4=1,2
 	  wmats0   = cv(g1,g2)*v(g3,g4)*mats0
 	  wmats1   = cv(g1,g2)*v(g3,g4)*mats1
      	  if (qhvv.eq.0) then
 	    wmatsgd   = cv(g1,g2)*v(g3,g4)*matsgd
	  else
 	    wmatshvv0 = cv(g1,g2)*v(g3,g4)*matshvv0
 	    wmatshvv1 = cv(g1,g2)*v(g3,g4)*matshvv1
	  endif
 	  wmatsgnd = cv(g1,g2)*v(g3,g4)*matsgnd
 	  f1 = 2*g1
 	  f2 = 2*g2-1
 	  f3 = 2*g3
 	  f4 = 2*g4-1
 	  if ((f1.eq.f3).and.(f2.eq.f4)) then
      	    if (qhvv.eq.0) then
 	      m2aqq0(f1,f2,f3,f4) = m2aqq0(f1,f2,f3,f4) + el6*(
     &		         +qch2*9d0*(abs(wmats0)**2+abs(matt0)**2) 
     &	                 -qchint*3d0*2d0*dreal(wmats0*dconjg(matt0)) ) 
 	      m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ qborn*( qch2*9d0*(abs(wmats0)**2+abs(matt0)**2) 
     &	                 -qchint*3d0*2d0*dreal(wmats0*dconjg(matt0)) ) 
     &		+ 2d0*dreal( +qch2*9d0*( wmatsgd*dconjg(wmats0)
     &		                         +mattgd *dconjg(matt0) ) ) )
	     else
 	      m2aqq0(f1,f2,f3,f4) = m2aqq0(f1,f2,f3,f4) + el6*(
     &		   +qch2*9d0*(abs(wmatshvv0)**2+abs(matthvv0)**2) 
     &	           -qchint*3d0*2d0*dreal(wmatshvv0*dconjg(matthvv0)) ) 
 	      m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ qborn*( qch2*9d0*(abs(wmatshvv0)**2+abs(matthvv0)**2) 
     &	             -qchint*3d0*2d0*dreal(wmatshvv0*dconjg(matthvv0)) ) 
     &		+ 2d0*dreal( qch2*9d0*( wmatshvv1*dconjg(wmatshvv0)
     &		                        +matthvv1 *dconjg(matthvv0) )) )
	    endif
 	    m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ 2d0*dreal( qch2  *9d0*( wmats1 *dconjg(wmats0)
     &		                         +matt1  *dconjg(matt0)  )
     &	                    -qchint*3d0*( wmats1 *dconjg(matt0)
     &			                 +wmats0 *dconjg(matt1)  ) 
     &	                    -qchint*3d0*( wmatsgnd *dconjg(matt0)
     &			                 +wmats0 *dconjg(mattgnd)) )  
     &		+ 9d0*(chh2s*abs(wmats0)**2+chh2t*abs(matt0)**2) )
 	  else
      	    if (qhvv.eq.0) then
 	      m2aqq0(f1,f2,f3,f4) = m2aqq0(f1,f2,f3,f4) + el6*(
     &		+ qch2*9d0*abs(wmats0)**2 ) 
 	      m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ qborn*( qch2*9d0*abs(wmats0)**2 ) 
     &		+ 2d0*dreal( qch2*9d0*( wmatsgd*dconjg(wmats0) ) ) )
	    else
 	      m2aqq0(f1,f2,f3,f4) = m2aqq0(f1,f2,f3,f4) + el6*(
     &		+ qch2*9d0*abs(wmatshvv0)**2 ) 
 	      m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ qborn*( qch2*9d0*abs(wmatshvv0)**2 ) 
     &		+ 2d0*dreal( qch2*9d0*( wmatshvv1*dconjg(wmatshvv0) ) ) )
	    endif
 	    m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ 2d0*dreal( qch2*9d0*( wmats1 *dconjg(wmats0) ) )
     &		+ 9d0*(chh2s*abs(wmats0)**2 ) )
 	  endif
200	continue


c Type: dbar-u -> dbar-u
c-----------------------

c*** generic amplitudes
	call setFnull(Fs0)
	call setFnull(Ft0)
	call setFnull(Fs1)
	call setFnull(Ft1)
	call setFnull(Fsgd)
	call setFnull(Ftgd)
	call setFnull(Fsgnd)
	call setFnull(Ftgnd)
	call setFnull(Fshvv0)
	call setFnull(Fshvv1)
	call setFnull(Fthvv0)
	call setFnull(Fthvv1)

c dbar-u -W-> sbar-c    (k3->-p1,k4->-p2,k1->p4,k2->p3)   
	if ((qw.eq.1).and.checkss12) 
     &	  call calcform_HWW4f(Fs0,Fs1,Fsgd,Fsgnd,Fshvv0,Fshvv1,
     &		              s12,t12,t22,t11,t21,s,s23,s13,t13,t23)

c dbar-c -Z-> dbar-c    (k3->-p1,k4->p3,k1->p4,k2->-p2)   
	if ((qz.eq.1).and.checkt11t22) 
     &	  call calcform_HZZ1133(Ft0,Ft1,Ftgd,Ftgnd,Fthvv0,Fthvv1,
     &			        t22,t12,s12,s,t21,t11,s23,t23,t13,s13)

	do 205 i1=-1,1,2
	do 205 i2=-1,1,2
	do 205 i4=-1,1,2
	  mats0   = 0d0
	  matt0   = 0d0
	  mats1   = 0d0
	  matt1   = 0d0
	  matsgd  = 0d0
	  mattgd  = 0d0
	  matsgnd = 0d0
	  mattgnd = 0d0
	  matshvv0 = 0d0
	  matthvv0 = 0d0
	  matshvv1 = 0d0
	  matthvv1 = 0d0
	  if (i1.eq.-i2) then
      	    mats0 = mats0 + m4312(1,i4,i2)*Fs0(1,i4,i2)
            if (qhvv.eq.0) then
      	      matsgd = matsgd + m4312(1,i4,i2)*Fsgd(1,i4,i2)
            else
              do j=1,13
      	        matshvv0 = matshvv0 + m4312(j,i4,i2)*Fshvv0(j,i4,i2)
      	        matshvv1 = matshvv1 + m4312(j,i4,i2)*Fshvv1(j,i4,i2)
              enddo
            endif
	    do j=1,13
      	      mats1 = mats1 + m4312(j,i4,i2)*Fs1(j,i4,i2)
      	      matsgnd = matsgnd + m4312(j,i4,i2)*Fsgnd(j,i4,i2)
	    enddo
	  endif
	  if (i2.eq.i4) then
      	    matt0 = matt0 + m4213(1,i4,-i1)*Ft0(1,i4,-i1)
            if (qhvv.eq.0) then
      	      mattgd = mattgd + m4213(1,i4,-i1)*Ftgd(1,i4,-i1)
            else
              do j=1,13
      	        matthvv0 = matthvv0 + m4213(j,i4,-i1)*Fthvv0(j,i4,-i1)
      	        matthvv1 = matthvv1 + m4213(j,i4,-i1)*Fthvv1(j,i4,-i1)
              enddo
            endif
	    do j=1,13
      	      matt1 = matt1 + m4213(j,i4,-i1)*Ft1(j,i4,-i1)
      	      mattgnd = mattgnd + m4213(j,i4,-i1)*Ftgnd(j,i4,-i1)
	    enddo
	  endif

 	do 205 g1=1,2
 	do 205 g2=1,2
 	do 205 g3=1,2
 	do 205 g4=1,2
 	  wmats0 = v(g2,g1)*cv(g4,g3)*mats0
 	  wmats1 = v(g2,g1)*cv(g4,g3)*mats1
          if (qhvv.eq.0) then
 	    wmatsgd   = v(g2,g1)*cv(g4,g3)*matsgd
	  else
 	    wmatshvv0 = v(g2,g1)*cv(g4,g3)*matshvv0
 	    wmatshvv1 = v(g2,g1)*cv(g4,g3)*matshvv1
	  endif
 	  wmatsgnd = v(g2,g1)*cv(g4,g3)*matsgnd
 	  f1 = 2*g1-1
 	  f2 = 2*g2
 	  f3 = 2*g3-1
 	  f4 = 2*g4
 	  if ((f1.eq.f3).and.(f2.eq.f4)) then
            if (qhvv.eq.0) then
 	      m2aqq0(f1,f2,f3,f4) = m2aqq0(f1,f2,f3,f4) + el6*(
     &		         +qch2*9d0*(abs(wmats0)**2+abs(matt0)**2) 
     &	                 -qchint*3d0*2d0*dreal(wmats0*dconjg(matt0)) ) 
 	      m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ qborn*( qch2*9d0*(abs(wmats0)**2+abs(matt0)**2) 
     &	                 -qchint*3d0*2d0*dreal(wmats0*dconjg(matt0)) ) 
     &		+ 2d0*dreal( qch2  *9d0*( wmatsgd*dconjg(wmats0)
     &		                         +mattgd *dconjg(matt0)  ) )
     &		+ 9d0*(chh2s*abs(wmats0)**2+chh2t*abs(matt0)**2) )
	    else
 	      m2aqq0(f1,f2,f3,f4) = m2aqq0(f1,f2,f3,f4) + el6*(
     &		     +qch2*9d0*(abs(wmatshvv0)**2+abs(matthvv0)**2) 
     &	             -qchint*3d0*2d0*dreal(wmatshvv0*dconjg(matthvv0)) ) 
 	      m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ qborn*( qch2*9d0*(abs(wmatshvv0)**2+abs(matthvv0)**2) 
     &	             -qchint*3d0*2d0*dreal(wmatshvv0*dconjg(matthvv0)) ) 
     &		+ 2d0*dreal( qch2*9d0*( wmatshvv1*dconjg(wmatshvv0)
     &		                       +matthvv1 *dconjg(matthvv0) ) ))
	    endif
 	    m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ 2d0*dreal( qch2  *9d0*( wmats1 *dconjg(wmats0)
     &		                         +matt1  *dconjg(matt0)  )
     &	                    -qchint*3d0*( wmats1 *dconjg(matt0)
     &			                 +wmats0 *dconjg(matt1)  ) 
     &	                    -qchint*3d0*( wmatsgnd *dconjg(matt0)
     &			                 +wmats0 *dconjg(mattgnd)) )  
     &		+ 9d0*(chh2s*abs(wmats0)**2+chh2t*abs(matt0)**2) )
 	  else
            if (qhvv.eq.0) then
 	      m2aqq0(f1,f2,f3,f4) = m2aqq0(f1,f2,f3,f4) + el6*(
     &		+ 9d0*abs(wmats0)**2 ) 
 	      m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ qborn*( qch2*9d0*abs(wmats0)**2 ) 
     &		+ 2d0*dreal( +qch2*9d0*( wmatsgd*dconjg(wmats0) )) )
	    else
 	      m2aqq0(f1,f2,f3,f4) = m2aqq0(f1,f2,f3,f4) + el6*(
     &		+ 9d0*abs(wmatshvv0)**2 ) 
 	      m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ qborn*( qch2*9d0*abs(wmatshvv0)**2 ) 
     &		+ 2d0*dreal( +qch2*9d0*( wmatshvv1*dconjg(wmatshvv0) )) )
	    endif
 	    m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ 2d0*dreal( qch2*9d0*( wmats1 *dconjg(wmats0) ) )
     &		+ 9d0*(chh2s*abs(wmats0)**2) )
 	  endif
205	continue


c Type: ubar-u -> ubar-u
c----------------------- 

c*** generic amplitudes
	call setFnull(Fs0)
	call setFnull(Ft0)
	call setFnull(Fs1)
	call setFnull(Ft1)
	call setFnull(Fsgd)
	call setFnull(Ftgd)
	call setFnull(Fsgnd)
	call setFnull(Ftgnd)
	call setFnull(Fshvv0)
	call setFnull(Fshvv1)
	call setFnull(Fthvv0)
	call setFnull(Fthvv1)

	if (qz.eq.1) then

c ubar-u -Z-> cbar-c  (k1->-p1,k2->-p2,k3->p4,k4->p3)
	  if (checkss12) call calcform_HZZ1144(Fs0,Fs1,Fsgd,Fsgnd,
     &		Fshvv0,Fshvv1,s,t12,t11,t22,t21,s12,t13,t23,s23,s13)

c ubar-c -Z-> ubar-c  (k1->-p1,k2->p3,k3->p4,k4->-p2)
	  if (checkt11t22) call calcform_HZZ1144(Ft0,Ft1,Ftgd,Ftgnd,
     &		Fthvv0,Fthvv1,t11,t12,s,s12,t21,t22,t13,s13,s23,t23)

	  do 201 i1=-1,1,2
	  do 201 i2=-1,1,2
	  do 201 i4=-1,1,2
	    mats0   = 0d0
	    matt0   = 0d0
	    mats1   = 0d0
	    matt1   = 0d0
	    matsgd  = 0d0
	    mattgd  = 0d0
	    matsgnd = 0d0
	    mattgnd = 0d0
	    matshvv0 = 0d0
	    matthvv0 = 0d0
	    matshvv1 = 0d0
	    matthvv1 = 0d0
	    if (i1.eq.-i2) then
      	      mats0 = mats0 + m1243(1,i2,i4)*Fs0(1,i2,i4)
              if (qhvv.eq.0) then
      	        matsgd = matsgd + m1243(1,i2,i4)*Fsgd(1,i2,i4)
              else
                do j=1,13
      	          matshvv0 = matshvv0 + m1243(j,i2,i4)*Fshvv0(j,i2,i4)
      	          matshvv1 = matshvv1 + m1243(j,i2,i4)*Fshvv1(j,i2,i4)
                enddo
              endif
	      do j=1,13
      		mats1 = mats1 + m1243(j,i2,i4)*Fs1(j,i2,i4)
      		matsgnd = matsgnd + m1243(j,i2,i4)*Fsgnd(j,i2,i4)
	      enddo
	    endif
	    if (i2.eq.i4) then
      	      matt0 = matt0 + m1342(1,-i1,i2)*Ft0(1,-i1,i2)
              if (qhvv.eq.0) then
      	        mattgd = mattgd + m1342(1,-i1,i2)*Ftgd(1,-i1,i2)
              else
                do j=1,13
      	          matthvv0 = matthvv0 + m1342(j,-i1,i2)*Fthvv0(j,-i1,i2)
      	          matthvv1 = matthvv1 + m1342(j,-i1,i2)*Fthvv1(j,-i1,i2)
                enddo
              endif
	      do j=1,13
      		matt1 = matt1 + m1342(j,-i1,i2)*Ft1(j,-i1,i2)
      		mattgnd = mattgnd + m1342(j,-i1,i2)*Ftgnd(j,-i1,i2)
	      enddo
	    endif
c*** ubar-u -ZZ-> ubar-u    
            if (qhvv.eq.0) then
	      m2aqq0(2,2,2,2) = m2aqq0(2,2,2,2) + el6*(
     &		         +qch2*9d0*(abs(mats0)**2+abs(matt0)**2) 
     &	                 -qchint*3d0*2d0*dreal(mats0*dconjg(matt0))  ) 
	      m2aqq(2,2,2,2) = m2aqq(2,2,2,2) + el6*(
     &		+ qborn*( qch2*9d0*(abs(mats0)**2+abs(matt0)**2) 
     &	                 -qchint*3d0*2d0*dreal(mats0*dconjg(matt0))  ) 
     &		+ 2d0*dreal(+qch2  *9d0*( matsgd*dconjg(mats0)
     &		                         +mattgd*dconjg(matt0) ) ) )
	    else
	      m2aqq0(2,2,2,2) = m2aqq0(2,2,2,2) + el6*(
     &		      +qch2*9d0*(abs(matshvv0)**2+abs(matthvv0)**2) 
     &	              -qchint*3d0*2d0*dreal(matshvv0*dconjg(matthvv0)) ) 
	      m2aqq(2,2,2,2) = m2aqq(2,2,2,2) + el6*(
     &		+ qborn*( qch2*9d0*(abs(matshvv0)**2+abs(matthvv0)**2) 
     &	              -qchint*3d0*2d0*dreal(matshvv0*dconjg(matthvv0)) ) 
     &		+ 2d0*dreal(+qch2  *9d0*( matshvv1*dconjg(matshvv0)
     &		                         +matthvv1*dconjg(matthvv0) )))
	    endif
	    m2aqq(2,2,2,2) = m2aqq(2,2,2,2) + el6*(
     &		+ 2d0*dreal( qch2  *9d0*( mats1 *dconjg(mats0)
     &		                         +matt1 *dconjg(matt0) )
     &	                    -qchint*3d0*( mats1 *dconjg(matt0)
     &			                 +mats0 *dconjg(matt1)  ) 
     &	                    -qchint*3d0*( matsgnd *dconjg(matt0)
     &			                 +mats0 *dconjg(mattgnd)) )  
     &		+ 9d0*(chh2s*abs(mats0)**2+chh2t*abs(matt0)**2) )
c*** ubar-u -Z-> cbar-c 
            if (qhvv.eq.0) then
	      m2aqq0(2,2,4,4) = m2aqq0(2,2,4,4) + el6*(
     &		+ qch2*9d0*abs(mats0)**2 )
	      m2aqq(2,2,4,4) = m2aqq(2,2,4,4) + el6*(
     &		+ qch2*9d0*qborn*abs(mats0)**2 
     &		+ qch2*2d0*dreal(+9d0*( matsgd*dconjg(mats0) )) ) 
	    else
	      m2aqq0(2,2,4,4) = m2aqq0(2,2,4,4) + el6*(
     &		+ qch2*9d0*abs(matshvv0)**2 )
	      m2aqq(2,2,4,4) = m2aqq(2,2,4,4) + el6*(
     &		+ qch2*9d0*qborn*abs(matshvv0)**2 
     &		+ qch2*2d0*dreal(+9d0*( matshvv1*dconjg(matshvv0) )) ) 
	    endif
	    m2aqq(2,2,4,4) = m2aqq(2,2,4,4) + el6*(
     &		+ qch2*2d0*dreal( 9d0*( mats1 *dconjg(mats0) )
     &		+ 9d0*(chh2s*abs(mats0)**2) ) )
c*** ubar-c -Z-> ubar-c 
            if (qhvv.eq.0) then
	      m2aqq0(2,4,2,4) = m2aqq0(2,4,2,4) + el6*(
     &		+ qch2*9d0*abs(matt0)**2 )
	      m2aqq(2,4,2,4) = m2aqq(2,4,2,4) + el6*(
     &		+ qch2*9d0*qborn*abs(matt0)**2 
     &		+ qch2*2d0*dreal(+9d0*( mattgd*dconjg(matt0) ) ) ) 
	    else
	      m2aqq0(2,4,2,4) = m2aqq0(2,4,2,4) + el6*(
     &		+ qch2*9d0*abs(matthvv0)**2 )
	      m2aqq(2,4,2,4) = m2aqq(2,4,2,4) + el6*(
     &		+ qch2*9d0*qborn*abs(matthvv0)**2 
     &		+ qch2*2d0*dreal(+9d0*( matthvv1*dconjg(matthvv0) ) ) ) 
	    endif
	    m2aqq(2,4,2,4) = m2aqq(2,4,2,4) + el6*(
     &		+ qch2*2d0*dreal( 9d0*( matt1 *dconjg(matt0) ) )
     &		+ 9d0*(chh2t*abs(matt0)**2) )
201	  continue
	  m2aqq0(4,4,4,4) = m2aqq0(2,2,2,2) 
	  m2aqq0(4,4,2,2) = m2aqq0(2,2,4,4)
	  m2aqq0(4,2,4,2) = m2aqq0(2,4,2,4)
	  m2aqq(4,4,4,4)  = m2aqq(2,2,2,2) 
	  m2aqq(4,4,2,2)  = m2aqq(2,2,4,4)
	  m2aqq(4,2,4,2)  = m2aqq(2,4,2,4)
	endif


c Type: ubar-u -> dbar-d
c----------------------- 

c*** generic amplitudes
	call setFnull(Fs0)
	call setFnull(Ft0)
	call setFnull(Fs1)
	call setFnull(Ft1)
	call setFnull(Fsgd)
	call setFnull(Ftgd)
	call setFnull(Fsgnd)
	call setFnull(Ftgnd)
	call setFnull(Fshvv0)
	call setFnull(Fshvv1)
	call setFnull(Fthvv0)
	call setFnull(Fthvv1)

c ubar-u -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
	if ((qz.eq.1).and.checkss12)
     &	  call calcform_HZZ1133(Fs0,Fs1,Fsgd,Fsgnd,Fshvv0,Fshvv1,
     &			        s,t12,t11,t22,t21,s12,t13,t23,s23,s13)

c ubar-u -W-> dbar-d  (k1->-p1,k2->p3,k3->p4,k4->-p2)
	if ((qw.eq.1).and.checkt11t22) 
     &	  call calcform_HWW4f(Ft0,Ft1,Ftgd,Ftgnd,Fthvv0,Fthvv1,
     &			      t11,t12,s,s12,t21,t22,t13,s13,s23,t23)
	  do 202 i1=-1,1,2
	  do 202 i2=-1,1,2
	  do 202 i4=-1,1,2
	    mats0   = 0d0
	    matt0   = 0d0
	    mats1   = 0d0
	    matt1   = 0d0
	    matsgd  = 0d0
	    mattgd  = 0d0
	    matsgnd = 0d0
	    mattgnd = 0d0
	    matshvv0 = 0d0
	    matthvv0 = 0d0
	    matshvv1 = 0d0
	    matthvv1 = 0d0
	    if (i1.eq.-i2) then
      	      mats0 = mats0 + m1243(1,i2,i4)*Fs0(1,i2,i4)
              if (qhvv.eq.0) then
      	        matsgd = matsgd + m1243(1,i2,i4)*Fsgd(1,i2,i4)
              else
                do j=1,13
      	          matshvv0 = matshvv0 + m1243(j,i2,i4)*Fshvv0(j,i2,i4)
      	          matshvv1 = matshvv1 + m1243(j,i2,i4)*Fshvv1(j,i2,i4)
                enddo
              endif
	      do j=1,13
      		mats1 = mats1 + m1243(j,i2,i4)*Fs1(j,i2,i4)
      		matsgnd = matsgnd + m1243(j,i2,i4)*Fsgnd(j,i2,i4)
	      enddo
	    endif
	    if (i2.eq.i4) then
      	      matt0 = matt0 + m1342(1,-i1,i2)*Ft0(1,-i1,i2)
              if (qhvv.eq.0) then
      	        mattgd = mattgd + m1342(1,-i1,i2)*Ftgd(1,-i1,i2)
              else
                do j=1,13
      	          matthvv0 = matthvv0 + m1342(j,-i1,i2)*Fthvv0(j,-i1,i2)
      	          matthvv1 = matthvv1 + m1342(j,-i1,i2)*Fthvv1(j,-i1,i2)
                enddo
              endif
	      do j=1,13
      		matt1 = matt1 + m1342(j,-i1,i2)*Ft1(j,-i1,i2)
      		mattgnd = mattgnd + m1342(j,-i1,i2)*Ftgnd(j,-i1,i2)
	      enddo
	    endif

 	do 202 g1=1,2
 	do 202 g2=1,2
 	do 202 g3=1,2
 	do 202 g4=1,2
 	  wmatt0 = cv(g1,g3)*v(g2,g4)*matt0
 	  wmatt1 = cv(g1,g3)*v(g2,g4)*matt1
          if (qhvv.eq.0) then
 	    wmattgd = cv(g1,g3)*v(g2,g4)*mattgd
	  else
 	    wmatthvv0 = cv(g1,g3)*v(g2,g4)*matthvv0
 	    wmatthvv1 = cv(g1,g3)*v(g2,g4)*matthvv1
	  endif
 	  wmattgnd = cv(g1,g3)*v(g2,g4)*mattgnd
 	  f1 = 2*g1
 	  f2 = 2*g2
 	  f3 = 2*g3-1
 	  f4 = 2*g4-1
 	  if ((f1.eq.f2).and.(f3.eq.f4)) then
            if (qhvv.eq.0) then
 	      m2aqq0(f1,f2,f3,f4) = m2aqq0(f1,f2,f3,f4) + el6*(
     &		          +qch2*9d0*(abs(wmatt0)**2+abs(mats0)**2) 
     &	                  -qchint*3d0*2d0*dreal(wmatt0*dconjg(mats0)) ) 
 	      m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ qborn*(  qch2*9d0*(abs(wmatt0)**2+abs(mats0)**2) 
     &	                  -qchint*3d0*2d0*dreal(wmatt0*dconjg(mats0)) ) 
     &		+ 2d0*dreal(+qch2  *9d0*( matsgd *dconjg(mats0)
     &		                         +wmattgd*dconjg(wmatt0) ) ))
	    else
 	      m2aqq0(f1,f2,f3,f4) = m2aqq0(f1,f2,f3,f4) + el6*(
     &		     +qch2*9d0*(abs(wmatthvv0)**2+abs(matshvv0)**2) 
     &	             -qchint*3d0*2d0*dreal(wmatthvv0*dconjg(matshvv0)) ) 
 	      m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ qborn*(  qch2*9d0*(abs(wmatthvv0)**2+abs(matshvv0)**2) 
     &	             -qchint*3d0*2d0*dreal(wmatthvv0*dconjg(matshvv0)) ) 
     &		+ 2d0*dreal(+qch2*9d0*( matshvv1 *dconjg(matshvv0)
     &		                       +wmatthvv1*dconjg(wmatthvv0) ) ))
	    endif
 	    m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ 2d0*dreal( qch2  *9d0*( mats1  *dconjg(mats0)
     &		                         +wmatt1 *dconjg(wmatt0) )
     &	                    -qchint*3d0*( mats1  *dconjg(wmatt0)
     &			                 +mats0  *dconjg(wmatt1) ) 
     &	                    -qchint*3d0*( matsgnd*dconjg(wmatt0)
     &			                 +mats0  *dconjg(wmattgnd)) ) 
     &		+ 9d0*(chh2s*abs(mats0)**2+chh2t*abs(wmatt0)**2) )
 	  else
            if (qhvv.eq.0) then
 	      m2aqq0(f1,f2,f3,f4) = m2aqq0(f1,f2,f3,f4) + el6*(
     &		+  qch2*9d0*abs(wmatt0)**2 ) 
 	      m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ qborn*( qch2*9d0*abs(wmatt0)**2 ) 
     &		+ qch2*2d0*dreal(+9d0*( wmattgd*dconjg(wmatt0) ) )) 
	    else
 	      m2aqq0(f1,f2,f3,f4) = m2aqq0(f1,f2,f3,f4) + el6*(
     &		+  qch2*9d0*abs(wmatthvv0)**2 ) 
 	      m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ qborn*( qch2*9d0*abs(wmatthvv0)**2 ) 
     &		+ qch2*2d0*dreal(+9d0*( wmatthvv1*dconjg(wmatthvv0) ) )) 
	    endif
 	    m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ qch2*2d0*dreal( 9d0*( wmatt1 *dconjg(wmatt0) ) )
     &		+ 9d0*(chh2t*abs(wmatt0)**2) ) 
 	  endif
202	  continue


c Type: dbar-d -> dbar-d
c-----------------------

c*** generic amplitudes
	call setFnull(Fs0)
	call setFnull(Ft0)
	call setFnull(Fs1)
	call setFnull(Ft1)
	call setFnull(Fsgd)
	call setFnull(Ftgd)
	call setFnull(Fsgnd)
	call setFnull(Ftgnd)
	call setFnull(Fshvv0)
	call setFnull(Fshvv1)
	call setFnull(Fthvv0)
	call setFnull(Fthvv1)

	if (qz.eq.1) then

c dbar-d -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
	  if (checkss12) call calcform_HZZ2233(Fs0,Fs1,Fsgd,Fsgnd,
     &		Fshvv0,Fshvv1,s,t12,t11,t22,t21,s12,t13,t23,s23,s13)

c dbar-s -Z-> dbar-s  (k1->-p1,k2->p3,k3->p4,k4->-p2)
	  if (checkt11t22) call calcform_HZZ2233(Ft0,Ft1,Ftgd,Ftgnd,
     &		Fthvv0,Fthvv1,t11,t12,s,s12,t21,t22,t13,s13,s23,t23)

	  do 203 i1=-1,1,2
	  do 203 i2=-1,1,2
	  do 203 i4=-1,1,2
	    mats0   = 0d0
	    matt0   = 0d0
	    mats1   = 0d0
	    matt1   = 0d0
	    matsgd  = 0d0
	    mattgd  = 0d0
	    matsgnd = 0d0
	    mattgnd = 0d0
	    matshvv0 = 0d0
	    matthvv0 = 0d0
	    matshvv1 = 0d0
	    matthvv1 = 0d0
	    if (i1.eq.-i2) then
      	      mats0 = mats0 + m1243(1,i2,i4)*Fs0(1,i2,i4)
              if (qhvv.eq.0) then
      	        matsgd = matsgd + m1243(1,i2,i4)*Fsgd(1,i2,i4)
              else
                do j=1,13
      	          matshvv0 = matshvv0 + m1243(j,i2,i4)*Fshvv0(j,i2,i4)
      	          matshvv1 = matshvv1 + m1243(j,i2,i4)*Fshvv1(j,i2,i4)
                enddo
              endif
	      do j=1,13
      		mats1 = mats1 + m1243(j,i2,i4)*Fs1(j,i2,i4)
      		matsgnd = matsgnd + m1243(j,i2,i4)*Fsgnd(j,i2,i4)
	      enddo
	    endif
	    if (i2.eq.i4) then
      	      matt0 = matt0 + m1342(1,-i1,i4)*Ft0(1,-i1,i4)
              if (qhvv.eq.0) then
      	        mattgd = mattgd + m1342(1,-i1,i4)*Ftgd(1,-i1,i4)
              else
                do j=1,13
      	          matthvv0 = matthvv0 + m1342(j,-i1,i4)*Fthvv0(j,-i1,i4)
      	          matthvv1 = matthvv1 + m1342(j,-i1,i4)*Fthvv1(j,-i1,i4)
                enddo
              endif
	      do j=1,13
      		matt1 = matt1 + m1342(j,-i1,i4)*Ft1(j,-i1,i4)
      		mattgnd = mattgnd + m1342(j,-i1,i4)*Ftgnd(j,-i1,i4)
	      enddo
	    endif
c*** dbar-d -ZZ-> dbar-d    
            if (qhvv.eq.0) then
	      m2aqq0(1,1,1,1) = m2aqq0(1,1,1,1) + el6*(
     &		         +qch2*9d0*(abs(mats0)**2+abs(matt0)**2) 
     &	                 -qchint*3d0*2d0*dreal(mats0*dconjg(matt0))  ) 
	      m2aqq(1,1,1,1) = m2aqq(1,1,1,1) + el6*(
     &		+ qborn*( qch2*9d0*(abs(mats0)**2+abs(matt0)**2) 
     &	                 -qchint*3d0*2d0*dreal(mats0*dconjg(matt0))  ) 
     &		+ 2d0*dreal(+qch2  *9d0*( matsgd*dconjg(mats0)
     &		                         +mattgd*dconjg(matt0) ) ))
	    else
	      m2aqq0(1,1,1,1) = m2aqq0(1,1,1,1) + el6*(
     &		         +qch2*9d0*(abs(matshvv0)**2+abs(matthvv0)**2) 
     &	              -qchint*3d0*2d0*dreal(matshvv0*dconjg(matthvv0)) ) 
	      m2aqq(1,1,1,1) = m2aqq(1,1,1,1) + el6*(
     &		+ qborn*( qch2*9d0*(abs(matshvv0)**2+abs(matthvv0)**2) 
     &	              -qchint*3d0*2d0*dreal(matshvv0*dconjg(matthvv0)) ) 
     &		+ 2d0*dreal(+qch2  *9d0*( matshvv1*dconjg(matshvv0)
     &		                         +matthvv1*dconjg(matthvv0) ) ))
	    endif
	    m2aqq(1,1,1,1) = m2aqq(1,1,1,1) + el6*(
     &		+ 2d0*dreal( qch2  *9d0*( mats1 *dconjg(mats0)
     &		                         +matt1 *dconjg(matt0) )
     &	                    -qchint*3d0*( mats1 *dconjg(matt0)
     &			                 +mats0 *dconjg(matt1)  ) 
     &	                    -qchint*3d0*( matsgnd*dconjg(matt0)
     &			                 +mats0 *dconjg(mattgnd)) ) 
     &		+ 9d0*(chh2s*abs(mats0)**2+chh2t*abs(matt0)**2) )
c*** dbar-d -Z-> sbar-s 
            if (qhvv.eq.0) then
	      m2aqq0(1,1,3,3) = m2aqq0(1,1,3,3) + el6*(
     &		+ qch2*9d0*abs(mats0)**2 )
	      m2aqq(1,1,3,3) = m2aqq(1,1,3,3) + el6*(
     &		+ qch2*9d0*qborn*abs(mats0)**2 
     &		+ qch2*2d0*dreal(+9d0*( matsgd*dconjg(mats0) ) ) ) 
	    else
	      m2aqq0(1,1,3,3) = m2aqq0(1,1,3,3) + el6*(
     &		+ qch2*9d0*abs(matshvv0)**2 )
	      m2aqq(1,1,3,3) = m2aqq(1,1,3,3) + el6*(
     &		+ qch2*9d0*qborn*abs(matshvv0)**2 
     &		+ qch2*2d0*dreal(+9d0*( matshvv1*dconjg(matshvv0) ) ) ) 
	    endif
	    m2aqq(1,1,3,3) = m2aqq(1,1,3,3) + el6*(
     &		+ qch2*2d0*dreal( 9d0*( mats1 *dconjg(mats0) ) )
     &		+ 9d0*(chh2s*abs(mats0)**2) )
c*** dbar-s -Z-> dbar-s 
            if (qhvv.eq.0) then
	      m2aqq0(1,3,1,3) = m2aqq0(1,3,1,3) + el6*(
     &		+ qch2*9d0*abs(matt0)**2 )
	      m2aqq(1,3,1,3) = m2aqq(1,3,1,3) + el6*(
     &		+ qch2*9d0*qborn*abs(matt0)**2 
     &		+ qch2*2d0*dreal(+9d0*( mattgd*dconjg(matt0) ) ) )
	    else
	      m2aqq0(1,3,1,3) = m2aqq0(1,3,1,3) + el6*(
     &		+ qch2*9d0*abs(matthvv0)**2 )
	      m2aqq(1,3,1,3) = m2aqq(1,3,1,3) + el6*(
     &		+ qch2*9d0*qborn*abs(matthvv0)**2 
     &		+ qch2*2d0*dreal(+9d0*( matthvv1*dconjg(matthvv0) ) ) )
	    endif
	    m2aqq(1,3,1,3) = m2aqq(1,3,1,3) + el6*(
     &		+ qch2*2d0*dreal( 9d0*( matt1 *dconjg(matt0) ) )
     &		+ 9d0*(chh2t*abs(matt0)**2) )
203	  continue
	  m2aqq0(3,3,3,3) = m2aqq0(1,1,1,1) 
	  m2aqq0(3,3,1,1) = m2aqq0(1,1,3,3)
	  m2aqq0(3,1,3,1) = m2aqq0(1,3,1,3)
	  m2aqq(3,3,3,3)  = m2aqq(1,1,1,1) 
	  m2aqq(3,3,1,1)  = m2aqq(1,1,3,3)
	  m2aqq(3,1,3,1)  = m2aqq(1,3,1,3)
	endif

c Type: dbar-d -> ubar-u
c-----------------------

c*** generic amplitudes
	call setFnull(Fs0)
	call setFnull(Ft0)
	call setFnull(Fs1)
	call setFnull(Ft1)
	call setFnull(Fsgd)
	call setFnull(Ftgd)
	call setFnull(Fsgnd)
	call setFnull(Ftgnd)
	call setFnull(Fshvv0)
	call setFnull(Fshvv1)
	call setFnull(Fthvv0)
	call setFnull(Fthvv1)

c dbar-d -Z-> cbar-c  (k3->-p1,k4->-p2,k1->p4,k2->p3)
	if ((qz.eq.1).and.checkss12)
     &	  call calcform_HZZ1133(Fs0,Fs1,Fsgd,Fsgnd,Fshvv0,Fshvv1,
     &		                s12,t12,t22,t11,t21,s,s23,s13,t13,t23)

c dbar-s -W-> ubar-c  (k3->-p1,k4->p3,k1->p4,k2->-p2)
	if ((qw.eq.1).and.checkt11t22)
     &	  call calcform_HWW4f(Ft0,Ft1,Ftgd,Ftgnd,Fthvv0,Fthvv1,
     &			      t22,t12,s12,s,t21,t11,s23,t23,t13,s13)

	  do 204 i1=-1,1,2
	  do 204 i2=-1,1,2
	  do 204 i4=-1,1,2
	    mats0   = 0d0
	    matt0   = 0d0
	    mats1   = 0d0
	    matt1   = 0d0
	    matsgd  = 0d0
	    mattgd  = 0d0
	    matsgnd = 0d0
	    mattgnd = 0d0
	    matshvv0 = 0d0
	    matthvv0 = 0d0
	    matshvv1 = 0d0
	    matthvv1 = 0d0
	    if (i1.eq.-i2) then
      	      mats0 = mats0 + m4312(1,i4,i2)*Fs0(1,i4,i2)
              if (qhvv.eq.0) then
      	        matsgd = matsgd + m4312(1,i4,i2)*Fsgd(1,i4,i2)
              else
                do j=1,13
      	          matshvv0 = matshvv0 + m4312(j,i4,i2)*Fshvv0(j,i4,i2)
      	          matshvv1 = matshvv1 + m4312(j,i4,i2)*Fshvv1(j,i4,i2)
                enddo
              endif
	      do j=1,13
      		mats1 = mats1 + m4312(j,i4,i2)*Fs1(j,i4,i2)
      		matsgnd = matsgnd + m4312(j,i4,i2)*Fsgnd(j,i4,i2)
	      enddo
	    endif
	    if (i2.eq.i4) then
      	      matt0 = matt0 + m4213(1,i2,-i1)*Ft0(1,i2,-i1)
              if (qhvv.eq.0) then
      	        mattgd = mattgd + m4213(1,i2,-i1)*Ftgd(1,i2,-i1)
              else
                do j=1,13
      	          matthvv0 = matthvv0 + m4213(j,i2,-i1)*Fthvv0(j,i2,-i1)
      	          matthvv1 = matthvv1 + m4213(j,i2,-i1)*Fthvv1(j,i2,-i1)
                enddo
              endif
	      do j=1,13
      		matt1 = matt1 + m4213(j,i2,-i1)*Ft1(j,i2,-i1)
      		mattgnd = mattgnd + m4213(j,i2,-i1)*Ftgnd(j,i2,-i1)
	      enddo
	    endif

 	do 204 g1=1,2
 	do 204 g2=1,2
 	do 204 g3=1,2
 	do 204 g4=1,2
 	  wmatt0 = v(g3,g1)*cv(g4,g2)*matt0
 	  wmatt1 = v(g3,g1)*cv(g4,g2)*matt1
	  if (qhvv.eq.0) then
 	    wmattgd = v(g3,g1)*cv(g4,g2)*mattgd
	  else
 	    wmatthvv0 = v(g3,g1)*cv(g4,g2)*matthvv0
 	    wmatthvv1 = v(g3,g1)*cv(g4,g2)*matthvv1
	  endif
 	  wmattgnd = v(g3,g1)*cv(g4,g2)*mattgnd
 	  f1 = 2*g1-1
 	  f2 = 2*g2-1
 	  f3 = 2*g3
 	  f4 = 2*g4
 	  if ((f1.eq.f2).and.(f3.eq.f4)) then
	    if (qhvv.eq.0) then
 	      m2aqq0(f1,f2,f3,f4) = m2aqq0(f1,f2,f3,f4) + el6*(
     &		           qch2*9d0*(abs(wmatt0)**2+abs(mats0)**2) 
     &	                  -qchint*3d0*2d0*dreal(wmatt0*dconjg(mats0)) ) 
 	      m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ qborn*( qch2*9d0*(abs(wmatt0)**2+abs(mats0)**2) 
     &	                 -qchint*3d0*2d0*dreal(wmatt0*dconjg(mats0)) ) 
     &		+ 2d0*dreal(+qch2  *9d0*( matsgd *dconjg(mats0)
     &		                         +wmattgd*dconjg(wmatt0) ) ))
	    else
 	      m2aqq0(f1,f2,f3,f4) = m2aqq0(f1,f2,f3,f4) + el6*(
     &		      qch2*9d0*(abs(wmatthvv0)**2+abs(matshvv0)**2) 
     &	             -qchint*3d0*2d0*dreal(wmatthvv0*dconjg(matshvv0)) ) 
 	      m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ qborn*( qch2*9d0*(abs(wmatthvv0)**2+abs(matshvv0)**2) 
     &	             -qchint*3d0*2d0*dreal(wmatthvv0*dconjg(matshvv0)) ) 
     &		+ 2d0*dreal(+qch2*9d0*( matshvv1 *dconjg(matshvv0)
     &		                       +wmatthvv1*dconjg(wmatthvv0) ) ))
	    endif
 	    m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*(
     &		+ 2d0*dreal( qch2  *9d0*( mats1  *dconjg(mats0)
     &		                         +wmatt1 *dconjg(wmatt0) )
     &	                    -qchint*3d0*( mats1  *dconjg(wmatt0)
     &			                 +mats0  *dconjg(wmatt1) ) 
     &	                    -qchint*3d0*( matsgnd*dconjg(wmatt0)
     &			                 +mats0  *dconjg(wmattgnd)) ) 
     &		+ 9d0*(chh2s*abs(mats0)**2+chh2t*abs(wmatt0)**2) )
 	  else
	    if (qhvv.eq.0) then
 	      m2aqq0(f1,f2,f3,f4) = m2aqq0(f1,f2,f3,f4) + el6*( 
     &		+ qch2*9d0*abs(wmatt0)**2 ) 
 	      m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*( 
     &		+ qborn*( qch2*9d0*abs(wmatt0)**2 ) 
     &		+ qch2*2d0*dreal(+9d0*( wmattgd*dconjg(wmatt0) )) )
	    else
 	      m2aqq0(f1,f2,f3,f4) = m2aqq0(f1,f2,f3,f4) + el6*( 
     &		+ qch2*9d0*abs(wmatthvv0)**2 ) 
 	      m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*( 
     &		+ qborn*( qch2*9d0*abs(wmatthvv0)**2 ) 
     &		+ qch2*2d0*dreal(+9d0*( wmatthvv1*dconjg(wmatthvv0) )) )
	    endif
 	    m2aqq(f1,f2,f3,f4) = m2aqq(f1,f2,f3,f4) + el6*( 
     &		+ qch2*2d0*dreal( 9d0*( wmatt1 *dconjg(wmatt0) ) )
     &		+ 9d0*(chh2t*abs(wmatt0)**2) )
 	  endif
204	  continue

	end

************************************************************************
        subroutine setprods3(p)
************************************************************************
*       Weyl-van der Waerden and Minkowski products
*-----------------------------------------------------------------------
*       23.8.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 eiph1,eiph2,sp(-4:4,-4:4),csp(-4:4,-4:4),v,cv
        real*8 p(6,0:3),vp(-4:4,-4:4)
        integer i,j

	common/prods3/sp,csp,vp
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)

c energies and angles
        eb1  = p(1,0)
        eb2  = p(2,0)
	e1   = p(3,0)
	e2   = p(4,0)
	cth1 = p(3,3)/p(3,0)
	cth2 = p(4,3)/p(4,0)
	sth1 = sqrt(p(3,1)**2+p(3,2)**2)/p(3,0)
	sth2 = sqrt(p(4,1)**2+p(4,2)**2)/p(4,0)
	eiph1= dcmplx(p(3,1),p(3,2))/p(3,0)/sth1
	eiph2= dcmplx(p(4,1),p(4,2))/p(4,0)/sth2
	if (p(1,3).lt.0d0) then
	  cth1 = -cth1
	  cth2 = -cth2
	  eiph1= dconjg(eiph1)
	  eiph2= dconjg(eiph2)
	endif
        r2eb1= sqrt(2d0*eb1)
        r2eb2= sqrt(2d0*eb2)
        r2e1 = sqrt(2d0*e1)
        r2e2 = sqrt(2d0*e2)
        if (cth1.gt.0d0) then
          c2th1 = sqrt((1d0+cth1)/2d0)
          s2th1 = sth1/2d0/c2th1
        else
          s2th1 = sqrt((1d0-cth1)/2d0)
          c2th1 = sth1/2d0/s2th1
        endif
        if (cth2.gt.0d0) then
          c2th2 = sqrt((1d0+cth2)/2d0)
          s2th2 = sth2/2d0/c2th2
        else
          s2th2 = sqrt((1d0-cth2)/2d0)
          c2th2 = sth2/2d0/s2th2
        endif

c spinor products
        sp(1,2) = r2eb1*r2eb2
        sp(1,3) = r2eb1*r2e1*(s2th1)
        sp(1,4) = r2eb1*r2e2*(s2th2)
        sp(2,3) = r2eb2*r2e1*(-1d0/eiph1*c2th1)
        sp(2,4) = r2eb2*r2e2*(-1d0/eiph2*c2th2)
        sp(3,4) = r2e1 *r2e2*(c2th1/eiph1*s2th2-c2th2/eiph2*s2th1)

        do 101 i=1,3
        do 101 j=i+1,4
           sp(j,i) = -sp(i,j)
101     continue

        do 100 i=1,4
        do 100 j=1,4
          csp(i,j)  = dconjg(sp(i,j))
           sp(-i, j) =  sp(i,j)
           sp( i,-j) =  sp(i,j)
           sp(-i,-j) =  sp(i,j)
          csp(-i, j) =-csp(i,j)
          csp( i,-j) =-csp(i,j)
          csp(-i,-j) = csp(i,j)
           vp( i, j) =  sp(i,j)*csp(i,j)
           vp(-i, j) = -vp(i,j)
           vp( i,-j) = -vp(i,j)
           vp(-i,-j) =  vp(i,j)
100     continue

	end

************************************************************************
*       routine for alpha_s taken from hdecay (M.Spira et al.)
*----------------------------------------------------------------------
*       25.6.03 Stefan Dittmaier
************************************************************************

csd      DOUBLE PRECISION FUNCTION ALPHAS(Q,N)
      DOUBLE PRECISION FUNCTION ALPS(Q,N)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION XLB(6)
      COMMON/ALSLAM/XLB1(6),XLB2(6)
      COMMON/ALS/XLAMBDA,AMC,AMB,AMT,N0
      B0(NF)=33.D0-2.D0*NF
      B1(NF)=6.D0*(153.D0-19.D0*NF)/B0(NF)**2
      ALS1(NF,X)=12.D0*PI/(B0(NF)*DLOG(X**2/XLB(NF)**2))
      ALS2(NF,X)=12.D0*PI/(B0(NF)*DLOG(X**2/XLB(NF)**2))
     .          *(1.D0-B1(NF)*DLOG(DLOG(X**2/XLB(NF)**2))
     .           /DLOG(X**2/XLB(NF)**2))
      PI=4.D0*DATAN(1.D0)
      IF(N.EQ.1)THEN
       DO 1 I=1,6
        XLB(I)=XLB1(I)
1      CONTINUE
      ELSE
       DO 2 I=1,6
        XLB(I)=XLB2(I)
2      CONTINUE
      ENDIF
      IF(Q.LT.AMC)THEN
       NF=3
      ELSEIF(Q.LE.AMB)THEN
       NF=4
      ELSEIF(Q.LE.AMT)THEN
       NF=5
      ELSE
       NF=6
      ENDIF
      IF(N.EQ.1)THEN
csd        ALPHAS=ALS1(NF,Q)
        ALPS=ALS1(NF,Q)
      ELSE
csd        ALPHAS=ALS2(NF,Q)
        ALPS=ALS2(NF,Q)
      ENDIF
      RETURN
      END

      SUBROUTINE ALSINI(ACC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION XLB(6)
      COMMON/ALSLAM/XLB1(6),XLB2(6)
      COMMON/ALS/XLAMBDA,AMC,AMB,AMT,N0
      PI=4.D0*DATAN(1.D0)
      XLB1(1)=0D0
      XLB1(2)=0D0
      XLB2(1)=0D0
      XLB2(2)=0D0
      IF(N0.EQ.3)THEN
       XLB(3)=XLAMBDA
       XLB(4)=XLB(3)*(XLB(3)/AMC)**(2.D0/25.D0)
       XLB(5)=XLB(4)*(XLB(4)/AMB)**(2.D0/23.D0)
       XLB(6)=XLB(5)*(XLB(5)/AMT)**(2.D0/21.D0)
      ELSEIF(N0.EQ.4)THEN
       XLB(4)=XLAMBDA
       XLB(5)=XLB(4)*(XLB(4)/AMB)**(2.D0/23.D0)
       XLB(3)=XLB(4)*(XLB(4)/AMC)**(-2.D0/27.D0)
       XLB(6)=XLB(5)*(XLB(5)/AMT)**(2.D0/21.D0)
      ELSEIF(N0.EQ.5)THEN
       XLB(5)=XLAMBDA
       XLB(4)=XLB(5)*(XLB(5)/AMB)**(-2.D0/25.D0)
       XLB(3)=XLB(4)*(XLB(4)/AMC)**(-2.D0/27.D0)
       XLB(6)=XLB(5)*(XLB(5)/AMT)**(2.D0/21.D0)
      ELSEIF(N0.EQ.6)THEN
       XLB(6)=XLAMBDA
       XLB(5)=XLB(6)*(XLB(6)/AMT)**(-2.D0/23.D0)
       XLB(4)=XLB(5)*(XLB(5)/AMB)**(-2.D0/25.D0)
       XLB(3)=XLB(4)*(XLB(4)/AMC)**(-2.D0/27.D0)
      ENDIF
      DO 1 I=1,6
       XLB1(I)=XLB(I)
1     CONTINUE
      IF(N0.EQ.3)THEN
       XLB(3)=XLAMBDA
       XLB(4)=XLB(3)*(XLB(3)/AMC)**(2.D0/25.D0)
     .             *(2.D0*DLOG(AMC/XLB(3)))**(-107.D0/1875.D0)
       XLB(4)=XITER(AMC,XLB(3),3,XLB(4),4,ACC)
       XLB(5)=XLB(4)*(XLB(4)/AMB)**(2.D0/23.D0)
     .             *(2.D0*DLOG(AMB/XLB(4)))**(-963.D0/13225.D0)
       XLB(5)=XITER(AMB,XLB(4),4,XLB(5),5,ACC)
       XLB(6)=XLB(5)*(XLB(5)/AMT)**(2.D0/21.D0)
     .            *(2.D0*DLOG(AMT/XLB(5)))**(-321.D0/3381.D0)
       XLB(6)=XITER(AMT,XLB(5),5,XLB(6),6,ACC)
      ELSEIF(N0.EQ.4)THEN
       XLB(4)=XLAMBDA
       XLB(5)=XLB(4)*(XLB(4)/AMB)**(2.D0/23.D0)
     .             *(2.D0*DLOG(AMB/XLB(4)))**(-963.D0/13225.D0)
       XLB(5)=XITER(AMB,XLB(4),4,XLB(5),5,ACC)
       XLB(3)=XLB(4)*(XLB(4)/AMC)**(-2.D0/27.D0)
     .             *(2.D0*DLOG(AMC/XLB(4)))**(107.D0/2025.D0)
       XLB(3)=XITER(AMC,XLB(4),4,XLB(3),3,ACC)
       XLB(6)=XLB(5)*(XLB(5)/AMT)**(2.D0/21.D0)
     .            *(2.D0*DLOG(AMT/XLB(5)))**(-321.D0/3381.D0)
       XLB(6)=XITER(AMT,XLB(5),5,XLB(6),6,ACC)
      ELSEIF(N0.EQ.5)THEN
       XLB(5)=XLAMBDA
       XLB(4)=XLB(5)*(XLB(5)/AMB)**(-2.D0/25.D0)
     .             *(2.D0*DLOG(AMB/XLB(5)))**(963.D0/14375.D0)
       XLB(4)=XITER(AMB,XLB(5),5,XLB(4),4,ACC)
       XLB(3)=XLB(4)*(XLB(4)/AMC)**(-2.D0/27.D0)
     .             *(2.D0*DLOG(AMC/XLB(4)))**(107.D0/2025.D0)
       XLB(3)=XITER(AMC,XLB(4),4,XLB(3),3,ACC)
       XLB(6)=XLB(5)*(XLB(5)/AMT)**(2.D0/21.D0)
     .            *(2.D0*DLOG(AMT/XLB(5)))**(-321.D0/3381.D0)
       XLB(6)=XITER(AMT,XLB(5),5,XLB(6),6,ACC)
      ELSEIF(N0.EQ.6)THEN
       XLB(6)=XLAMBDA
       XLB(5)=XLB(6)*(XLB(6)/AMT)**(-2.D0/23.D0)
     .            *(2.D0*DLOG(AMT/XLB(6)))**(321.D0/3703.D0)
       XLB(5)=XITER(AMT,XLB(6),6,XLB(5),5,ACC)
       XLB(4)=XLB(5)*(XLB(5)/AMB)**(-2.D0/25.D0)
     .             *(2.D0*DLOG(AMB/XLB(5)))**(963.D0/14375.D0)
       XLB(4)=XITER(AMB,XLB(5),5,XLB(4),4,ACC)
       XLB(3)=XLB(4)*(XLB(4)/AMC)**(-2.D0/27.D0)
     .             *(2.D0*DLOG(AMC/XLB(4)))**(107.D0/2025.D0)
       XLB(3)=XITER(AMC,XLB(4),4,XLB(3),3,ACC)
      ENDIF
      DO 2 I=1,6
       XLB2(I)=XLB(I)
2     CONTINUE
      RETURN
      END

      DOUBLE PRECISION FUNCTION XITER(Q,XLB1,NF1,XLB,NF2,ACC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      B0(NF)=33.D0-2.D0*NF
      B1(NF)=6.D0*(153.D0-19.D0*NF)/B0(NF)**2
      ALS2(NF,X,XLB)=12.D0*PI/(B0(NF)*DLOG(X**2/XLB**2))
     .              *(1.D0-B1(NF)*DLOG(DLOG(X**2/XLB**2))
     .              /DLOG(X**2/XLB**2))
      AA(NF)=12D0*PI/B0(NF)
      BB(NF)=B1(NF)/AA(NF)
      XIT(A,B,X)=A/2.D0*(1D0+DSQRT(1D0-4D0*B*DLOG(X)))
      PI=4.D0*DATAN(1.D0)
      XLB2=XLB
      II=0
1     II=II+1
      X=DLOG(Q**2/XLB2**2)
      ALP=ALS2(NF1,Q,XLB1)
      A=AA(NF2)/ALP
      B=BB(NF2)*ALP
      XX=XIT(A,B,X)
      XLB2=Q*DEXP(-XX/2.D0)
      Y1=ALS2(NF1,Q,XLB1)
      Y2=ALS2(NF2,Q,XLB2)
      DY=DABS(Y2-Y1)/Y1
      IF(DY.GE.ACC) GOTO 1
      XITER=XLB2
      RETURN
      END

      DOUBLE PRECISION FUNCTION XITLA(NO,ALP,ACC)
C--ITERATION ROUTINE TO DETERMINE IMPROVED LAMBDA'S
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	complex*16 v,cv
csd
	real*8 mw,mw2,mz,mz2,mh,mh2,mxe,mxe2,ml,ml2,mqp,mqp2,mqm,mqm2
csd      COMMON/PARAM/GF,ALPH,AMTAU,AMMUON,AMZ,AMW
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
      B0(NF)=33.D0-2.D0*NF
      B1(NF)=6.D0*(153.D0-19.D0*NF)/B0(NF)**2
      ALS2(NF,X,XLB)=12.D0*PI/(B0(NF)*DLOG(X**2/XLB**2))
     .              *(1.D0-B1(NF)*DLOG(DLOG(X**2/XLB**2))
     .              /DLOG(X**2/XLB**2))
      AA(NF)=12D0*PI/B0(NF)
      BB(NF)=B1(NF)/AA(NF)
      XIT(A,B,X)=A/2.D0*(1D0+DSQRT(1D0-4D0*B*DLOG(X)))
csd      PI=4.D0*DATAN(1.D0)
	ALPH   = 1d0/alpha0
	AMTAU  = ml(3)
	AMMUON = ml(2)
	AMZ    = mz
	AMW    = mw
csd
      NF=5
      Q=AMZ
      XLB=Q*DEXP(-AA(NF)/ALP/2.D0)
      IF(NO.EQ.1)GOTO 111
      II=0
1     II=II+1
      X=DLOG(Q**2/XLB**2)
      A=AA(NF)/ALP
      B=BB(NF)*ALP
      XX=XIT(A,B,X)
      XLB=Q*DEXP(-XX/2.D0)
      Y1=ALP
      Y2=ALS2(NF,Q,XLB)
      DY=DABS(Y2-Y1)/Y1
      IF(DY.GE.ACC) GOTO 1
111   XITLA=XLB
      RETURN
      END

**********************************************************************
        function xseww(s)
**********************************************************************
*       unrenormalized W self-energy
*	bosonic loops only
*       conventional formalism
*---------------------------------------------------------------------
*       2.6.04 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 B00H,B00W,B00Z,Bs0W,BsHW,BsWZ
        complex*16 xseww,B0_,xB0_
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
	complex*16 v,cv

        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)

c	B00H = B0_(0D0,0D0,MH,0)
c	B00W = B0_(0D0,0D0,MW,0)
c	B00Z = B0_(0D0,0D0,MZ,0)
c	Bs0W = B0_(S,0D0,MW,0)
c	BsHW = B0_(S,MH,MW,0)
c	BsWZ = B0_(S,MW,MZ,0)

	B00H = xB0_(0D0,null,xMH2,0)
	B00W = xB0_(0D0,null,xMW2,0)
	B00Z = xB0_(0D0,null,xMZ2,0)
	Bs0W = xB0_(S,null,xMW2,0)
	BsHW = xB0_(S,xMH2,xMW2,0)
	BsWZ = xB0_(S,xMW2,xMZ2,0)

        xseww = ALPHA/PI*(
     &  (-3D0*xMH2-57D0*xMW2-2D0*S+3D0*xMH2*xSW2+54D0*xMW2*xSW2
     &    +2D0*S*xSW2)/72D0/xCW2/xSW2
     &  -xMH2*(xMH2-xMW2-2D0*S)/xSW2*B00H/(48D0*S)
     &  +xMW2/xSW2/xCW2*(xMH2-xMW2+20D0*S-xMH2*xSW2+2D0*xMW2*xSW2
     &    -20D0*S*xSW2)*B00W/(48D0*S)
     &  +xMW2/xSW2/xCW**4*(-9D0+8D0*xSW2)*(-2D0*S+xMW2*xSW2+2D0*S*xSW2)
     &    *B00Z/(48D0*S)
     &  -(-xMW**4+2D0*xMW2*S+5D0*S**2)*Bs0W/(6D0*S)
     &  +(xMH**4-2D0*xMH2*xMW2+xMW**4-2D0*xMH2*S+10D0*xMW2*S+S**2)/xSW2
     &    *BsHW/(48D0*S)
     &  +(-60D0*xMW2*S-39D0*S**2+146D0*xMW2*S*xSW2+118D0*S**2*xSW2
     &    +9D0*xMW**4*xSW**4-102D0*xMW2*S*xSW**4-119D0*S**2*xSW**4
     &    -8D0*xMW**4*xSW**6+16D0*xMW2*S*xSW**6+40D0*S**2*xSW**6)
     &    /xCW**4/xSW2*BsWZ/(48D0*S)       )

        end


**********************************************************************
        function xseww_bgf(s)
**********************************************************************
*       unrenormalized W self-energy
*	bosonic loops only
*       background-field formalism
*---------------------------------------------------------------------
*       13.6.04 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 B00H,B00W,B00Z,Bs0W,BsHW,BsWZ
        complex*16 xseww_bgf,B0_,xB0_
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
	complex*16 v,cv

        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)

c	B00H = B0_(0D0,0D0,MH,0)
c	B00W = B0_(0D0,0D0,MW,0)
c	B00Z = B0_(0D0,0D0,MZ,0)
c	Bs0W = B0_(S,0D0,MW,0)
c	BsHW = B0_(S,MH,MW,0)
c	BsWZ = B0_(S,MW,MZ,0)

	B00H = xB0_(0D0,null,xMH2,0)
	B00W = xB0_(0D0,null,xMW2,0)
	B00Z = xB0_(0D0,null,xMZ2,0)
	Bs0W = xB0_(S,null,xMW2,0)
	BsHW = xB0_(S,xMH2,xMW2,0)
	BsWZ = xB0_(S,xMW2,xMZ2,0)

        xseww_bgf = ALPHA/PI*(
     &  (-3D0*xMH2-57D0*xMW2-2D0*S+3D0*xMH2*xSW2+54D0*xMW2*xSW2
     &    +2D0*S*xSW2)/72D0/xCW2/xSW2
     &  -xMH2*(xMH2-xMW2-2D0*S)/xSW2*B00H/(48D0*S)
     &  +xMW2/xSW2/xCW2*(xMH2-xMW2+20D0*S-xMH2*xSW2+2D0*xMW2*xSW2
     &    -20D0*S*xSW2)*B00W/(48D0*S)
     &  +xMW2/xSW2/xCW**4*(-9D0+8D0*xSW2)*(-2D0*S+xMW2*xSW2+2D0*S*xSW2)
     &    *B00Z/(48D0*S)
     &  -(-xMW**4+2D0*xMW2*S+5D0*S**2)*Bs0W/(6D0*S)
     &  +(xMH**4-2D0*xMH2*xMW2+xMW**4-2D0*xMH2*S+10D0*xMW2*S+S**2)/xSW2
     &    *BsHW/(48D0*S)
     &  +(-60D0*xMW2*S-39D0*S**2+146D0*xMW2*S*xSW2+118D0*S**2*xSW2
     &    +9D0*xMW**4*xSW**4-102D0*xMW2*S*xSW**4-119D0*S**2*xSW**4
     &    -8D0*xMW**4*xSW**6+16D0*xMW2*S*xSW**6+40D0*S**2*xSW**6)
     &    /xCW**4/xSW2*BsWZ/(48D0*S)       
     &  +(xMW2-S)*(Bs0W+xCW2/xSW2*BsWZ)		)

        end

**********************************************************************
        subroutine xsevv(s,seaa,seaz,sezz)
**********************************************************************
*       unrenormalized neutral boson self-energies
*	bosonic loops only
*       conventional formalism
*---------------------------------------------------------------------
*       2.6.04 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 seaa,seaz,sezz
	complex*16 B0_,xB0_,xDB0_,B00H,B00W,B00Z,BSHZ,BSWW,DB0HZ
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
	complex*16 v,cv

        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)

c	B00H = B0_(0D0,0D0,MH,0)
c	B00W = B0_(0D0,0D0,MW,0)
c	B00Z = B0_(0D0,0D0,MZ,0)
c	BSHZ = B0_(S,MH,MZ,0)
c	BSWW = B0_(S,MW,MW,0)

	B00H = xB0_(0D0,null,xMH2,0)
	B00W = xB0_(0D0,null,xMW2,0)
	B00Z = xB0_(0D0,null,xMZ2,0)
	BSHZ = xB0_(S,xMH2,xMZ2,0)
	BSWW = xB0_(S,xMW2,xMW2,0)
	DB0HZ= xDB0_(0D0,XMH2,XMZ2,0)

        seaa = -ALPHA/(4D0*PI)*(
     &  -4d0*xMW2*(B00W-1d0) + (3D0*S+4D0*xMW2)*BSWW )

        seaz = ALPHA/(72D0*xCW*PI*xSW)*(
     &	2D0*S+12D0*(1D0-6D0*xCW2)*xMW2*(B00W-1D0)
     &  +3D0*(8D0*(1D0+3D0*xCW2)*xMW2+S+18D0*xCW2*S)*BSWW)

	if (s.ne.0d0) then
          sezz = ALPHA/PI*(
     &    (-3D0*xMH2-57D0*xMZ2-2D0*S+174D0*xMZ2*xSW2+4D0*S*xSW2
     &      -192D0*xMZ2*xSW**4+72D0*xMZ2*xSW**6)/72D0/xCW2/xSW2
     &    -xMH2*(xMH2-xMZ2-2D0*S)/xSW2/xCW2*B00H/(48D0*S)
     &    +xMZ2/xSW2*(9D0-20D0*xSW2+12D0*xSW**4)*B00W/12D0
     &    -xMZ2*(-xMH2+xMZ2-2D0*S)/xSW2/xCW2*B00Z/(48D0*S)
     &    +(xMH**4-2D0*xMH2*xMZ2+xMZ**4-2D0*xMH2*S+10D0*xMZ2*S+S**2)
     &      /xSW2/xCW2*BSHZ/(48D0*S)
     &    +(-60D0*xMZ2-39D0*S+188D0*xMZ2*xSW2+76D0*S*xSW2
     &      -176D0*xMZ2*xSW**4-36D0*S*xSW**4+48D0*xMZ2*xSW**6)
     &	    /xSW2/xCW2*BSWW/48D0   )
	else
	  sezz = ALPHA/(48D0*PI*XCW2*XSW2)*(
     &	  -2D0*(XMH2+(1D0+12D0*XCW2-24D0*XCW2**2)*XMZ2)
     &    +8D0*XMH2*XMW2*B00H/(XCW2*(XMH2-XMZ2))
     &    -24D0*XMW2*(XCW2-XSW2)*B00W
     &	  +4D0*XMZ2*(XMH2-3D0*XMZ2)*B00Z/(XMH2-XMZ2)
     &    +(XMH2-XMZ2)**2*DB0HZ 			)
	endif

	end

**********************************************************************
        subroutine xsevv_bgf(s,seaa,seaz,sezz)
**********************************************************************
*       unrenormalized neutral boson self-energies
*	bosonic loops only
*       background-field formalism
*---------------------------------------------------------------------
*       13.6.04 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 seaa,seaz,sezz
	complex*16 B0_,xB0_,xDB0_,B00H,B00W,B00Z,BSHZ,BSWW,DB0HZ
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
	complex*16 v,cv

        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)

c	B00H = B0_(0D0,0D0,MH,0)
c	B00W = B0_(0D0,0D0,MW,0)
c	B00Z = B0_(0D0,0D0,MZ,0)
c	BSHZ = B0_(S,MH,MZ,0)
c	BSWW = B0_(S,MW,MW,0)

	B00H = xB0_(0D0,null,xMH2,0)
	B00W = xB0_(0D0,null,xMW2,0)
	B00Z = xB0_(0D0,null,xMZ2,0)
	BSHZ = xB0_(S,xMH2,xMZ2,0)
	BSWW = xB0_(S,xMW2,xMW2,0)
	DB0HZ= xDB0_(0D0,XMH2,XMZ2,0)

        seaa = -ALPHA/(4D0*PI)*(
     &  -4d0*xMW2*(B00W-1d0) + (3D0*S+4D0*xMW2)*BSWW 
     &  +4d0*S*BsWW	)

        seaz = ALPHA/(72D0*xCW*PI*xSW)*(
     &	2D0*S+12D0*(1D0-6D0*xCW2)*xMW2*(B00W-1D0)
     &  +3D0*(8D0*(1D0+3D0*xCW2)*xMW2+S+18D0*xCW2*S)*BSWW
     &  -36d0*xCW2*(xMZ2-2D0*S)*BsWW	)

	if (s.ne.0d0) then
          sezz = ALPHA/PI*(
     &    (-3D0*xMH2-57D0*xMZ2-2D0*S+174D0*xMZ2*xSW2+4D0*S*xSW2
     &      -192D0*xMZ2*xSW**4+72D0*xMZ2*xSW**6)/72D0/xCW2/xSW2
     &    -xMH2*(xMH2-xMZ2-2D0*S)/xSW2/xCW2*B00H/(48D0*S)
     &    +xMZ2/xSW2*(9D0-20D0*xSW2+12D0*xSW**4)*B00W/12D0
     &    -xMZ2*(-xMH2+xMZ2-2D0*S)/xSW2/xCW2*B00Z/(48D0*S)
     &    +(xMH**4-2D0*xMH2*xMZ2+xMZ**4-2D0*xMH2*S+10D0*xMZ2*S+S**2)
     &      /xSW2/xCW2*BSHZ/(48D0*S)
     &    +(-60D0*xMZ2-39D0*S+188D0*xMZ2*xSW2+76D0*S*xSW2
     &      -176D0*xMZ2*xSW**4-36D0*S*xSW**4+48D0*xMZ2*xSW**6)
     &	    /xSW2/xCW2*BSWW/48D0   
     &    +xCW2*(xMZ2-S)/xSW2*BsWW )
	else
	  sezz = ALPHA/(48D0*PI*XCW2*XSW2)*(
     &	  -2D0*(XMH2+(1D0+12D0*XCW2-24D0*XCW2**2)*XMZ2)
     &    +8D0*XMH2*XMW2*B00H/(XCW2*(XMH2-XMZ2))
     &    -24D0*XMW2*(XCW2-XSW2)*B00W
     &	  +4D0*XMZ2*(XMH2-3D0*XMZ2)*B00Z/(XMH2-XMZ2)
     &    +(XMH2-XMZ2)**2*DB0HZ 			)
     &    +ALPHA/PI*xMW2/xSW2*(-1D0+B00W)
	endif

	end

**********************************************************************
        function xseff_l(s,qf,sgni3f)
**********************************************************************
*       unrenormalized left-handed fermion self-energies
*	massless fermions, sgni3f = +-1
*---------------------------------------------------------------------
*       2.6.04 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 xseff_r,xseff_l
	complex*16 B0_,xB0_,B1_,xB1_,b1a,b1w,b1z
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
	complex*16 v,cv

        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)

        b1w = xB1_(s,null,xmw2,0)
        b1z = xB1_(s,null,xmz2,0)
        b1a = xB1_(s,null,null,0)

c        xseff_r = -alpha/4d0/pi*(
c     &            +qf**2*xsw2/xcw2*(2d0*B1z+1d0) 
c     &		  +qf**2*(2d0*B1a+1d0) )
        xseff_l = -alpha/4d0/pi*(
     &            +(-qf*xsw/xcw+sgni3f/2d0/xsw/xcw)**2*(2d0*B1z+1d0)
     &            +1d0/2d0/xsw2*(2d0*B1w+1d0) 
     &		  +qf**2*(2d0*B1a+1d0) )

	end

************************************************************************
        subroutine xcalcrenc
************************************************************************
*	calculate renormalization constants
*	bosonic loops only
*	conventional formalism
*-----------------------------------------------------------------------
*       23.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 xseww,seaa,seaz,sezz
	complex*16 xB0_,B00H,B00W,B00Z,BW0W,BWWZ,BWHW,BZWW,BZHZ
	complex*16 xB1_,B1Z,B1W
	complex*16 xDB0_,xDB1_,DBW0W,DBWWZ,DBWHW,DBZWW,DBZHZ,DB0WW
	complex*16 DB00W,DB0HW,DB0WZ,BHWW,BHZZ,DBHHH,DBHWW,DBHZZ
	complex*16 seww0
	complex*16 guu,gdd,gnn,gll     
	complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
	complex*16 dZuur,dZuul,dZddr,dZddl,dZnnr,dZnnl,dZllr,dZlll
	complex*16 ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl
	complex*16 ct_wnl,ct_znnr,ct_znnl,ct_zllr,ct_zlll
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
	complex*16 dalpz,drbos,drferm
	complex*16 v,cv
	integer i,qalp

	common/rscheme/dalpz,drbos,drferm,qalp
        COMMON/UV/MUDIM2
        COMMON/IR/LAMBDA,LAMBDA2
	common/xrenc/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &	       dZuur,dZuul,dZddr,dZddl,dZnnr,dZnnl,dZllr,dZlll,
     &	       ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl,
     &	       ct_wnl,ct_znnr,ct_znnl,ct_zllr,ct_zlll
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/qf/qu,qd,ql,qn,qf(4),mu,mu2,md,md2,mlep,mlep2,
     &            guu(-1:1),gdd(-1:1),gnn(-1:1),gll(-1:1)

	B00H  = xB0_(0d0,null,xmh2,0)
	B00W  = xB0_(0d0,null,xmw2,0)
	B00Z  = xB0_(0d0,null,xmz2,0)
	BW0W  = xB0_(mw2,null,xmw2,0)
	BWWZ  = xB0_(mw2,xmw2,xmz2,0)
	BWHW  = xB0_(mw2,xmh2,xmw2,0)
	BZWW  = xB0_(mz2,xmw2,xmw2,0)
	BZHZ  = xB0_(mz2,xmh2,xmz2,0)
	DBW0W = xDB0_(mw2,null,xmw2,0)
	DBWHW = xDB0_(mw2,xmh2,xmw2,0)
	DBWWZ = xDB0_(mw2,xmw2,xmz2,0)
	DBZHZ = xDB0_(mz2,xmh2,xmz2,0)
	DBZWW = xDB0_(mz2,xmw2,xmw2,0)
	DB0WW = xDB0_(0d0,xmw2,xmw2,0)
	DB00W = xDB0_(0d0,null,xmw2,0)
	DB0HW = xDB0_(0d0,xmh2,xmw2,0)
	DB0WZ = xDB0_(0d0,xmw2,xmz2,0)
        B1W   = xB1_(0D0,null,xMW2,0)
        B1Z   = xB1_(0D0,null,xMZ2,0)
	BHWW  = xB0_(mh2,XMW2,XMW2,0)
	BHZZ  = xB0_(mh2,XMZ2,XMZ2,0)
	DBHHH = xDB0_(mh2,XMH2,XMH2,0)
	DBHWW = xDB0_(mh2,XMW2,XMW2,0)
	DBHZZ = xDB0_(mh2,XMZ2,XMZ2,0)

	dmw2 = xseww(mw2)

	call xsevv(mz2,seaa,seaz,sezz)
	dmz2 = sezz
	dZaz = -2d0*seaz/mz2

	call xsevv(0d0,seaa,seaz,sezz)

	dZza = 2d0*seaz/xmz2

	dZaz = dZaz + (xmz2-mz2)/mz2*dZza

	dZaa = -ALPHA/(4D0*PI)*(3D0-3D0*B00W-4D0*xMW2*DB0WW)

	x = mw2
	dZw = -ALPHA/(144D0*PI)*(
     &	-(4D0/XSW2)+(3D0*X**(-2)*XMH2*(XMH2-XMW2)*B00H)/XSW2
     &	-(3D0*X**(-2)*XMW2*(XMH2-2D0*XMW2+XMZ2)*B00W)/XSW2
     &	-(3D0*X**(-2)*(1D0+8D0*XCW2)*XMZ2*(XMW2-XMZ2)*B00Z)/XSW2
     &	-24D0*X**(-2)*(5D0*X**2+XMW2**2)*BW0W
     &	+(3D0*X**(-2)*(X**2-XMH2**2+2D0*XMH2*XMW2-XMW2**2)*BWHW)/XSW2
     &	-3D0*X**(-2)*XMW2*XMZ2**(-2)*(8D0*XMW2**3-X**2*XMZ2
     &    -15D0*XMW2**2*XMZ2+XMZ2**3+XMW2*(40D0*X**2+6D0*XMZ2**2))*BWWZ
     &    /(XCW2*XSW2)
     &	+(24D0*(-(5D0*X**2)-2D0*X*XMW2+XMW2**2)*DBW0W)/X
     &	+3D0*(X**2+XMH2**2+10D0*X*XMW2+XMW2**2-2D0*XMH2*(X+XMW2))
     &    *DBWHW/(X*XSW2)
     &	+(3D0*XMW2*XMZ2**(-2)*(8D0*XMW2**3-XMW2**2*(16D0*X+15D0*XMZ2)
     &    +XMZ2*(X**2+10D0*X*XMZ2+XMZ2**2)+XMW2*(-(40D0*X**2)
     &    -54D0*X*XMZ2+6D0*XMZ2**2))*DBWWZ)/(X*XCW2*XSW2)
     &	)

	x = mz2
	dZzz = -ALPHA/(144D0*PI*XCW2*XSW2)*(
     &	-(4D0*(1D0-2D0*XSW2))
     &	+3D0*X**(-2)*XMH2*(XMH2-XMZ2)*B00H
     &	-3D0*X**(-2)*XMZ2*(XMH2-XMZ2)*B00Z
     &	+3D0*X**(-2)*(X**2-XMH2**2+2D0*XMH2*XMZ2-XMZ2**2)*BZHZ
     &	-3D0*(39D0-76D0*XSW2+36D0*XSW2**2)*BZWW
     &	+(3D0*(X**2+XMH2**2+10D0*X*XMZ2+XMZ2**2-2D0*XMH2*(X+XMZ2))
     &	  *DBZHZ)/X
     &	-3D0*(4D0*XMW2*(15D0-32D0*XSW2+12D0*XSW2**2)
     &	  +X*(39D0-76D0*XSW2+36D0*XSW2**2))*DBZWW)

	x = mh2
	dZh = -ALPHA/(32D0*PI*XCW2*XSW2)*(
     &	-8D0*XMW2/XMZ2*BHWW - 4D0*BHZZ + 9D0*XMH**4/XMZ2*DBHHH
     &	+2D0*(XMH**4-4D0*X*XMW2+12D0*XMW**4)/XMZ2*DBHWW
     &  +(XMH**4-4D0*X*XMZ2+12D0*XMZ**4)/XMZ2*DBHZZ	)

	seww0 =  ALPHA/(48D0*PI)*(
     &	-2D0/xCW2/xSW2*(xMH2+19D0*xMW2-xMH2*xSW2-18D0*xMW2*xSW2)
     &  +8D0*xMH2*xMW2/xSW2*B00H/(xMH2-xMW2)
     &	+4D0*xMW2/xSW**4*(15D0*xMH2-15D0*xMW2-16D0*xMH2*xSW2
     &   +14D0*xMW2*xSW2)*B00W/(xMH2-xMW2)
     &	-4D0/xCW2*xMW2/xSW**4*(5D0-2D0*xSW2)*(3D0-4D0*xSW2)*B00Z
     & 	+8D0*xMW**4*DB00W+(xMH2-xMW2)**2/xSW2*DB0HW
     &	+xMW**4/xCW**4*xSW2*(9D0-8D0*xSW2)*DB0WZ	)

c modifications for complex renormalization
        dmw2 = dmw2 - (xmw2-mw2)*dZw
c     term from non-analyticity of Wgamma diagram
        dmw2 = dmw2 + dcmplx(0d0,mw*gw*alpha/pi)
        dmz2 = dmz2 - (xmz2-mz2)*dZzz

c dependent parameters
        dsw  = xcw2/2d0/xsw*( dmz2/xmz2 - dmw2/xmw2 )

	drbos = -dZaa-2d0*dsw/xsw+(seww0-dmw2)/xmw2+xcw/xsw*dZza
     &		+alpha/4d0/pi/xsw2*(6d0+(7d0-4d0*xsw2)
     &			/2d0/xsw2*log(xcw2))

	if ((qalp.eq.0).or.(qalp.eq.1)) then
	  dZe = -dZaa/2d0-dZza*xsw/2d0/xcw
	elseif (qalp.eq.2) then
	  dZe = -dZaa/2d0-dZza*xsw/2d0/xcw - drbos/2d0
	endif

	dZuur   = -ALPHA/4D0/PI*qu**2*( log(mudim2/mu2)+4d0
     &		  	               +4d0*log(lambda/mu) ) 
     &		  +ALPHA/4D0/PI*guu(+1)**2*(2D0*B1Z+1D0) 
	dZuul   = -ALPHA/4D0/PI*qu**2*( log(mudim2/mu2)+4d0
     &		  	               +4d0*log(lambda/mu) ) 
     &		  +ALPHA/4D0/PI*( guu(-1)**2*(2D0*B1Z+1D0)
     &              		 +(2D0*B1W+1D0)/2D0/xSW2   )
	dZddr   = -ALPHA/4D0/PI*qd**2*( log(mudim2/md2)+4d0
     &		  	               +4d0*log(lambda/md) ) 
     &		  +ALPHA/4D0/PI*gdd(+1)**2*(2D0*B1Z+1D0) 
	dZddl   = -ALPHA/4D0/PI*qd**2*( log(mudim2/md2)+4d0
     &		  	               +4d0*log(lambda/md) ) 
     &		  +ALPHA/4D0/PI*( gdd(-1)**2*(2D0*B1Z+1D0)
     &              		 +(2D0*B1W+1D0)/2D0/xSW2   )

	dZnnr   = 0d0
	dZnnl   = +ALPHA/4D0/PI*( gnn(-1)**2*(2D0*B1Z+1D0)
     &              		 +(2D0*B1W+1D0)/2D0/xSW2   )
	dZllr   = -ALPHA/4D0/PI*ql**2*( log(mudim2/mlep2)+4d0
     &		  	               +4d0*log(lambda/mlep) ) 
     &		  +ALPHA/4D0/PI*gll(+1)**2*(2D0*B1Z+1D0) 
	dZlll   = -ALPHA/4D0/PI*ql**2*( log(mudim2/mlep2)+4d0
     &		  	               +4d0*log(lambda/mlep) ) 
     &		  +ALPHA/4D0/PI*( gll(-1)**2*(2D0*B1Z+1D0)
     &              		 +(2D0*B1W+1D0)/2D0/xSW2   )

c*** vertex counterterms
	ct_hww  = dZe-dsw/xsw+dmw2/xmw2/2d0+dZw+dZh/2d0
	ct_hzz  = dZe+(2d0*xsw2/xcw2-1d0)*dsw/xsw
     &	 	  +dmw2/xmw2/2d0+dZzz+dZh/2d0
	ct_wud  = dZe-dsw/xsw+(dZw+dZuul+dZddl)/2d0
	ct_zuur = dZe+dsw/xsw/xcw2+dZzz/2d0+dZuur+dZaz/2d0/xsw*xcw
	ct_zuul = dZe+dsw/xsw/xcw2-1d0/xsw2/xcw*dsw/guu(-1)
     &			+dZzz/2d0+dZuul-qu*dZaz/2d0/guu(-1)
	ct_zddr = dZe+dsw/xsw/xcw2+dZzz/2d0+dZddr+dZaz/2d0/xsw*xcw
	ct_zddl = dZe+dsw/xsw/xcw2+1d0/xsw2/xcw*dsw/gdd(-1)
     &			+dZzz/2d0+dZddl-qd*dZaz/2d0/gdd(-1)

	ct_wnl  = dZe-dsw/xsw+(dZw+dZnnl+dZlll)/2d0
	ct_znnr = 0d0
	ct_znnl = dZe+dsw/xsw/xcw2-1d0/xsw2/xcw*dsw/gnn(-1)
     &			+dZzz/2d0+dZnnl
	ct_zllr = dZe+dsw/xsw/xcw2+dZzz/2d0+dZllr+dZaz/2d0/xsw*xcw
	ct_zlll = dZe+dsw/xsw/xcw2+1d0/xsw2/xcw*dsw/gll(-1)
     &			+dZzz/2d0+dZlll-ql*dZaz/2d0/gll(-1)

	end

************************************************************************
        subroutine xcalcrenc_bgf
************************************************************************
*	calculate renormalization constants
*	bosonic loops only
*	background-field formalism
*-----------------------------------------------------------------------
*       23.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 xseww_bgf,seaa,seaz,sezz,dZff_a 
	complex*16 xB0_,B00H,B00W,B00Z,BW0W,BWWZ,BWHW,BZWW,BZHZ
	complex*16 xB1_,B1Z,B1W
	complex*16 xDB0_,DBW0W,DBWWZ,DBWHW,DBZWW,DBZHZ,DB0WW
	complex*16 DB00W,DB0HW,DB0WZ,BHWW,BHZZ,DBHHH,DBHWW,DBHZZ
	complex*16 seww0conv
	complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
	complex*16 dZuur,dZuul,dZddr,dZddl,dZnnr,dZnnl,dZllr,dZlll
	complex*16 ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl
	complex*16 ct_wnl,ct_znnr,ct_znnl,ct_zllr,ct_zlll
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
	complex*16 dalpz,drbos,drferm
	complex*16 v,cv
	complex*16 guu,gdd,gnn,gll     
	integer i,qalp

	common/rscheme/dalpz,drbos,drferm,qalp
        COMMON/UV/MUDIM2
        COMMON/IR/LAMBDA,LAMBDA2
	common/xrenc_bgf/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &	       dZuur,dZuul,dZddr,dZddl,dZnnr,dZnnl,dZllr,dZlll,
     &	       ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl,
     &	       ct_wnl,ct_znnr,ct_znnl,ct_zllr,ct_zlll
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/qf/qu,qd,ql,qn,qf(4),mu,mu2,md,md2,mlep,mlep2,
     &            guu(-1:1),gdd(-1:1),gnn(-1:1),gll(-1:1)

	B00H  = xB0_(0d0,null,xmh2,0)
	B00W  = xB0_(0d0,null,xmw2,0)
	B00Z  = xB0_(0d0,null,xmz2,0)
	BW0W  = xB0_(mw2,null,xmw2,0)
	BWWZ  = xB0_(mw2,xmw2,xmz2,0)
	BWHW  = xB0_(mw2,xmh2,xmw2,0)
	BZWW  = xB0_(mz2,xmw2,xmw2,0)
	BZHZ  = xB0_(mz2,xmh2,xmz2,0)
	DBW0W = xDB0_(mw2,null,xmw2,0)
	DBWHW = xDB0_(mw2,xmh2,xmw2,0)
	DBWWZ = xDB0_(mw2,xmw2,xmz2,0)
	DBZHZ = xDB0_(mz2,xmh2,xmz2,0)
	DBZWW = xDB0_(mz2,xmw2,xmw2,0)
	DB0WW = xDB0_(0d0,xmw2,xmw2,0)
	DB00W = xDB0_(0d0,null,xmw2,0)
	DB0HW = xDB0_(0d0,xmh2,xmw2,0)
	DB0WZ = xDB0_(0d0,xmw2,xmz2,0)
        B1W   = xB1_(0D0,null,xMW2,0)
        B1Z   = xB1_(0D0,null,xMZ2,0)
	BHWW  = xB0_(mh2,XMW2,XMW2,0)
	BHZZ  = xB0_(mh2,XMZ2,XMZ2,0)
	DBHHH = xDB0_(mh2,XMH2,XMH2,0)
	DBHWW = xDB0_(mh2,XMW2,XMW2,0)
	DBHZZ = xDB0_(mh2,XMZ2,XMZ2,0)

	dmw2 = xseww_bgf(mw2)

	call xsevv_bgf(mz2,seaa,seaz,sezz)
	dmz2 = sezz
	dZaz = -2d0*seaz/mz2
	dZza = 0d0

	dZaz = dZaz + (xmz2-mz2)/mz2*dZza

	dZaa = -ALPHA/(4D0*PI)*(3D0-3D0*B00W-4D0*xMW2*DB0WW
     &  			+4d0*(1D0-B00W) )

	x = mw2
	dZw = -ALPHA/(144D0*PI)*(
     &	-(4D0/XSW2)+(3D0*X**(-2)*XMH2*(XMH2-XMW2)*B00H)/XSW2
     &	-(3D0*X**(-2)*XMW2*(XMH2-2D0*XMW2+XMZ2)*B00W)/XSW2
     &	-(3D0*X**(-2)*(1D0+8D0*XCW2)*XMZ2*(XMW2-XMZ2)*B00Z)/XSW2
     &	-24D0*X**(-2)*(5D0*X**2+XMW2**2)*BW0W
     &	+(3D0*X**(-2)*(X**2-XMH2**2+2D0*XMH2*XMW2-XMW2**2)*BWHW)/XSW2
     &	-3D0*X**(-2)*XMW2*XMZ2**(-2)*(8D0*XMW2**3-X**2*XMZ2
     &    -15D0*XMW2**2*XMZ2+XMZ2**3+XMW2*(40D0*X**2+6D0*XMZ2**2))*BWWZ
     &    /(XCW2*XSW2)
     &	+(24D0*(-(5D0*X**2)-2D0*X*XMW2+XMW2**2)*DBW0W)/X
     &	+3D0*(X**2+XMH2**2+10D0*X*XMW2+XMW2**2-2D0*XMH2*(X+XMW2))
     &    *DBWHW/(X*XSW2)
     &	+(3D0*XMW2*XMZ2**(-2)*(8D0*XMW2**3-XMW2**2*(16D0*X+15D0*XMZ2)
     &    +XMZ2*(X**2+10D0*X*XMZ2+XMZ2**2)+XMW2*(-(40D0*X**2)
     &    -54D0*X*XMZ2+6D0*XMZ2**2))*DBWWZ)/(X*XCW2*XSW2)
     &  -144d0*(xSW2*BW0W+xCW2*BWWZ)/xSW2		)

	x = mz2
	dZzz = -ALPHA/(144D0*PI*XCW2*XSW2)*(
     &	-(4D0*(1D0-2D0*XSW2))
     &	+3D0*X**(-2)*XMH2*(XMH2-XMZ2)*B00H
     &	-3D0*X**(-2)*XMZ2*(XMH2-XMZ2)*B00Z
     &	+3D0*X**(-2)*(X**2-XMH2**2+2D0*XMH2*XMZ2-XMZ2**2)*BZHZ
     &	-3D0*(39D0-76D0*XSW2+36D0*XSW2**2)*BZWW
     &	+(3D0*(X**2+XMH2**2+10D0*X*XMZ2+XMZ2**2-2D0*XMH2*(X+XMZ2))
     &	  *DBZHZ)/X
     &	-3D0*(4D0*XMW2*(15D0-32D0*XSW2+12D0*XSW2**2)
     &	  +X*(39D0-76D0*XSW2+36D0*XSW2**2))*DBZWW
     &  -144d0*xCW2**2*BZWW	)

	x = mh2
	dZh = -ALPHA/(32D0*PI*XCW2*XSW2)*(
     &	-8D0*XMW2/XMZ2*BHWW - 4D0*BHZZ + 9D0*XMH**4/XMZ2*DBHHH
     &	+2D0*(XMH**4-4D0*X*XMW2+12D0*XMW**4)/XMZ2*DBHWW
     &  +(XMH**4-4D0*X*XMZ2+12D0*XMZ**4)/XMZ2*DBHZZ	)
     &  +ALPHA/XCW2/XSW2/(8D0*PI)*(
     &		2D0*XCW2*BHWW+BHZZ
     &         -(-X+XMH2)*(2D0*XCW2*DBHWW+DBHZZ)	)

	seww0conv =  ALPHA/(48D0*PI)*(
     &	-2D0/xCW2/xSW2*(xMH2+19D0*xMW2-xMH2*xSW2-18D0*xMW2*xSW2)
     &  +8D0*xMH2*xMW2/xSW2*B00H/(xMH2-xMW2)
     &	+4D0*xMW2/xSW**4*(15D0*xMH2-15D0*xMW2-16D0*xMH2*xSW2
     &   +14D0*xMW2*xSW2)*B00W/(xMH2-xMW2)
     &	-4D0/xCW2*xMW2/xSW**4*(5D0-2D0*xSW2)*(3D0-4D0*xSW2)*B00Z
     & 	+8D0*xMW**4*DB00W+(xMH2-xMW2)**2/xSW2*DB0HW
     &	+xMW**4/xCW**4*xSW2*(9D0-8D0*xSW2)*DB0WZ	)

c modifications for complex renormalization
        dmw2 = dmw2 - (xmw2-mw2)*dZw
c     term from non-analyticity of Wgamma diagram
        dmw2 = dmw2 + dcmplx(0d0,mw*gw*alpha/pi)
        dmz2 = dmz2 - (xmz2-mz2)*dZzz

c dependent parameters
        dsw  = xcw2/2d0/xsw*( dmz2/xmz2 - dmw2/xmw2 )

	drbos = -dZaa-2d0*dsw/xsw+(seww0conv-dmw2)/xmw2
     &          +alpha/pi/xsw2*(-1d0+B00w)
     &		+alpha/4d0/pi/xsw2*(6d0+(7d0-4d0*xsw2)
     &			/2d0/xsw2*log(xcw2))

	if ((qalp.eq.0).or.(qalp.eq.1)) then
	  dZe = -dZaa/2d0
	elseif (qalp.eq.2) then
	  dZe = -dZaa/2d0 - drbos/2d0
	endif

	dZuur   = -ALPHA/4D0/PI*qu**2*( log(mudim2/mu2)+4d0
     &		  	               +4d0*log(lambda/mu) ) 
     &		  +ALPHA/4D0/PI*guu(+1)**2*(2D0*B1Z+1D0) 
	dZuul   = -ALPHA/4D0/PI*qu**2*( log(mudim2/mu2)+4d0
     &		  	               +4d0*log(lambda/mu) ) 
     &		  +ALPHA/4D0/PI*( guu(-1)**2*(2D0*B1Z+1D0)
     &              		 +(2D0*B1W+1D0)/2D0/xSW2   )
	dZddr   = -ALPHA/4D0/PI*qd**2*( log(mudim2/md2)+4d0
     &		  	               +4d0*log(lambda/md) ) 
     &		  +ALPHA/4D0/PI*gdd(+1)**2*(2D0*B1Z+1D0) 
	dZddl   = -ALPHA/4D0/PI*qd**2*( log(mudim2/md2)+4d0
     &		  	               +4d0*log(lambda/md) ) 
     &		  +ALPHA/4D0/PI*( gdd(-1)**2*(2D0*B1Z+1D0)
     &              		 +(2D0*B1W+1D0)/2D0/xSW2   )

	dZnnr   = 0d0
	dZnnl   = +ALPHA/4D0/PI*( gnn(-1)**2*(2D0*B1Z+1D0)
     &              		 +(2D0*B1W+1D0)/2D0/xSW2   )
	dZllr   = -ALPHA/4D0/PI*ql**2*( log(mudim2/mlep2)+4d0
     &		  	               +4d0*log(lambda/mlep) ) 
     &		  +ALPHA/4D0/PI*gll(+1)**2*(2D0*B1Z+1D0) 
	dZlll   = -ALPHA/4D0/PI*ql**2*( log(mudim2/mlep2)+4d0
     &		  	               +4d0*log(lambda/mlep) ) 
     &		  +ALPHA/4D0/PI*( gll(-1)**2*(2D0*B1Z+1D0)
     &              		 +(2D0*B1W+1D0)/2D0/xSW2   )

c*** vertex counterterms
	ct_hww  = dZe-dsw/xsw+dmw2/xmw2/2d0+dZw+dZh/2d0
	ct_hzz  = dZe+(2d0*xsw2/xcw2-1d0)*dsw/xsw
     &	 	  +dmw2/xmw2/2d0+dZzz+dZh/2d0
	ct_wud  = dZe-dsw/xsw+(dZw+dZuul+dZddl)/2d0
	ct_zuur = dZe+dsw/xsw/xcw2+dZzz/2d0+dZuur+dZaz/2d0/xsw*xcw
	ct_zuul = dZe+dsw/xsw/xcw2-1d0/xsw2/xcw*dsw/guu(-1)
     &			+dZzz/2d0+dZuul-qu*dZaz/2d0/guu(-1)
	ct_zddr = dZe+dsw/xsw/xcw2+dZzz/2d0+dZddr+dZaz/2d0/xsw*xcw
	ct_zddl = dZe+dsw/xsw/xcw2+1d0/xsw2/xcw*dsw/gdd(-1)
     &			+dZzz/2d0+dZddl-qd*dZaz/2d0/gdd(-1)

	end

**********************************************************************
	function xseww_ferm(s)
**********************************************************************
*	unrenormalized W self-energy
*	closed fermion loops only
*--------------------------------------------------------------------- 
*	28.5.04 Stefan Dittmaier
**********************************************************************
	implicit real*8 (a-z)
	complex*16 xseww_ferm,xB0_,xdB0_
	complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
	complex*16 v,cv
        integer i

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)

	xseww_ferm = 0d0

	if (s.ne.0d0) then

	do 10 i=1,3
	xseww_ferm = xseww_ferm - ALPHA/PI/xsw2/72D0*(
     &  8D0*S-6D0*xML2(I)-18D0*xMQM2(I)-18D0*xMQP2(I)
     &	-3D0*xB0_(0D0,null,xML2(I),0)*xML2(I)*(-2D0*S+xML2(I))/S
     &	+(3D0*xB0_(S,null,xML2(I),0)*(-S+xML2(I))*(2D0*S+xML2(I)))/S
     &	-9D0*xB0_(0D0,null,xMQM2(I),0)*xMQM2(I)
     &		*(-2D0*S+xMQM2(I)-xMQP2(I))/S
     &	+9D0*xB0_(0D0,null,xMQP2(I),0)*xMQP2(I)
     &		*(2D0*S+xMQM2(I)-xMQP2(I))/S
     &	+9D0*xB0_(S,xMQM2(I),xMQP2(I),0)*(-2D0*S**2+S*xMQM2(I)
     &	    +xMQM(I)**4+S*xMQP2(I)-2D0*xMQM2(I)*xMQP2(I)+xMQP(I)**4)/S )
10	continue

	else

	do 20 i=1,3
        xseww_ferm = xseww_ferm - ALPHA/(24D0*PI*xsw2)*(
     &  -6D0*xmqm2(i)-2D0*xml2(i)-6D0*xmqp2(i)
     &  +6D0*xmqm2(i)*xB0_(0d0,null,xmqm2(i),0)
     &	+3D0*xml2(i)*xB0_(0d0,null,xml2(i),0)
     &	+6D0*xmqp2(i)*xB0_(0d0,null,xmqp2(i),0)
     &  +3D0*(xmqm2(i)+xmqp2(i))*xB0_(0d0,xmqm2(i),xmqp2(i),0)
     &  +xml(i)**4*xDB0_(0d0,null,xml2(i),0)
     &	+3D0*(xmqm2(i)-xmqp2(i))**2*DB0_(0d0,xmqm2(i),xmqp2(i),0)  )
20	continue

	endif

	end

**********************************************************************
        subroutine xsevv_ferm(s,xseaa,xseaz,xsezz)
**********************************************************************
*       unrenormalized neutral boson self-energies
*       closed fermion loops only
*---------------------------------------------------------------------
*	28.5.04 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 xseaa,xseaz,xsezz
        complex*16 xB0_,B00l,B00u,B00d,Bsll,SBs00,Bsuu,Bsdd
	complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
	complex*16 v,cv
        integer i

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)

        xseaa   = 0d0
        xseaz   = 0d0
        xsezz   = 0d0

	if (s.ne.0d0) then
          SBs00 = S*xB0_(S,null,null,0)
	else
	  SBs00 = 0d0
	endif

        do 100 i=1,3

        B00l = xB0_(0D0,null,xml2(i),0)
        B00u = xB0_(0D0,null,xmqp2(i),0)
        B00d = xB0_(0D0,null,xmqm2(i),0)
        Bsll = xB0_(S,xml2(i),xml2(i),0)
        Bsuu = xB0_(S,xmqp2(i),xmqp2(i),0)
        Bsdd = xB0_(S,xmqm2(i),xmqm2(i),0)

        xseaa = xseaa -ALPHA/(27D0*PI)*(
     &  -2D0*(3D0*xmqm2(i)+9D0*xml2(i)+12D0*xmqp2(i)-4D0*S)
     &  +6D0*xmqm2(i)*B00d+18D0*xml2(i)*B00l+24D0*xmqp2(i)*B00u
     &  -3D0*(2D0*xmqm2(i)+S)*Bsdd-9D0*(2D0*xml2(i)+S)*Bsll
     &  -12D0*(2D0*xmqp2(i)+S)*Bsuu)

        xseaz = xseaz -ALPHA/(108D0*xcw*PI)*(
     &  32D0*S*xsw-12D0*S/xsw-72D0*xsw*xML2(I)+18D0*xML2(I)/xsw
     &  -24D0*xsw*xMQM2(I)+18D0*xMQM2(I)/xsw
     &	-96D0*xsw*xMQP2(I)+36D0*xMQP2(I)/xsw
     &  -18D0*(1D0-4D0*xsw2)*B00l*xML2(I)/xsw
     &  + 9D0*(1D0-4D0*xsw2)*Bsll*(S+2D0*xML2(I))/xsw
     &  - 6D0*(3D0-4D0*xsw2)*B00d*xMQM2(I)/xsw
     &  + 3D0*(3D0-4D0*xsw2)*Bsdd*(S+2D0*xMQM2(I))/xsw
     &  -12D0*(3D0-8D0*xsw2)*B00u*xMQP2(I)/xsw
     &  + 6D0*(3D0-8D0*xsw2)*Bsuu*(S+2D0*xMQP2(I))/xsw )

        xsezz = xsezz + ALPHA/(216D0*xcw2*PI)*(
     &  48D0*S-64D0*S*xsw2-24D0*S/xsw2
     &  -72D0*xML2(I)+144D0*xsw2*xML2(I)+18D0*xML2(I)/xsw2
     &  -72D0*xMQM2(I)+48D0*xsw2*xMQM2(I)+54D0*xMQM2(I)/xsw2
     &  -144D0*xMQP2(I)+192D0*xsw2*xMQP2(I)+54D0*xMQP2(I)/xsw2
     &  +9D0*SBs00/xsw2
     &  -18D0*(1D0+8D0*xsw**4-4D0*xsw2)*B00l*xML2(I)/xsw2
     &  -9D0*Bsll*(-S-8D0*S*xsw**4+4D0*S*xsw2
     &    +xML2(I)-16D0*xsw**4*xML2(I)+8D0*xsw2*xML2(I))/xsw2
     &  -6D0*(9D0+8D0*xsw**4-12D0*xsw2)*B00d*xMQM2(I)/xsw2
     &  +3D0*Bsdd*(9D0*S+8D0*S*xsw**4-12D0*S*xsw2
     &    -9D0*xMQM2(I)+16D0*xsw**4*xMQM2(I)-24D0*xsw2*xMQM2(I))/xsw2
     &  -6D0*(9D0+32D0*xsw**4-24D0*xsw2)*B00u*xMQP2(I)/xsw2
     &  +3D0*Bsuu*(9D0*S+32D0*S*xsw**4-24D0*S*xsw2
     &    -9D0*xMQP2(I)+64D0*xsw**4*xMQP2(I)-48D0*xsw2*xMQP2(I))/xsw2 )

100	continue

	end

************************************************************************
        subroutine xcalcrenc_ferm
************************************************************************
*	calculate renormalization constants
*	fermion-loop contributions only
*-----------------------------------------------------------------------
*       28.5.04 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 xseww_ferm,xseaa,xseaz,xsezz
	complex*16 xB0_,xDB0_
	complex*16 B00l,B00u,B00d,B0du,BWnl,BWud,BZ00,BZll,BZdd,BZuu  
	complex*16 DBWnl,DBWud,DBZ00,DBZll,DBZdd,DBZuu
	complex*16 DB0ll,DB0dd,DB0uu,DB00l,DB0du,seww0 
	complex*16 BHuu,BHdd,BHll,DBHuu,DBHdd,DBHll 
	complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
	complex*16 dZuur,dZuul,dZddr,dZddl,dZnnr,dZnnl,dZllr,dZlll
	complex*16 ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl
	complex*16 ct_wnl,ct_znnr,ct_znnl,ct_zllr,ct_zlll
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
	complex*16 dalpz,drbos,drferm
	complex*16 v,cv
	complex*16 guu,gdd,gnn,gll     
	real*8 iw3f(4)
	integer i,qalp

	common/xrenc_ferm/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &	       dZuur,dZuul,dZddr,dZddl,dZnnr,dZnnl,dZllr,dZlll,
     &	       ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl,
     &	       ct_wnl,ct_znnr,ct_znnl,ct_zllr,ct_zlll
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
	common/rscheme/dalpz,drbos,drferm,qalp
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/qf/qu,qd,ql,qn,qf(4),mu,mu2,md,md2,mlep,mlep2,
     &            guu(-1:1),gdd(-1:1),gnn(-1:1),gll(-1:1)

	dmw2  = 0d0
	dmz2  = 0d0
	dZw   = 0d0
	dZzz  = 0d0
	dZaa  = 0d0
	dZza  = 0d0
	dZaz  = 0d0
	dZh   = 0d0
	dalpz = 0d0
	seww0 = 0d0

	do 10 i=1,3

	B00l  =  xB0_(0D0,    null, xML2(I),0)
	B00u  =  xB0_(0D0,    null,xMQP2(I),0)
	B00d  =  xB0_(0D0,    null,xMQM2(I),0)
	B0du  =  xB0_(0D0,xMQM2(I),xMQP2(I),0)
	BWnl  =  xB0_(MW2,    null, xML2(I),0)
	BWud  =  xB0_(MW2,xMQP2(I),xMQM2(I),0)
	DBWnl = xDB0_(MW2,    null, xML2(I),0)
	DBWud = xDB0_(MW2,xMQP2(I),xMQM2(I),0)
	BZ00  =  xB0_(MZ2,    null,    null,0)
	BZll  =  xB0_(MZ2, xML2(I), xML2(I),0)
	BZdd  =  xB0_(MZ2,xMQM2(I),xMQM2(I),0)
	BZuu  =  xB0_(MZ2,xMQP2(I),xMQP2(I),0)
	DBZ00 = xDB0_(MZ2,    null,    null,0)
	DBZll = xDB0_(MZ2, xML2(I), xML2(I),0)
	DBZdd = xDB0_(MZ2,xMQM2(I),xMQM2(I),0)
	DBZuu = xDB0_(MZ2,xMQP2(I),xMQP2(I),0)
	BHuu  =  xB0_(MH2,xMQP2(I),xMQP2(I),0)
	BHdd  =  xB0_(MH2,xMQM2(I),xMQM2(I),0)
	BHll  =  xB0_(MH2,xML2(I),xML2(I),0)
	DBHuu =  xDB0_(MH2,xMQP2(I),xMQP2(I),0)
	DBHdd =  xDB0_(MH2,xMQM2(I),xMQM2(I),0) 
	DBHll =  xDB0_(MH2,xML2(I),xML2(I),0) 
	DB0ll = xDB0_(0d0, xML2(I), xML2(I),0)
	DB0dd = xDB0_(0d0,xMQM2(I),xMQM2(I),0)
	DB0uu = xDB0_(0d0,xMQP2(I),xMQP2(I),0)
	DB00l = xDB0_(0d0,    null, xML2(I),0)
	DB0du = xDB0_(0d0,xMQM2(I),xMQP2(I),0)

	dZw   = dZw  + ALPHA/(72D0*PI*xSW2)*(
     &	8D0 + 3D0*MW2**(-2)*B00l*xML2(I)**2
     & 	+3D0*DBWnl*(-MW2+xML2(I))*(2D0*MW2+xML2(I))/MW2
     &  -3D0*MW2**(-2)*BWnl*(2D0*MW2**2+xML2(I)**2)
     & 	+9D0*MW2**(-2)*B00d*xMQM2(I)*(xMQM2(I)-xMQP2(I))
     & 	-9D0*MW2**(-2)*B00u*xMQP2(I)*(xMQM2(I)-xMQP2(I))
     &	-9D0*MW2**(-2)*BWud*(2D0*MW2**2+xMQM2(I)**2
     &			     -2D0*xMQM2(I)*xMQP2(I)+xMQP2(I)**2)
     &	+9D0*DBWud*(-2D0*MW2**2+MW2*xMQM2(I)+xMQM2(I)**2+MW2*xMQP2(I)
     &  	    -2D0*xMQM2(I)*xMQP2(I)+xMQP2(I)**2)/MW2	    )

	dZzz  = dZzz - ALPHA/(216D0*xCW2*PI)*(
     &	48D0-64D0*xSW2-24D0/xSW2
     &	+9D0*BZ00/xSW2
     &  +9D0*(1D0-4D0*xSW2+8D0*xSW2**2)*BZll/xSW2
     &  +3D0*(9D0-12D0*xSW2+8D0*xSW2**2)*BZdd/xSW2
     &  +3D0*(9D0-24D0*xSW2+32D0*xSW2**2)*BZuu/xSW2
     &	+9D0*MZ2*DBZ00/xSW2
     &	-9D0*DBZll*(-MZ2+4D0*MZ2*xSW2-8D0*MZ2*xSW2**2+xML2(I)
     &  	    +8D0*xSW2*xML2(I)-16D0*xSW2**2*xML2(I))/xSW2
     &	+3D0*DBZdd*(9D0*MZ2-12D0*MZ2*xSW2+8D0*MZ2*xSW2**2-9D0*xMQM2(I)
     &  	    -24D0*xSW2*xMQM2(I)+16D0*xSW2**2*xMQM2(I))/xSW2
     &	+3D0*DBZuu*(9D0*MZ2-24D0*MZ2*xSW2+32D0*MZ2*xSW2**2-9D0*xMQP2(I)
     &		    -48D0*xSW2*xMQP2(I)+64D0*xSW2**2*xMQP2(I))/xSW2   )

	dZaa  = dZaa - ALPHA/(27D0*PI)*(
     &	-32D0+9D0*B00l+3D0*B00d+12D0*B00u
     &	+18D0*DB0ll*xML2(I)+6D0*DB0dd*xMQM2(I)+24D0*DB0uu*xMQP2(I) )

        dZh = dZh
     &       +3D0*ALPHA*xMQP2(I)/xMW2/xSW2/8D0/PI
     &        *( -BHuu+(-MH2+4D0*xMQP2(I))*DBHuu )
     &       +3D0*ALPHA*xMQM2(I)/xMW2/xSW2/8D0/PI
     &        *( -BHdd+(-MH2+4D0*xMQM2(I))*DBHdd )
     &       +ALPHA*xML2(I)/xMW2/xSW2/8D0/PI
     &        *( -BHll+(-MH2+4D0*xML2(I))*DBHll )

	dalpz = dalpz + alpha/3d0/pi*dreal(
     & 	     ( 1d0/3d0+(1d0+2d0* xml2(i)/mz2)*(B00l-1d0-BZll) )
     & 	    +( 1d0/3d0+(1d0+2d0*xmqm2(i)/mz2)*(B00d-1d0-BZdd) )/3d0 )
	if (i.ne.3)
     &  dalpz = dalpz + alpha/3d0/pi*dreal(
     &     ( 1d0/3d0+(1d0+2d0*xmqp2(i)/mz2)*(B00u-1d0-BZuu) )*4d0/3d0 )

	seww0 = seww0 - ALPHA/(24D0*PI*xSW2)*(
     & 	-6D0*xmqm2(i)-2D0*xml2(i)-6D0*xmqp2(i)
     &	+6D0*xmqm2(i)*B00d+3D0*xml2(i)*B00l+6D0*xmqp2(i)*B00u
     &	+3D0*(xmqm2(i)+xmqp2(i))*B0du
     &	+xml(i)**4*DB00l+3D0*(xmqm2(i)-xmqp2(i))**2*DB0du	)

10	continue

	dmw2 = xseww_ferm(mw2)
        call xsevv_ferm(mz2,xseaa,xseaz,xsezz)
	dmz2 = xsezz
	dZaz = -2d0*xseaz/mz2
        call xsevv_ferm(0d0,xseaa,xseaz,xsezz)
	dZza = 0d0

c modifications for complex renormalization
	dmw2 = dmw2 - (xmw2-mw2)*dZw
	dmz2 = dmz2 - (xmz2-mz2)*dZzz
	dZaz = dZaz + (xmz2-mz2)/mz2*dZza

c dependent parameters
	dsw  = xcw2/2d0/xsw*( dmz2/xmz2 - dmw2/xmw2 )

	drferm = -dZaa-2d0*dsw/xsw+(seww0-dmw2)/xmw2

	if (qalp.eq.0) then
	  dZe = -dZaa/2d0 - dZza/2d0*xsw/xcw
	elseif (qalp.eq.1) then
	  dZe = -dZaa/2d0 - dZza/2d0*xsw/xcw - dalpz/2d0
	elseif (qalp.eq.2) then
	  dZe = -dZaa/2d0 - dZza/2d0*xsw/xcw - drferm/2d0
	endif

	dZuur = 0d0
	dZuul = 0d0
	dZddr = 0d0
	dZddl = 0d0
	dZnnr = 0d0
	dZnnl = 0d0
	dZllr = 0d0
	dZlll = 0d0

c*** vertex counterterms
	ct_hww  = dZe-dsw/xsw+dmw2/xmw2/2d0+dZw+dZh/2d0
	ct_hzz  = dZe+(2d0*xsw2/xcw2-1d0)*dsw/xsw
     &	 	  +dmw2/xmw2/2d0+dZzz+dZh/2d0
	ct_wud  = dZe-dsw/xsw+(dZw+dZuul+dZddl)/2d0
	ct_zuur = dZe+dsw/xsw/xcw2+dZzz/2d0+dZuur+dZaz/2d0/xsw*xcw
	ct_zuul = dZe+dsw/xsw/xcw2-1d0/xsw2/xcw*dsw/guu(-1)
     &			+dZzz/2d0+dZuul-qu*dZaz/2d0/guu(-1)
	ct_zddr = dZe+dsw/xsw/xcw2+dZzz/2d0+dZddr+dZaz/2d0/xsw*xcw
	ct_zddl = dZe+dsw/xsw/xcw2+1d0/xsw2/xcw*dsw/gdd(-1)
     &			+dZzz/2d0+dZddl-qd*dZaz/2d0/gdd(-1)

	ct_wnl  = dZe-dsw/xsw+(dZw+dZnnl+dZlll)/2d0
	ct_znnr = 0d0
	ct_znnl = dZe+dsw/xsw/xcw2-1d0/xsw2/xcw*dsw/gnn(-1)
     &			+dZzz/2d0+dZnnl
	ct_zllr = dZe+dsw/xsw/xcw2+dZzz/2d0+dZllr+dZaz/2d0/xsw*xcw
	ct_zlll = dZe+dsw/xsw/xcw2+1d0/xsw2/xcw*dsw/gll(-1)
     &			+dZzz/2d0+dZlll-ql*dZaz/2d0/gll(-1)

999     format(a10,2g26.16)
c        write(*,999) 'dmw2     = ',dmw2
c        write(*,999) 'dmz2     = ',dmz2
c        write(*,999) 'dsw      = ',dsw
c        write(*,999) 'dZe      = ',dZe
c        write(*,999) 'dZaa     = ',dZaa
c        write(*,999) 'dZza     = ',dZza
c        write(*,999) 'dZaz     = ',dZaz
c        write(*,999) 'dZzz     = ',dZzz
c        write(*,999) 'dZh      = ',dZh
c        write(*,999) 'dZw      = ',dZw
c	stop

	end

**********************************************************************
        subroutine wpdf_sd(x,mfact,pdf,pdf_phot,qpdf)
**********************************************************************
*       qpdf=1:  MRST2004QEDx with    O(alpha) effects
*       qpdf=2:  MRST2004QEDx without O(alpha) effects
*---------------------------------------------------------------------
*       6.1.06 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
c*** boundary for MRST2004QED
        data xmin,xmax,qsqmin,qsqmax/1d-5,1d0,1.25d0,1d7/
        real*8 pdf(-6:6)
	integer i,qpdf
c
        if (qpdf.eq.1) then
c*** MRST2004QED [with O(alpha) effects]
c    ===================================
          if ((x.lt.xmin).or.(x.gt.xmax)) then
	    do i=-6,6
       	    pdf(i) = 0d0
       	    enddo
            pdf_phot = 0d0
            return
          endif
          if (mfact**2.lt.qsqmin) mfact = sqrt(qsqmin)
          if (mfact**2.gt.qsqmax) mfact = sqrt(qsqmax)
          call mrstqed(x,mfact,1,
     &                  upv,dnv,usea,dsea,str,chm,bot,xglu,phot)
          pdf(0)   = xglu / x
          pdf(+1)  = (dnv+dsea) / x
          pdf(-1)  =     dsea / x
          pdf(+2)  = (upv+usea) / x
          pdf(-2)  =     usea / x
          pdf(+3)  = str / x
          pdf(-3)  = str / x
          pdf(+4)  = chm / x
          pdf(-4)  = chm / x
	  pdf_phot = phot / x
        elseif (qpdf.eq.2) then
c*** MRST2004QEDx [without O(alpha) effects]
c    =======================================
          if ((x.lt.xmin).or.(x.gt.xmax)) then
	    do i=-6,6
	      pdf(i) = 0d0
	    enddo
            pdf_phot = 0d0
            return
          endif
          if (mfact**2.lt.qsqmin) mfact = sqrt(qsqmin)
          if (mfact**2.gt.qsqmax) mfact = sqrt(qsqmax)
          call mrstqed(x,mfact,3,
     &                  upv,dnv,usea,dsea,str,chm,bot,xglu,phot)
          pdf(0)   = xglu / x
          pdf(+1)  = (dnv+dsea) / x
          pdf(-1)  =     dsea / x
          pdf(+2)  = (upv+usea) / x
          pdf(-2)  =     usea / x
          pdf(+3)  = str / x
          pdf(-3)  = str / x
          pdf(+4)  = chm / x
          pdf(-4)  = chm / x
	  pdf_phot = 0d0
	endif

	end

************************************************************************
        subroutine calcsmeH4f(mat,i1,i2,i3,i4)
************************************************************************
*       19.8.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 sp(-4:4,-4:4),csp(-4:4,-4:4),mat(13,-1:1,-1:1)
        real*8 vp(-4:4,-4:4)
        integer j,j1,j2,i1,i2,i3,i4

	common/prods3/sp,csp,vp

        do 201 j=1,13
        do 201 j1=-1,1,2
        do 201 j2=-1,1,2
	  mat(j,j1,j2) = 0d0
201     continue

        MAT(1,1,1) = 2D0*CSP(I1,I3)*SP(I2,I4)
        MAT(2,1,1) = 2D0*CSP(I1,I2)*CSP(I1,I3)*SP(I1,I2)*SP(I2,I4)
        MAT(3,1,1) = 2D0*CSP(I1,I3)*CSP(I3,I4)*SP(I2,I4)*SP(I3,I4)
        MAT(4,1,1) = 2D0*CSP(I1,I2)*CSP(I1,I3)*CSP(I3,I4)*SP(I1,I3)*
     &  SP(I2,I4)**2
        MAT(5,1,1) = CSP(I1,I3)**2*SP(I1,I4)*SP(I2,I3)
        MAT(6,1,1) = CSP(I1,I3)*CSP(I2,I3)*SP(I2,I3)*SP(I2,I4)
        MAT(7,1,1) = CSP(I1,I3)*CSP(I1,I4)*SP(I1,I4)*SP(I2,I4)
        MAT(8,1,1) = CSP(I1,I4)*CSP(I2,I3)*SP(I2,I4)**2
        MAT(9,1,1) = 8D0*CSP(I1,I3)**2*SP(I1,I4)*SP(I2,I3)
        MAT(10,1,1) = 8D0*CSP(I1,I3)*CSP(I2,I3)*SP(I2,I3)*SP(I2,I4)
        MAT(11,1,1) = 8D0*CSP(I1,I3)*CSP(I1,I4)*SP(I1,I4)*SP(I2,I4)
        MAT(12,1,1) = 8D0*CSP(I1,I3)*CSP(I2,I4)*SP(I2,I4)**2
        MAT(13,1,1) = 32D0*CSP(I1,I3)*SP(I2,I4)
        MAT(1,-1,1) = 2D0*CSP(I2,I3)*SP(I1,I4)
        MAT(5,-1,1) = CSP(I1,I3)*CSP(I2,I3)*SP(I1,I3)*SP(I1,I4)
        MAT(6,-1,1) = CSP(I2,I3)**2*SP(I1,I3)*SP(I2,I4)
        MAT(7,-1,1) = CSP(I1,I3)*CSP(I2,I4)*SP(I1,I4)**2
        MAT(8,-1,1) = CSP(I2,I3)*CSP(I2,I4)*SP(I1,I4)*SP(I2,I4)
        MAT(9,-1,1) = 4D0*CSP(I1,I3)*CSP(I2,I3)*SP(I1,I3)*SP(I1,I4)
        MAT(10,-1,1) = 4D0*CSP(I2,I3)**2*SP(I1,I3)*SP(I2,I4)
        MAT(11,-1,1) = 4D0*CSP(I1,I3)*CSP(I2,I4)*SP(I1,I4)**2
        MAT(12,-1,1) = 4D0*CSP(I2,I3)*CSP(I2,I4)*SP(I1,I4)*SP(I2,I4)
        MAT(13,-1,1) = 8D0*CSP(I2,I3)*SP(I1,I4)
        MAT(1,1,-1) = 2D0*CSP(I1,I4)*SP(I2,I3)
        MAT(5,1,-1) = CSP(I1,I3)*CSP(I1,I4)*SP(I1,I3)*SP(I2,I3)
        MAT(6,1,-1) = CSP(I1,I3)*CSP(I2,I4)*SP(I2,I3)**2
        MAT(7,1,-1) = CSP(I1,I4)**2*SP(I1,I3)*SP(I2,I4)
        MAT(8,1,-1) = CSP(I1,I4)*CSP(I2,I4)*SP(I2,I3)*SP(I2,I4)
        MAT(9,1,-1) = 4D0*CSP(I1,I3)*CSP(I1,I4)*SP(I1,I3)*SP(I2,I3)
        MAT(10,1,-1) = 4D0*CSP(I1,I3)*CSP(I2,I4)*SP(I2,I3)**2
        MAT(11,1,-1) = 4D0*CSP(I1,I4)**2*SP(I1,I3)*SP(I2,I4)
        MAT(12,1,-1) = 4D0*CSP(I1,I4)*CSP(I2,I4)*SP(I2,I3)*SP(I2,I4)
        MAT(13,1,-1) = 8D0*CSP(I1,I4)*SP(I2,I3)
        MAT(1,-1,-1) = 2D0*CSP(I2,I4)*SP(I1,I3)
        MAT(2,-1,-1) = 2D0*CSP(I1,I2)*CSP(I2,I4)*SP(I1,I2)*SP(I1,I3)
        MAT(3,-1,-1) = 2D0*CSP(I2,I4)*CSP(I3,I4)*SP(I1,I3)*SP(I3,I4)
        MAT(4,-1,-1) = 2D0*CSP(I1,I3)*CSP(I2,I4)**2*SP(I1,I2)*SP(I1,
     &  I3)*SP(I3,I4)
        MAT(5,-1,-1) = CSP(I1,I4)*CSP(I2,I3)*SP(I1,I3)**2
        MAT(6,-1,-1) = CSP(I2,I3)*CSP(I2,I4)*SP(I1,I3)*SP(I2,I3)
        MAT(7,-1,-1) = CSP(I1,I4)*CSP(I2,I4)*SP(I1,I3)*SP(I1,I4)
        MAT(8,-1,-1) = CSP(I2,I4)**2*SP(I1,I4)*SP(I2,I3)
        MAT(9,-1,-1) = 8D0*CSP(I1,I4)*CSP(I2,I3)*SP(I1,I3)**2
        MAT(10,-1,-1) = 8D0*CSP(I2,I3)*CSP(I2,I4)*SP(I1,I3)*SP(I2,
     &  I3)
        MAT(11,-1,-1) = 8D0*CSP(I1,I4)*CSP(I2,I4)*SP(I1,I3)*SP(I1,
     &  I4)
        MAT(12,-1,-1) = 8D0*CSP(I2,I4)**2*SP(I1,I3)*SP(I2,I4)
        MAT(13,-1,-1) = 32D0*CSP(I2,I4)*SP(I1,I3)

	end

************************************************************************
        subroutine Mat2born(p,m2i0,m2if0,
     &		     m2if0_22,m2if0_33,m2if0_44,m2if0_nd,qbcalc)
************************************************************************
*       Born structures needed for subtraction function for
*	    parton1(p1) + parton2(p2) --> f(p3) + f'(p4) + H(p5)
*	qbcalc = 0/1: b-quarks ex-/in-cluded in evaluation
*
*	Note: anomalous HVV couplings for qhvv>0
*	      + included in m2i0, m2if0_22, m2if0_33, m2if0_44
*	      - NOT included in m2if0, m2if0_nd
*
*-----------------------------------------------------------------------
*       13.10.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
	complex*16 pws,pws12,pwt11,pwt22,pwt12,pwt21
	complex*16 pzs,pzs12,pzt11,pzt22,pzt12,pzt21
        real*8 p(6,0:3)
        real*8 m2aqq0ss(5,5,5,5),m2qaq0ss(5,5,5,5)
        real*8 m2qq0ss(5,5,5,5),m2aqaq0ss(5,5,5,5)
        real*8 m2aqq0tt(5,5,5,5),m2qaq0tt(5,5,5,5)
        real*8 m2qq0tt(5,5,5,5),m2aqaq0tt(5,5,5,5)
        real*8 m2aqq0st(5,5,5,5),m2qaq0st(5,5,5,5)
        real*8 m2qq0st(5,5,5,5),m2aqaq0st(5,5,5,5)
        real*8 m2i0(-5:5,-5:5)
        real*8 m2if0(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0hvv(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_22(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_33(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_44(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_nd(-5:5,-5:5,-5:5,-5:5)
	integer i1,i2,i3,i4,i,j,qb,qbcalc
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
	integer qhvv

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        common/hvv/rsm,d,db,dt,dtb,lambdahvv,
     &             a1hww,a2hww,a3hww,a1haa,a2haa,a3haa,
     &             a1haz,a2haz,a3haz,a1hzz,a2hzz,a3hzz,qhvv

        data m2aqq0ss/625*0/,m2aqq0st/625*0/,m2aqq0tt/625*0/
        data m2qq0ss/625*0/,m2qq0st/625*0/,m2qq0tt/625*0/
        data m2aqaq0ss/625*0/,m2aqaq0st/625*0/,m2aqaq0tt/625*0/
        data m2qaq0ss/625*0/,m2qaq0st/625*0/,m2qaq0tt/625*0/

c energies and angles
        eb1  = p(1,0)
        eb2  = p(2,0)
	e1   = p(3,0)
	e2   = p(4,0)
	cth1 = p(3,3)/p(3,0)
	cth2 = p(4,3)/p(4,0)
	if (p(1,3).lt.0d0) then
	  cth1 = -cth1
	  cth2 = -cth2
	endif
	sth1 = sqrt(p(3,1)**2+p(3,2)**2)/p(3,0)
	sth2 = sqrt(p(4,1)**2+p(4,2)**2)/p(4,0)
        if (cth1.gt.0d0) then
          c22th1 = (1d0+cth1)*.5d0
          s22th1 = sth1**2/(4d0*c22th1)
        else
          s22th1 = (1d0-cth1)*.5d0
          c22th1 = sth1**2/(4d0*s22th1)
        endif
        if (cth2.gt.0d0) then
          c22th2 = (1d0+cth2)*.5d0
          s22th2 = sth2**2/(4d0*c22th2)
        else
          s22th2 = (1d0-cth2)*.5d0
          c22th2 = sth2**2/(4d0*s22th2)
        endif

c invariants
        s    = 4d0*eb1*eb2
        t11  = -4d0*eb1*e1*s22th1
        t12  = -4d0*eb1*e2*s22th2
        t21  = -4d0*eb2*e1*c22th1
        t22  = -4d0*eb2*e2*c22th2
c        s12  = mh2-s+4d0*e1*eb1*s22th1+4d0*e1*eb2*c22th1
c     &		    +4d0*e2*eb1*s22th2+4d0*e2*eb2*c22th2
	s12  = 2d0*( p(3,0)*p(4,0)-p(3,1)*p(4,1)
     &	            -p(3,2)*p(4,2)-p(3,3)*p(4,3))

c propagators
        if(qwidth.eq.1) then
          pws12 = 1d0/(s12-cmw2)
          pzs12 = 1d0/(s12-cmz2)
          pws = 1d0/(s-cmw2)
          pzs = 1d0/(s-cmz2)
          pwt11 = 1d0/(t11-cmw2)
          pzt11 = 1d0/(t11-cmz2)
          pwt22 = 1d0/(t22-cmw2)
          pzt22 = 1d0/(t22-cmz2)
          pwt12 = 1d0/(t12-cmw2)
          pzt12 = 1d0/(t12-cmz2)
          pwt21 = 1d0/(t21-cmw2)
          pzt21 = 1d0/(t21-cmz2)
        else

          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s12.lt.0d0))) then
            pws12 = 1d0/(s12-mw2)
            pzs12 = 1d0/(s12-mz2)
          else
            pws12 = 1d0/(s12-cmw2)
            pzs12 = 1d0/(s12-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s.lt.0d0))) then
            pws = 1d0/(s-mw2)
            pzs = 1d0/(s-mz2)
          else
            pws = 1d0/(s-cmw2)
            pzs = 1d0/(s-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(t11.lt.0d0))) then
            pwt11 = 1d0/(t11-mw2)
            pzt11 = 1d0/(t11-mz2)
          else
            pwt11 = 1d0/(t11-cmw2)
            pzt11 = 1d0/(t11-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(t22.lt.0d0))) then
            pwt22 = 1d0/(t22-mw2)
            pzt22 = 1d0/(t22-mz2)
          else
            pwt22 = 1d0/(t22-cmw2)
            pzt22 = 1d0/(t22-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(t12.lt.0d0))) then
            pwt12 = 1d0/(t12-mw2)
            pzt12 = 1d0/(t12-mz2)
          else
            pwt12 = 1d0/(t12-cmw2)
            pzt12 = 1d0/(t12-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(t21.lt.0d0))) then
            pwt21 = 1d0/(t21-mw2)
            pzt21 = 1d0/(t21-mz2)
          else
            pwt21 = 1d0/(t21-cmw2)
            pzt21 = 1d0/(t21-cmz2)
          endif
        endif


c*** initializations
c	do 100 i1=1,4
c	do 100 i2=1,4
c	do 100 i3=1,4
c	do 100 i4=1,4
c	  m2aqq0ss(i1,i2,i3,i4)  = 0d0
c	  m2aqq0tt(i1,i2,i3,i4)  = 0d0
c	  m2aqq0st(i1,i2,i3,i4)  = 0d0
c	  m2qaq0ss(i1,i2,i3,i4)  = 0d0
c	  m2qaq0tt(i1,i2,i3,i4)  = 0d0
c	  m2qaq0st(i1,i2,i3,i4)  = 0d0
c	  m2qq0ss(i1,i2,i3,i4)   = 0d0
c	  m2qq0tt(i1,i2,i3,i4)   = 0d0
c	  m2qq0st(i1,i2,i3,i4)   = 0d0
c	  m2aqaq0ss(i1,i2,i3,i4) = 0d0
c	  m2aqaq0tt(i1,i2,i3,i4) = 0d0
c	  m2aqaq0st(i1,i2,i3,i4) = 0d0
c100	continue

	qb = qbcalc
	if ((qbini.eq.0).and.(qbfin.eq.0)) qb = 0

c qbar-q --> qbar-q
	call Mat2aqqborn(m2aqq0ss,m2aqq0tt,m2aqq0st,
     &			 s,s12,t11,t21,t12,t22,
     &			 pws,pws12,pwt11,pwt22,pzs,pzs12,pzt11,pzt22,qb)
c q-q    --> q-q
	call Mat2aqqborn(m2qq0ss,m2qq0tt,m2qq0st,
     &		 t21,t12,t11,s,s12,t22,
     &		 pwt21,pwt12,pwt11,pwt22,pzt21,pzt12,pzt11,pzt22,qb)

c other channels from CP symmetry for qcp=1
	if (qcp.eq.0) then
c q-qbar --> q-qbar
	  call Mat2aqqborn(m2qaq0ss,m2qaq0tt,m2qaq0st,
     &			 s,s12,t22,t12,t21,t11,
     &	                 pws,pws12,pwt22,pwt11,pzs,pzs12,pzt11,pzt22,qb)
c qbar-qbar --> qbar-qbar
	  call Mat2aqqborn(m2aqaq0ss,m2aqaq0tt,m2aqaq0st,
     &		 t12,t21,t11,s12,s,t22,
     &		 pwt12,pwt21,pwt11,pwt22,pzt21,pzt12,pzt11,pzt22,qb)
	else
	  do 103 i4=1,4+qb
	  do 103 i3=1,4+qb
	  do 103 i2=1,4+qb
	  do 103 i1=1,4+qb
	    m2qaq0ss(i1,i2,i3,i4)  = m2aqq0ss(i1,i2,i3,i4) 
	    m2qaq0tt(i1,i2,i3,i4)  = m2aqq0tt(i1,i2,i3,i4) 
	    m2qaq0st(i1,i2,i3,i4)  = m2aqq0st(i1,i2,i3,i4) 
	    m2aqaq0ss(i1,i2,i3,i4) = m2qq0ss(i1,i2,i3,i4)  
	    m2aqaq0tt(i1,i2,i3,i4) = m2qq0tt(i1,i2,i3,i4)  
	    m2aqaq0st(i1,i2,i3,i4) = m2qq0st(i1,i2,i3,i4)  
103	  continue
	endif

c add final states for fixed initial states
        do 200 i1=-4-qbini,4+qbini
        do 200 i2=-4-qbini,4+qbini
          m2i0(i1,i2) = 0d0
          if (i1*i2.eq.0) goto 200
        do 300 i3=1,4+qbfin
        do 300 i4=1,4+qbfin
          if(i1.gt.0) then
            if ((i2.gt.0)) then
              m2if0_nd(i1,i2,i3,i4) = m2qq0st(i3,i2,i1,i4)*.5d0
              m2if0(i1,i2,i3,i4)    = m2qq0ss(i3,i2,i1,i4)*.5d0
     &           + m2qq0tt(i3,i2,i1,i4)*.5d0 + m2qq0st(i3,i2,i1,i4)*.5d0
              m2i0(i1,i2) = m2i0(i1,i2) + m2if0hvv(i1,i2,i3,i4)
            else
              m2if0_nd(i1,i2,i3,-i4) = m2qaq0st(-i2,i1,i4,i3)
              m2if0(i1,i2,i3,-i4)    = m2qaq0ss(-i2,i1,i4,i3)
     &           + m2qaq0tt(-i2,i1,i4,i3) + m2qaq0st(-i2,i1,i4,i3)
              m2i0(i1,i2) = m2i0(i1,i2) + m2if0hvv(i1,i2,i3,-i4)
            endif
          elseif (i2.gt.0) then
            m2if0_nd(i1,i2,-i3,i4) = m2aqq0st(-i1,i2,i3,i4)
            m2if0(i1,i2,-i3,i4)    = m2aqq0ss(-i1,i2,i3,i4)
     &         + m2aqq0tt(-i1,i2,i3,i4) + m2aqq0st(-i1,i2,i3,i4)
            m2i0(i1,i2) = m2i0(i1,i2) + m2if0hvv(i1,i2,-i3,i4)
          else
            m2if0_nd(i1,i2,-i3,-i4) = m2aqaq0st(-i1,i4,i3,-i2)*.5d0
            m2if0(i1,i2,-i3,-i4)    = m2aqaq0ss(-i1,i4,i3,-i2)*.5d0
     &         + m2aqaq0tt(-i1,i4,i3,-i2)*.5d0 
     &	       + m2aqaq0st(-i1,i4,i3,-i2)*.5d0
            m2i0(i1,i2) = m2i0(i1,i2) + m2if0hvv(i1,i2,-i3,-i4)
	  endif
300     continue
          if ((i1.ne.-1).or.(i2.ne.1)) m2i0(i1,i2) = 0d0
200     continue


	if (qhvv.ne.0) then

	call setprods3(p)

c qbar-q --> qbar-q
        call Mat2aqqbornhvv(m2aqq0ss,m2aqq0tt,m2aqq0st,
     &	                    -1,-2,3,4,qb)
c q-q    --> q-q
        call Mat2aqqbornhvv(m2qq0ss,m2qq0tt,m2qq0st,
     &	                    3,-2,-1,4,qb)
c q-qbar --> q-qbar
        call Mat2aqqbornhvv(m2qaq0ss,m2qaq0tt,m2qaq0st,
     &	                    -2,-1,4,3,qb)
c qbar-qbar --> qbar-qbar
        call Mat2aqqbornhvv(m2aqaq0ss,m2aqaq0tt,m2aqaq0st,
     &	                    -1,4,3,-2,qb)

	endif

c add final states for fixed initial states
        do 201 i1=-4-qbini,4+qbini
        do 201 i2=-4-qbini,4+qbini
          m2i0(i1,i2) = 0d0
          if (i1*i2.eq.0) goto 201
        do 301 i3=1,4+qbfin
        do 301 i4=1,4+qbfin
          if(i1.gt.0) then
            if ((i2.gt.0)) then
              m2if0_22(i1,i2,i3,i4) = 0d0
              m2if0_33(i1,i2,i3,i4) = m2qq0tt(i3,i2,i1,i4)*.5d0
              m2if0_44(i1,i2,i3,i4) = m2qq0ss(i3,i2,i1,i4)*.5d0
              m2if0hvv(i1,i2,i3,i4) = m2qq0ss(i3,i2,i1,i4)*.5d0
     &           + m2qq0tt(i3,i2,i1,i4)*.5d0 + m2qq0st(i3,i2,i1,i4)*.5d0
              m2i0(i1,i2) = m2i0(i1,i2) + m2if0hvv(i1,i2,i3,i4)
            else
              m2if0_22(i1,i2,i3,-i4) = m2qaq0ss(-i2,i1,i4,i3)
              m2if0_33(i1,i2,i3,-i4) = m2qaq0tt(-i2,i1,i4,i3)
              m2if0_44(i1,i2,i3,-i4) = 0d0
              m2if0hvv(i1,i2,i3,-i4) = m2qaq0ss(-i2,i1,i4,i3)
     &           + m2qaq0tt(-i2,i1,i4,i3) + m2qaq0st(-i2,i1,i4,i3)
              m2i0(i1,i2) = m2i0(i1,i2) + m2if0hvv(i1,i2,i3,-i4)
            endif
          elseif (i2.gt.0) then
            m2if0_22(i1,i2,-i3,i4) = m2aqq0ss(-i1,i2,i3,i4)
            m2if0_33(i1,i2,-i3,i4) = m2aqq0tt(-i1,i2,i3,i4)
            m2if0_44(i1,i2,-i3,i4) = 0d0
            m2if0hvv(i1,i2,-i3,i4) = m2aqq0ss(-i1,i2,i3,i4)
     &         + m2aqq0tt(-i1,i2,i3,i4) + m2aqq0st(-i1,i2,i3,i4)
            m2i0(i1,i2) = m2i0(i1,i2) + m2if0hvv(i1,i2,-i3,i4)
          else
            m2if0_22(i1,i2,-i3,-i4) = 0d0
            m2if0_33(i1,i2,-i3,-i4) = m2aqaq0tt(-i1,i4,i3,-i2)*.5d0
            m2if0_44(i1,i2,-i3,-i4) = m2aqaq0ss(-i1,i4,i3,-i2)*.5d0
            m2if0hvv(i1,i2,-i3,-i4) = m2aqaq0ss(-i1,i4,i3,-i2)*.5d0
     &         + m2aqaq0tt(-i1,i4,i3,-i2)*.5d0 
     &	       + m2aqaq0st(-i1,i4,i3,-i2)*.5d0
            m2i0(i1,i2) = m2i0(i1,i2) + m2if0hvv(i1,i2,-i3,-i4)
	  endif
301     continue
201     continue

	end

************************************************************************
        subroutine Mat2born0(p,m2i0,m2if0,qbcalc)
************************************************************************
*       Born structures needed for subtraction function for
*	    parton1(p1) + parton2(p2) --> f(p3) + f'(p4) + H(p5)
*	qbcalc = 0/1: b-quarks ex-/in-cluded in evaluation
*
*	Note: anomalous HVV couplings for qhvv>0 included
*
*-----------------------------------------------------------------------
*       13.10.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
	complex*16 pws,pws12,pwt11,pwt22,pwt12,pwt21
	complex*16 pzs,pzs12,pzt11,pzt22,pzt12,pzt21
        real*8 p(6,0:3)
        real*8 m2aqq0ss(5,5,5,5),m2qaq0ss(5,5,5,5)
        real*8 m2qq0ss(5,5,5,5),m2aqaq0ss(5,5,5,5)
        real*8 m2aqq0tt(5,5,5,5),m2qaq0tt(5,5,5,5)
        real*8 m2qq0tt(5,5,5,5),m2aqaq0tt(5,5,5,5)
        real*8 m2aqq0st(5,5,5,5),m2qaq0st(5,5,5,5)
        real*8 m2qq0st(5,5,5,5),m2aqaq0st(5,5,5,5)
        real*8 m2i0(-5:5,-5:5)
        real*8 m2if0(-5:5,-5:5,-5:5,-5:5)
	integer i1,i2,i3,i4,i,j,qb,qbcalc
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
	integer qhvv

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        common/hvv/rsm,d,db,dt,dtb,lambdahvv,
     &             a1hww,a2hww,a3hww,a1haa,a2haa,a3haa,
     &             a1haz,a2haz,a3haz,a1hzz,a2hzz,a3hzz,qhvv

        data m2aqq0ss/625*0/,m2aqq0st/625*0/,m2aqq0tt/625*0/
        data m2qq0ss/625*0/,m2qq0st/625*0/,m2qq0tt/625*0/
        data m2aqaq0ss/625*0/,m2aqaq0st/625*0/,m2aqaq0tt/625*0/
        data m2qaq0ss/625*0/,m2qaq0st/625*0/,m2qaq0tt/625*0/

c energies and angles
        eb1  = p(1,0)
        eb2  = p(2,0)
	e1   = p(3,0)
	e2   = p(4,0)
	cth1 = p(3,3)/p(3,0)
	cth2 = p(4,3)/p(4,0)
	if (p(1,3).lt.0d0) then
	  cth1 = -cth1
	  cth2 = -cth2
	endif
	sth1 = sqrt(p(3,1)**2+p(3,2)**2)/p(3,0)
	sth2 = sqrt(p(4,1)**2+p(4,2)**2)/p(4,0)
        if (cth1.gt.0d0) then
          c22th1 = (1d0+cth1)*.5d0
          s22th1 = sth1**2/(4d0*c22th1)
        else
          s22th1 = (1d0-cth1)*.5d0
          c22th1 = sth1**2/(4d0*s22th1)
        endif
        if (cth2.gt.0d0) then
          c22th2 = (1d0+cth2)*.5d0
          s22th2 = sth2**2/(4d0*c22th2)
        else
          s22th2 = (1d0-cth2)*.5d0
          c22th2 = sth2**2/(4d0*s22th2)
        endif

c invariants
        s    = 4d0*eb1*eb2
        t11  = -4d0*eb1*e1*s22th1
        t12  = -4d0*eb1*e2*s22th2
        t21  = -4d0*eb2*e1*c22th1
        t22  = -4d0*eb2*e2*c22th2
c        s12  = mh2-s+4d0*e1*eb1*s22th1+4d0*e1*eb2*c22th1
c     &		    +4d0*e2*eb1*s22th2+4d0*e2*eb2*c22th2
	s12  = 2d0*( p(3,0)*p(4,0)-p(3,1)*p(4,1)
     &	            -p(3,2)*p(4,2)-p(3,3)*p(4,3))

c propagators
        if(qwidth.eq.1) then
          pws12 = 1d0/(s12-cmw2)
          pzs12 = 1d0/(s12-cmz2)
          pws = 1d0/(s-cmw2)
          pzs = 1d0/(s-cmz2)
          pwt11 = 1d0/(t11-cmw2)
          pzt11 = 1d0/(t11-cmz2)
          pwt22 = 1d0/(t22-cmw2)
          pzt22 = 1d0/(t22-cmz2)
          pwt12 = 1d0/(t12-cmw2)
          pzt12 = 1d0/(t12-cmz2)
          pwt21 = 1d0/(t21-cmw2)
          pzt21 = 1d0/(t21-cmz2)
        else

          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s12.lt.0d0))) then
            pws12 = 1d0/(s12-mw2)
            pzs12 = 1d0/(s12-mz2)
          else
            pws12 = 1d0/(s12-cmw2)
            pzs12 = 1d0/(s12-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s.lt.0d0))) then
            pws = 1d0/(s-mw2)
            pzs = 1d0/(s-mz2)
          else
            pws = 1d0/(s-cmw2)
            pzs = 1d0/(s-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(t11.lt.0d0))) then
            pwt11 = 1d0/(t11-mw2)
            pzt11 = 1d0/(t11-mz2)
          else
            pwt11 = 1d0/(t11-cmw2)
            pzt11 = 1d0/(t11-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(t22.lt.0d0))) then
            pwt22 = 1d0/(t22-mw2)
            pzt22 = 1d0/(t22-mz2)
          else
            pwt22 = 1d0/(t22-cmw2)
            pzt22 = 1d0/(t22-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(t12.lt.0d0))) then
            pwt12 = 1d0/(t12-mw2)
            pzt12 = 1d0/(t12-mz2)
          else
            pwt12 = 1d0/(t12-cmw2)
            pzt12 = 1d0/(t12-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(t21.lt.0d0))) then
            pwt21 = 1d0/(t21-mw2)
            pzt21 = 1d0/(t21-mz2)
          else
            pwt21 = 1d0/(t21-cmw2)
            pzt21 = 1d0/(t21-cmz2)
          endif
        endif


c*** initializations
c	do 100 i1=1,4
c	do 100 i2=1,4
c	do 100 i3=1,4
c	do 100 i4=1,4
c	  m2aqq0ss(i1,i2,i3,i4)  = 0d0
c	  m2aqq0tt(i1,i2,i3,i4)  = 0d0
c	  m2aqq0st(i1,i2,i3,i4)  = 0d0
c	  m2qaq0ss(i1,i2,i3,i4)  = 0d0
c	  m2qaq0tt(i1,i2,i3,i4)  = 0d0
c	  m2qaq0st(i1,i2,i3,i4)  = 0d0
c	  m2qq0ss(i1,i2,i3,i4)   = 0d0
c	  m2qq0tt(i1,i2,i3,i4)   = 0d0
c	  m2qq0st(i1,i2,i3,i4)   = 0d0
c	  m2aqaq0ss(i1,i2,i3,i4) = 0d0
c	  m2aqaq0tt(i1,i2,i3,i4) = 0d0
c	  m2aqaq0st(i1,i2,i3,i4) = 0d0
c100	continue

	qb = qbcalc
	if ((qbini.eq.0).and.(qbfin.eq.0)) qb = 0

	if (qhvv.eq.0) then

c qbar-q --> qbar-q
	call Mat2aqqborn(m2aqq0ss,m2aqq0tt,m2aqq0st,
     &			 s,s12,t11,t21,t12,t22,
     &			 pws,pws12,pwt11,pwt22,pzs,pzs12,pzt11,pzt22,qb)
c q-q    --> q-q
	call Mat2aqqborn(m2qq0ss,m2qq0tt,m2qq0st,
     &		 t21,t12,t11,s,s12,t22,
     &		 pwt21,pwt12,pwt11,pwt22,pzt21,pzt12,pzt11,pzt22,qb)

c other channels from CP symmetry for qcp=1
	if (qcp.eq.0) then
c q-qbar --> q-qbar
	  call Mat2aqqborn(m2qaq0ss,m2qaq0tt,m2qaq0st,
     &			 s,s12,t22,t12,t21,t11,
     &	                 pws,pws12,pwt22,pwt11,pzs,pzs12,pzt11,pzt22,qb)
c qbar-qbar --> qbar-qbar
	  call Mat2aqqborn(m2aqaq0ss,m2aqaq0tt,m2aqaq0st,
     &		 t12,t21,t11,s12,s,t22,
     &		 pwt12,pwt21,pwt11,pwt22,pzt21,pzt12,pzt11,pzt22,qb)
	else
	  do 103 i4=1,4+qb
	  do 103 i3=1,4+qb
	  do 103 i2=1,4+qb
	  do 103 i1=1,4+qb
	    m2qaq0ss(i1,i2,i3,i4)  = m2aqq0ss(i1,i2,i3,i4) 
	    m2qaq0tt(i1,i2,i3,i4)  = m2aqq0tt(i1,i2,i3,i4) 
	    m2qaq0st(i1,i2,i3,i4)  = m2aqq0st(i1,i2,i3,i4) 
	    m2aqaq0ss(i1,i2,i3,i4) = m2qq0ss(i1,i2,i3,i4)  
	    m2aqaq0tt(i1,i2,i3,i4) = m2qq0tt(i1,i2,i3,i4)  
	    m2aqaq0st(i1,i2,i3,i4) = m2qq0st(i1,i2,i3,i4)  
103	  continue
	endif

	else

	call setprods3(p)

c qbar-q --> qbar-q
        call Mat2aqqbornhvv(m2aqq0ss,m2aqq0tt,m2aqq0st,-1,-2,3,4,qb)
c q-q    --> q-q
        call Mat2aqqbornhvv(m2qq0ss,m2qq0tt,m2qq0st,3,-2,-1,4,qb)
c q-qbar --> q-qbar
        call Mat2aqqbornhvv(m2qaq0ss,m2qaq0tt,m2qaq0st,-2,-1,4,3,qb)
c qbar-qbar --> qbar-qbar
        call Mat2aqqbornhvv(m2aqaq0ss,m2aqaq0tt,m2aqaq0st,-1,4,3,-2,qb)

	endif

c add final states for fixed initial states
        do 200 i1=-4-qbini,4+qbini
        do 200 i2=-4-qbini,4+qbini
          m2i0(i1,i2) = 0d0
          if (i1*i2.eq.0) goto 200
        do 300 i3=1,4+qbfin
        do 300 i4=1,4+qbfin
          if(i1.gt.0) then
            if ((i2.gt.0)) then
              m2if0(i1,i2,i3,i4)    = m2qq0ss(i3,i2,i1,i4)*.5d0
     &           + m2qq0tt(i3,i2,i1,i4)*.5d0 + m2qq0st(i3,i2,i1,i4)*.5d0
              m2i0(i1,i2) = m2i0(i1,i2) + m2if0(i1,i2,i3,i4)
            else
              m2if0(i1,i2,i3,-i4)    = m2qaq0ss(-i2,i1,i4,i3)
     &           + m2qaq0tt(-i2,i1,i4,i3) + m2qaq0st(-i2,i1,i4,i3)
              m2i0(i1,i2) = m2i0(i1,i2) + m2if0(i1,i2,i3,-i4)
            endif
          elseif (i2.gt.0) then
            m2if0(i1,i2,-i3,i4)    = m2aqq0ss(-i1,i2,i3,i4)
     &         + m2aqq0tt(-i1,i2,i3,i4) + m2aqq0st(-i1,i2,i3,i4)
            m2i0(i1,i2) = m2i0(i1,i2) + m2if0(i1,i2,-i3,i4)
          else
            m2if0(i1,i2,-i3,-i4)    = m2aqaq0ss(-i1,i4,i3,-i2)*.5d0
     &         + m2aqaq0tt(-i1,i4,i3,-i2)*.5d0 
     &	       + m2aqaq0st(-i1,i4,i3,-i2)*.5d0
            m2i0(i1,i2) = m2i0(i1,i2) + m2if0(i1,i2,-i3,-i4)
	  endif
300     continue
200     continue

	end

************************************************************************
        subroutine Mat2born1(p,m2if0,qbcalc)
************************************************************************
*       Born structures needed for subtraction function for
*	    parton1(p1) + parton2(p2) --> f(p3) + f'(p4) + H(p5)
*	qbcalc = 0/1: b-quarks ex-/in-cluded in evaluation
*
*	Note: NO anomalous HVV couplings !
*
*-----------------------------------------------------------------------
*       13.10.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
	complex*16 pws,pws12,pwt11,pwt22,pwt12,pwt21
	complex*16 pzs,pzs12,pzt11,pzt22,pzt12,pzt21
        real*8 p(6,0:3)
        real*8 m2aqq0ss(5,5,5,5),m2qaq0ss(5,5,5,5)
        real*8 m2qq0ss(5,5,5,5),m2aqaq0ss(5,5,5,5)
        real*8 m2aqq0tt(5,5,5,5),m2qaq0tt(5,5,5,5)
        real*8 m2qq0tt(5,5,5,5),m2aqaq0tt(5,5,5,5)
        real*8 m2aqq0st(5,5,5,5),m2qaq0st(5,5,5,5)
        real*8 m2qq0st(5,5,5,5),m2aqaq0st(5,5,5,5)
        real*8 m2if0(-5:5,-5:5,-5:5,-5:5)
	integer i1,i2,i3,i4,i,j,qb,qbcalc
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        data m2aqq0ss/625*0/,m2aqq0st/625*0/,m2aqq0tt/625*0/
        data m2qq0ss/625*0/,m2qq0st/625*0/,m2qq0tt/625*0/
        data m2aqaq0ss/625*0/,m2aqaq0st/625*0/,m2aqaq0tt/625*0/
        data m2qaq0ss/625*0/,m2qaq0st/625*0/,m2qaq0tt/625*0/

c energies and angles
        eb1  = p(1,0)
        eb2  = p(2,0)
	e1   = p(3,0)
	e2   = p(4,0)
	cth1 = p(3,3)/p(3,0)
	cth2 = p(4,3)/p(4,0)
	if (p(1,3).lt.0d0) then
	  cth1 = -cth1
	  cth2 = -cth2
	endif
	sth1 = sqrt(p(3,1)**2+p(3,2)**2)/p(3,0)
	sth2 = sqrt(p(4,1)**2+p(4,2)**2)/p(4,0)
        if (cth1.gt.0d0) then
          c22th1 = (1d0+cth1)*.5d0
          s22th1 = sth1**2/(4d0*c22th1)
        else
          s22th1 = (1d0-cth1)*.5d0
          c22th1 = sth1**2/(4d0*s22th1)
        endif
        if (cth2.gt.0d0) then
          c22th2 = (1d0+cth2)*.5d0
          s22th2 = sth2**2/(4d0*c22th2)
        else
          s22th2 = (1d0-cth2)*.5d0
          c22th2 = sth2**2/(4d0*s22th2)
        endif

c invariants
        s    = 4d0*eb1*eb2
        t11  = -4d0*eb1*e1*s22th1
        t12  = -4d0*eb1*e2*s22th2
        t21  = -4d0*eb2*e1*c22th1
        t22  = -4d0*eb2*e2*c22th2
c        s12  = mh2-s+4d0*e1*eb1*s22th1+4d0*e1*eb2*c22th1
c     &		    +4d0*e2*eb1*s22th2+4d0*e2*eb2*c22th2
	s12  = 2d0*( p(3,0)*p(4,0)-p(3,1)*p(4,1)
     &	            -p(3,2)*p(4,2)-p(3,3)*p(4,3))

c propagators


        if(qwidth.eq.1) then
          pws12 = 1d0/(s12-cmw2)
          pzs12 = 1d0/(s12-cmz2)
          pws = 1d0/(s-cmw2)
          pzs = 1d0/(s-cmz2)
          pwt11 = 1d0/(t11-cmw2)
          pzt11 = 1d0/(t11-cmz2)
          pwt22 = 1d0/(t22-cmw2)
          pzt22 = 1d0/(t22-cmz2)
          pwt12 = 1d0/(t12-cmw2)
          pzt12 = 1d0/(t12-cmz2)
          pwt21 = 1d0/(t21-cmw2)
          pzt21 = 1d0/(t21-cmz2)
        else

          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s12.lt.0d0))) then
            pws12 = 1d0/(s12-mw2)
            pzs12 = 1d0/(s12-mz2)
          else
            pws12 = 1d0/(s12-cmw2)
            pzs12 = 1d0/(s12-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s.lt.0d0))) then
            pws = 1d0/(s-mw2)
            pzs = 1d0/(s-mz2)
          else
            pws = 1d0/(s-cmw2)
            pzs = 1d0/(s-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(t11.lt.0d0))) then
            pwt11 = 1d0/(t11-mw2)
            pzt11 = 1d0/(t11-mz2)
          else
            pwt11 = 1d0/(t11-cmw2)
            pzt11 = 1d0/(t11-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(t22.lt.0d0))) then
            pwt22 = 1d0/(t22-mw2)
            pzt22 = 1d0/(t22-mz2)
          else
            pwt22 = 1d0/(t22-cmw2)
            pzt22 = 1d0/(t22-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(t12.lt.0d0))) then
            pwt12 = 1d0/(t12-mw2)
            pzt12 = 1d0/(t12-mz2)
          else
            pwt12 = 1d0/(t12-cmw2)
            pzt12 = 1d0/(t12-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(t21.lt.0d0))) then
            pwt21 = 1d0/(t21-mw2)
            pzt21 = 1d0/(t21-mz2)
          else
            pwt21 = 1d0/(t21-cmw2)
            pzt21 = 1d0/(t21-cmz2)
          endif
        endif

	qb = qbcalc
	if ((qbini.eq.0).and.(qbfin.eq.0)) qb = 0

c qbar-q --> qbar-q
	call Mat2aqqborn(m2aqq0ss,m2aqq0tt,m2aqq0st,
     &			 s,s12,t11,t21,t12,t22,
     &			 pws,pws12,pwt11,pwt22,pzs,pzs12,pzt11,pzt22,qb)
c q-q    --> q-q
	call Mat2aqqborn(m2qq0ss,m2qq0tt,m2qq0st,
     &		 t21,t12,t11,s,s12,t22,
     &		 pwt21,pwt12,pwt11,pwt22,pzt21,pzt12,pzt11,pzt22,qb)

c other channels from CP symmetry for qcp=1
	if (qcp.eq.0) then
c q-qbar --> q-qbar
	  call Mat2aqqborn(m2qaq0ss,m2qaq0tt,m2qaq0st,
     &			 s,s12,t22,t12,t21,t11,
     &	                 pws,pws12,pwt22,pwt11,pzs,pzs12,pzt11,pzt22,qb)
c qbar-qbar --> qbar-qbar
	  call Mat2aqqborn(m2aqaq0ss,m2aqaq0tt,m2aqaq0st,
     &		 t12,t21,t11,s12,s,t22,
     &		 pwt12,pwt21,pwt11,pwt22,pzt21,pzt12,pzt11,pzt22,qb)
	else
	  do 103 i4=1,4+qb
	  do 103 i3=1,4+qb
	  do 103 i2=1,4+qb
	  do 103 i1=1,4+qb
	    m2qaq0ss(i1,i2,i3,i4)  = m2aqq0ss(i1,i2,i3,i4) 
	    m2qaq0tt(i1,i2,i3,i4)  = m2aqq0tt(i1,i2,i3,i4) 
	    m2qaq0st(i1,i2,i3,i4)  = m2aqq0st(i1,i2,i3,i4) 
	    m2aqaq0ss(i1,i2,i3,i4) = m2qq0ss(i1,i2,i3,i4)  
	    m2aqaq0tt(i1,i2,i3,i4) = m2qq0tt(i1,i2,i3,i4)  
	    m2aqaq0st(i1,i2,i3,i4) = m2qq0st(i1,i2,i3,i4)  
103	  continue
	endif

c add final states for fixed initial states
        do 200 i1=-4-qbini,4+qbini
        do 200 i2=-4-qbini,4+qbini
          if (i1*i2.eq.0) goto 200
        do 300 i3=1,4+qbfin
        do 300 i4=1,4+qbfin
          if(i1.gt.0) then
            if ((i2.gt.0)) then
              m2if0(i1,i2,i3,i4)    = (m2qq0ss(i3,i2,i1,i4)
     &           + m2qq0tt(i3,i2,i1,i4) + m2qq0st(i3,i2,i1,i4))*.5d0
            else
              m2if0(i1,i2,i3,-i4)    = m2qaq0ss(-i2,i1,i4,i3)
     &           + m2qaq0tt(-i2,i1,i4,i3) + m2qaq0st(-i2,i1,i4,i3)
            endif
          elseif (i2.gt.0) then
            m2if0(i1,i2,-i3,i4)    = m2aqq0ss(-i1,i2,i3,i4)
     &         + m2aqq0tt(-i1,i2,i3,i4) + m2aqq0st(-i1,i2,i3,i4)
          else
            m2if0(i1,i2,-i3,-i4)    = (m2aqaq0ss(-i1,i4,i3,-i2)
     &         + m2aqaq0tt(-i1,i4,i3,-i2) 
     &	       + m2aqaq0st(-i1,i4,i3,-i2))*.5d0
	  endif
300     continue
200     continue

	end

************************************************************************
        subroutine Mat2born2(p,m2if0_22,m2if0_33,m2if0_44,m2if0_nd
     &				,qbcalc)
************************************************************************
*       Born structures needed for subtraction function for
*	    parton1(p1) + parton2(p2) --> f(p3) + f'(p4) + H(p5)
*	qbcalc = 0/1: b-quarks ex-/in-cluded in evaluation
*
*	Note: anomalous HVV couplings for qhvv>0
*	      + included in m2if0_22, m2if0_33, m2if0_44
*	      - NOT included in m2if0_nd
*
*-----------------------------------------------------------------------
*       13.10.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
	complex*16 pws,pws12,pwt11,pwt22,pwt12,pwt21
	complex*16 pzs,pzs12,pzt11,pzt22,pzt12,pzt21
        real*8 p(6,0:3)
        real*8 m2aqq0ss(5,5,5,5),m2qaq0ss(5,5,5,5)
        real*8 m2qq0ss(5,5,5,5),m2aqaq0ss(5,5,5,5)
        real*8 m2aqq0tt(5,5,5,5),m2qaq0tt(5,5,5,5)
        real*8 m2qq0tt(5,5,5,5),m2aqaq0tt(5,5,5,5)
        real*8 m2aqq0st(5,5,5,5),m2qaq0st(5,5,5,5)
        real*8 m2qq0st(5,5,5,5),m2aqaq0st(5,5,5,5)
        real*8 m2aqq0sshvv(5,5,5,5),m2qaq0sshvv(5,5,5,5)
        real*8 m2qq0sshvv(5,5,5,5),m2aqaq0sshvv(5,5,5,5)
        real*8 m2aqq0tthvv(5,5,5,5),m2qaq0tthvv(5,5,5,5)
        real*8 m2qq0tthvv(5,5,5,5),m2aqaq0tthvv(5,5,5,5)
        real*8 m2aqq0sthvv(5,5,5,5),m2qaq0sthvv(5,5,5,5)
        real*8 m2qq0sthvv(5,5,5,5),m2aqaq0sthvv(5,5,5,5)
        real*8 m2if0_22(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_33(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_44(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_nd(-5:5,-5:5,-5:5,-5:5)
	integer i1,i2,i3,i4,i,j,qb,qbcalc
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
	integer qhvv

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        common/hvv/rsm,d,db,dt,dtb,lambdahvv,
     &             a1hww,a2hww,a3hww,a1haa,a2haa,a3haa,
     &             a1haz,a2haz,a3haz,a1hzz,a2hzz,a3hzz,qhvv

        data m2aqq0ss/625*0/,m2aqq0st/625*0/,m2aqq0tt/625*0/
        data m2qq0ss/625*0/,m2qq0st/625*0/,m2qq0tt/625*0/
        data m2aqaq0ss/625*0/,m2aqaq0st/625*0/,m2aqaq0tt/625*0/
        data m2qaq0ss/625*0/,m2qaq0st/625*0/,m2qaq0tt/625*0/
        data m2aqq0sshvv/625*0/,m2aqq0sthvv/625*0/,m2aqq0tthvv/625*0/
        data m2qq0sshvv/625*0/,m2qq0sthvv/625*0/,m2qq0tthvv/625*0/
        data m2aqaq0sshvv/625*0/,m2aqaq0sthvv/625*0/,m2aqaq0tthvv/625*0/
        data m2qaq0sshvv/625*0/,m2qaq0sthvv/625*0/,m2qaq0tthvv/625*0/

c energies and angles
        eb1  = p(1,0)
        eb2  = p(2,0)
	e1   = p(3,0)
	e2   = p(4,0)
	cth1 = p(3,3)/p(3,0)
	cth2 = p(4,3)/p(4,0)
	if (p(1,3).lt.0d0) then
	  cth1 = -cth1
	  cth2 = -cth2
	endif
	sth1 = sqrt(p(3,1)**2+p(3,2)**2)/p(3,0)
	sth2 = sqrt(p(4,1)**2+p(4,2)**2)/p(4,0)
        if (cth1.gt.0d0) then
          c22th1 = (1d0+cth1)*.5d0
          s22th1 = sth1**2/(4d0*c22th1)
        else
          s22th1 = (1d0-cth1)*.5d0
          c22th1 = sth1**2/(4d0*s22th1)
        endif
        if (cth2.gt.0d0) then
          c22th2 = (1d0+cth2)*.5d0
          s22th2 = sth2**2/(4d0*c22th2)
        else
          s22th2 = (1d0-cth2)*.5d0
          c22th2 = sth2**2/(4d0*s22th2)
        endif

c invariants
        s    = 4d0*eb1*eb2
        t11  = -4d0*eb1*e1*s22th1
        t12  = -4d0*eb1*e2*s22th2
        t21  = -4d0*eb2*e1*c22th1
        t22  = -4d0*eb2*e2*c22th2
c        s12  = mh2-s+4d0*e1*eb1*s22th1+4d0*e1*eb2*c22th1
c     &		    +4d0*e2*eb1*s22th2+4d0*e2*eb2*c22th2
	s12  = 2d0*( p(3,0)*p(4,0)-p(3,1)*p(4,1)
     &	            -p(3,2)*p(4,2)-p(3,3)*p(4,3))

c propagators

        if(qwidth.eq.1) then
          pws12 = 1d0/(s12-cmw2)
          pzs12 = 1d0/(s12-cmz2)
          pws = 1d0/(s-cmw2)
          pzs = 1d0/(s-cmz2)
          pwt11 = 1d0/(t11-cmw2)
          pzt11 = 1d0/(t11-cmz2)
          pwt22 = 1d0/(t22-cmw2)
          pzt22 = 1d0/(t22-cmz2)
          pwt12 = 1d0/(t12-cmw2)
          pzt12 = 1d0/(t12-cmz2)
          pwt21 = 1d0/(t21-cmw2)
          pzt21 = 1d0/(t21-cmz2)
        else

          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s12.lt.0d0))) then
            pws12 = 1d0/(s12-mw2)
            pzs12 = 1d0/(s12-mz2)
          else
            pws12 = 1d0/(s12-cmw2)
            pzs12 = 1d0/(s12-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s.lt.0d0))) then
            pws = 1d0/(s-mw2)
            pzs = 1d0/(s-mz2)
          else
            pws = 1d0/(s-cmw2)
            pzs = 1d0/(s-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(t11.lt.0d0))) then
            pwt11 = 1d0/(t11-mw2)
            pzt11 = 1d0/(t11-mz2)
          else
            pwt11 = 1d0/(t11-cmw2)
            pzt11 = 1d0/(t11-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(t22.lt.0d0))) then
            pwt22 = 1d0/(t22-mw2)
            pzt22 = 1d0/(t22-mz2)
          else
            pwt22 = 1d0/(t22-cmw2)
            pzt22 = 1d0/(t22-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(t12.lt.0d0))) then
            pwt12 = 1d0/(t12-mw2)
            pzt12 = 1d0/(t12-mz2)
          else
            pwt12 = 1d0/(t12-cmw2)
            pzt12 = 1d0/(t12-cmz2)
          endif
          
          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(t21.lt.0d0))) then
            pwt21 = 1d0/(t21-mw2)
            pzt21 = 1d0/(t21-mz2)
          else
            pwt21 = 1d0/(t21-cmw2)
            pzt21 = 1d0/(t21-cmz2)
          endif
        endif

	qb = qbcalc
	if ((qbini.eq.0).and.(qbfin.eq.0)) qb = 0

c qbar-q --> qbar-q
	call Mat2aqqborn(m2aqq0ss,m2aqq0tt,m2aqq0st,
     &			 s,s12,t11,t21,t12,t22,
     &			 pws,pws12,pwt11,pwt22,pzs,pzs12,pzt11,pzt22,qb)
c q-q    --> q-q
	call Mat2aqqborn(m2qq0ss,m2qq0tt,m2qq0st,
     &		 t21,t12,t11,s,s12,t22,
     &		 pwt21,pwt12,pwt11,pwt22,pzt21,pzt12,pzt11,pzt22,qb)

c other channels from CP symmetry for qcp=1
	if (qcp.eq.0) then
c q-qbar --> q-qbar
	  call Mat2aqqborn(m2qaq0ss,m2qaq0tt,m2qaq0st,
     &			 s,s12,t22,t12,t21,t11,
     &	                 pws,pws12,pwt22,pwt11,pzs,pzs12,pzt11,pzt22,qb)
c qbar-qbar --> qbar-qbar
	  call Mat2aqqborn(m2aqaq0ss,m2aqaq0tt,m2aqaq0st,
     &		 t12,t21,t11,s12,s,t22,
     &		 pwt12,pwt21,pwt11,pwt22,pzt21,pzt12,pzt11,pzt22,qb)
	else
	  do 103 i4=1,4+qb
	  do 103 i3=1,4+qb
	  do 103 i2=1,4+qb
	  do 103 i1=1,4+qb
	    m2qaq0ss(i1,i2,i3,i4)  = m2aqq0ss(i1,i2,i3,i4) 
	    m2qaq0tt(i1,i2,i3,i4)  = m2aqq0tt(i1,i2,i3,i4) 
	    m2qaq0st(i1,i2,i3,i4)  = m2aqq0st(i1,i2,i3,i4) 
	    m2aqaq0ss(i1,i2,i3,i4) = m2qq0ss(i1,i2,i3,i4)  
	    m2aqaq0tt(i1,i2,i3,i4) = m2qq0tt(i1,i2,i3,i4)  
	    m2aqaq0st(i1,i2,i3,i4) = m2qq0st(i1,i2,i3,i4)  
103	  continue
	endif

c Anomalous amplitudes for diagonal QCD corrections only
c    -> "...sthvv" amplitudes irrelevant
	if (qhvv.ne.0) then

	call setprods3(p)

c qbar-q --> qbar-q
        call Mat2aqqbornhvv(m2aqq0ss,m2aqq0tt,m2aqq0sthvv,
     &	                    -1,-2,3,4,qb)
c q-q    --> q-q
        call Mat2aqqbornhvv(m2qq0ss,m2qq0tt,m2qq0sthvv,
     &	                    3,-2,-1,4,qb)
c q-qbar --> q-qbar
        call Mat2aqqbornhvv(m2qaq0ss,m2qaq0tt,m2qaq0sthvv,
     &	                    -2,-1,4,3,qb)
c qbar-qbar --> qbar-qbar
        call Mat2aqqbornhvv(m2aqaq0ss,m2aqaq0tt,m2aqaq0sthvv,
     &	                    -1,4,3,-2,qb)

	endif

c add final states for fixed initial states
        do 200 i1=-4-qbini,4+qbini
        do 200 i2=-4-qbini,4+qbini
          if (i1*i2.eq.0) goto 200
        do 300 i3=1,4+qbfin
        do 300 i4=1,4+qbfin
          if(i1.gt.0) then
            if ((i2.gt.0)) then
              m2if0_22(i1,i2,i3,i4) = 0d0
              m2if0_33(i1,i2,i3,i4) = m2qq0tt(i3,i2,i1,i4)*.5d0
              m2if0_44(i1,i2,i3,i4) = m2qq0ss(i3,i2,i1,i4)*.5d0
              m2if0_nd(i1,i2,i3,i4) = m2qq0st(i3,i2,i1,i4)*.5d0
            else
              m2if0_22(i1,i2,i3,-i4) = m2qaq0ss(-i2,i1,i4,i3)
              m2if0_33(i1,i2,i3,-i4) = m2qaq0tt(-i2,i1,i4,i3)
              m2if0_44(i1,i2,i3,-i4) = 0d0
              m2if0_nd(i1,i2,i3,-i4) = m2qaq0st(-i2,i1,i4,i3)
            endif
          elseif (i2.gt.0) then
            m2if0_22(i1,i2,-i3,i4) = m2aqq0ss(-i1,i2,i3,i4)
            m2if0_33(i1,i2,-i3,i4) = m2aqq0tt(-i1,i2,i3,i4)
            m2if0_44(i1,i2,-i3,i4) = 0d0
            m2if0_nd(i1,i2,-i3,i4) = m2aqq0st(-i1,i2,i3,i4)
          else
            m2if0_22(i1,i2,-i3,-i4) = 0d0
            m2if0_33(i1,i2,-i3,-i4) = m2aqaq0tt(-i1,i4,i3,-i2)*.5d0
            m2if0_44(i1,i2,-i3,-i4) = m2aqaq0ss(-i1,i4,i3,-i2)*.5d0
            m2if0_nd(i1,i2,-i3,-i4) = m2aqaq0st(-i1,i4,i3,-i2)*.5d0
	  endif
300     continue
200     continue

	end

************************************************************************
        subroutine Mat2aqqborn(m2aqq0ss,m2aqq0tt,m2aqq0st,
     &			s,s12,t11,t21,t12,t22,
     &			pws,pws12,pwt11,pwt22,pzs,pzs12,pzt11,pzt22,qb)
************************************************************************
*       generic Born structures needed for subtraction function for
*	    anti-q(p1) + q(p2) --> f(p3) + f'(p4) + H(p5)
*
*       from generic amplitudes for
*	    H(p) --> fa(k1) + anti-fb(k2) + fc(k3) + anti-fd(k4)
*	         CC: f1     + anti-f2     + f3     + anti-f4     
*	         NC: f1     + anti-f1     + f3     + anti-f3     
*	             f2     + anti-f2     + f3     + anti-f3     
*	             f1     + anti-f1     + f4     + anti-f4     
*
*	fermions: f1,f4 = generic   up-type fermions
*	          f2,f3 = generic down-type fermions
*-----------------------------------------------------------------------
*       13.10.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 pre,pres,pret,mats0,matt0,wmats0,wmatt0
	complex*16 v,cv
	complex*16 pws,pws12,pwt11,pwt22
	complex*16 pzs,pzs12,pzt11,pzt22
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
	real*8 m1243sq(-1:1,-1:1),m4213sq(-1:1,-1:1)
        real*8 m2aqq0ss(5,5,5,5),m2aqq0tt(5,5,5,5),m2aqq0st(5,5,5,5)
	integer ia,ib,ic,id
	integer i1,i2,i3,i4,j,j1,j2,f1,f2,f3,f4,g1,g2,g3,g4,qb
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
	complex*16 guu,gdd,gnn,gll     
	logical checkss12,checkt11t22

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)

        common/qf/qu,qd,ql,qn,qf(4),mu,mu2,md,md2,mlep,mlep2,
     &            guu(-1:1),gdd(-1:1),gnn(-1:1),gll(-1:1)

	el3 = el**3

        m1243sq(1,1)   = 4D0*t12*t21
        m1243sq(-1,1)  = 4D0*t11*t22
        m1243sq(1,-1)  = m1243sq(-1,1)
        m1243sq(-1,-1) = m1243sq(1,1)

        M4213sq(1,1)   = m1243sq(1,1)
        M4213sq(-1,1)  = 4D0*s*s12
        M4213sq(1,-1)  = M4213sq(-1,1)
        M4213sq(-1,-1) = m1243sq(-1,-1)

	checkss12   = ((  s*qschan.gt.0d0).or.(  s*qtchan.lt.0d0)).and.
     &	              ((s12*qschan.gt.0d0).or.(s12*qtchan.lt.0d0))
	checkt11t22 = ((t11*qschan.gt.0d0).or.(t11*qtchan.lt.0d0)).and.
     &	              ((t22*qschan.gt.0d0).or.(t22*qtchan.lt.0d0))


c qbar-q scattering
c
c   s-channel:                             t-channel:
c
c   fa(p1) \_          / fd(p3)            fa(p1) --<--*--<-- fb(p3)
c          |\        |/                                >
c            \       /-                                >
c             *vvvvv*                                  >
c           _/       \                                 >
c           /|        \|                               >
c   fb(p2) /          -\ fc(p4)            fd(p2) -->--*-->-- fc(p4)


c Type: ubar-d -> ubar-d
c-----------------------

c*** generic amplitudes
	pres = 0d0
	pret = 0d0

c ubar-d -W-> cbar-s    (k1->-p1,k2->-p2,k3->p4,k4->p3)   
        if (checkss12) pres = qw*el3*PWS12*PWS*XMW/(2D0*XSW*XSW2)

c ubar-s -Z-> ubar-s    (k1->-p1,k2->p3,k3->p4,k4->-p2)   
        if (checkt11t22) pret = qz*el3*PZT11*PZT22/XSW/XCW2*XMW

c*** individual channels
 	do 200 g1=1,2
 	do 200 g2=1,2+qb
 	do 200 g3=1,2
 	do 200 g4=1,2+qb
 	  f1 = 2*g1
 	  f2 = 2*g2-1
 	  f3 = 2*g3
 	  f4 = 2*g4-1
 	  m2aqq0ss(f1,f2,f3,f4) = 0d0
 	  m2aqq0tt(f1,f2,f3,f4) = 0d0
 	  m2aqq0st(f1,f2,f3,f4) = 0d0

	do 200 i1=1,4

	  if (i1.eq.1) then
	    mats0  = 0d0
	    matt0  = pret*guu(-1)*gdd(+1)
	    fac    = m4213sq(-1,+1)
	  elseif (i1.eq.2) then
	    mats0  = -pres
	    matt0  = pret*guu(-1)*gdd(-1)
	    fac    = m4213sq(-1,-1)
	  elseif (i1.eq.3) then
	    mats0  = 0d0
	    matt0  = pret*guu(+1)*gdd(+1)
	    fac    = m4213sq(+1,+1)
	  elseif (i1.eq.4) then
	    mats0  = 0d0
	    matt0  = pret*guu(+1)*gdd(-1)
	    fac    = m4213sq(+1,-1)
	  endif

 	  wmats0   = cv(g1,g2)*v(g3,g4)*mats0

 	  if ((f1.eq.f3).and.(f2.eq.f4)) then
 	    m2aqq0ss(f1,f2,f3,f4) = m2aqq0ss(f1,f2,f3,f4) 
     &		         + fac*9d0*abs(wmats0)**2 *qch2
 	    m2aqq0tt(f1,f2,f3,f4) = m2aqq0tt(f1,f2,f3,f4) 
     &		         + fac*9d0*abs(matt0)**2 *qch2
 	    m2aqq0st(f1,f2,f3,f4) = m2aqq0st(f1,f2,f3,f4) 
     &	          - fac*3d0*2d0*dreal(wmats0*dconjg(matt0)) *qchint 
 	  else
 	    m2aqq0ss(f1,f2,f3,f4) = m2aqq0ss(f1,f2,f3,f4) 
     &			 + fac*9d0*abs(wmats0)**2 *qch2 
 	  endif

200	continue

c Type: dbar-u -> dbar-u
c-----------------------

c*** generic amplitudes
	pres = 0d0
	pret = 0d0

c dbar-u -W-> sbar-c    (k3->-p1,k4->-p2,k1->p4,k2->p3)   
	if (checkss12) pres = qw*el3*PWS12*PWS*XMW/(2D0*XSW*XSW2)

c dbar-c -Z-> dbar-c    (k3->-p1,k4->p3,k1->p4,k2->-p2)   
        if (checkt11t22) pret = qz*el3*PZT11*PZT22*XMW/(XSW*XCW2)

 	do 205 g1=1,2+qb
 	do 205 g2=1,2
 	do 205 g3=1,2+qb
 	do 205 g4=1,2
 	  f1 = 2*g1-1
 	  f2 = 2*g2
 	  f3 = 2*g3-1
 	  f4 = 2*g4
 	  m2aqq0ss(f1,f2,f3,f4) = 0d0
 	  m2aqq0tt(f1,f2,f3,f4) = 0d0
 	  m2aqq0st(f1,f2,f3,f4) = 0d0

	do 205 i1=1,4

	  if (i1.eq.1) then
	    mats0  = 0d0
	    matt0  = pret*guu(+1)*gdd(-1)
	    fac    = m4213sq(-1,+1)
	  elseif (i1.eq.2) then
	    mats0  = -pres
	    matt0  = pret*guu(-1)*gdd(-1)
	    fac    = m4213sq(-1,-1)
	  elseif (i1.eq.3) then
	    mats0  = 0d0
	    matt0  = pret*guu(+1)*gdd(+1)
	    fac    = m4213sq(+1,+1)
	  elseif (i1.eq.4) then
	    mats0  = 0d0
	    matt0  = pret*guu(-1)*gdd(+1)
	    fac    = m4213sq(+1,-1)
	  endif

 	  wmats0 = v(g2,g1)*cv(g4,g3)*mats0

 	  if ((f1.eq.f3).and.(f2.eq.f4)) then
 	    m2aqq0ss(f1,f2,f3,f4) = m2aqq0ss(f1,f2,f3,f4) 
     &		         + fac*9d0*abs(wmats0)**2 *qch2 
 	    m2aqq0tt(f1,f2,f3,f4) = m2aqq0tt(f1,f2,f3,f4) 
     &		         + fac*9d0*abs(matt0)**2 *qch2 
 	    m2aqq0st(f1,f2,f3,f4) = m2aqq0st(f1,f2,f3,f4) 
     &	          - fac*3d0*2d0*dreal(wmats0*dconjg(matt0)) *qchint
 	  else
 	    m2aqq0ss(f1,f2,f3,f4) = m2aqq0ss(f1,f2,f3,f4) 
     &			 + fac*9d0*abs(wmats0)**2 *qch2 
 	  endif
205	continue


c Type: ubar-u -> ubar-u
c----------------------- 

c*** generic amplitudes
	pres = 0d0
	pret = 0d0

c ubar-u -Z-> cbar-c  (k1->-p1,k2->-p2,k3->p4,k4->p3)
	if (checkss12) pres = qz*el3*PZS*PZS12*XMW/(XSW*XCW2)

c ubar-c -Z-> ubar-c  (k1->-p1,k2->p3,k3->p4,k4->-p2)
	if (checkt11t22) pret = qz*el3*PZT11*PZT22*XMW/(XSW*XCW2)

	m2aqq0ss(2,2,2,2) = 0d0
	m2aqq0tt(2,2,2,2) = 0d0
	m2aqq0st(2,2,2,2) = 0d0
	m2aqq0ss(2,2,4,4) = 0d0
	m2aqq0tt(2,2,4,4) = 0d0
	m2aqq0st(2,2,4,4) = 0d0
	m2aqq0ss(2,4,2,4) = 0d0
	m2aqq0tt(2,4,2,4) = 0d0
	m2aqq0st(2,4,2,4) = 0d0

	do 201 i1=1,6

	if (i1.eq.1) then
	  mats0  = 0d0
	  matt0  = pret*guu(+1)*guu(-1)
	  fac    = m4213sq(-1,+1)
	elseif (i1.eq.2) then
	  mats0  = -pres*guu(-1)*guu(-1)
	  matt0  =  pret*guu(-1)*guu(-1)
	  fac    = m4213sq(-1,-1)
	elseif (i1.eq.3) then
	  mats0  = -pres*guu(+1)*guu(+1)
	  matt0  =  pret*guu(+1)*guu(+1)
	  fac    = m4213sq(+1,+1)
	elseif (i1.eq.4) then
	  mats0  = 0d0
	  matt0  = pret*guu(-1)*guu(+1)
	  fac    = m4213sq(+1,-1)
	elseif (i1.eq.5) then
	  mats0  = pres*guu(-1)*guu(+1)
	  matt0  = 0d0
	  fac    = m1243sq(-1,+1)
	elseif (i1.eq.6) then
	  mats0  = pres*guu(+1)*guu(-1)
	  matt0  = 0d0
	  fac    = m1243sq(+1,-1)
	endif

c*** ubar-u -ZZ-> ubar-u    
	m2aqq0ss(2,2,2,2) = m2aqq0ss(2,2,2,2) 
     &			    + fac*9d0*abs(mats0)**2 *qch2
	m2aqq0tt(2,2,2,2) = m2aqq0tt(2,2,2,2) 
     &			    + fac*9d0*abs(matt0)**2 *qch2 
	m2aqq0st(2,2,2,2) = m2aqq0st(2,2,2,2) 
     &	      - fac*3d0*2d0*dreal(mats0*dconjg(matt0)) *qchint
c*** ubar-u -Z-> cbar-c 
	m2aqq0ss(2,2,4,4) = m2aqq0ss(2,2,4,4) 
     &			    + fac*9d0*abs(mats0)**2 *qch2 
c*** ubar-c -Z-> ubar-c 
	m2aqq0tt(2,4,2,4) = m2aqq0tt(2,4,2,4) 
     &			    + fac*9d0*abs(matt0)**2 *qch2 
201	continue
	m2aqq0ss(4,4,4,4) = m2aqq0ss(2,2,2,2) 
	m2aqq0tt(4,4,4,4) = m2aqq0tt(2,2,2,2) 
	m2aqq0st(4,4,4,4) = m2aqq0st(2,2,2,2) 
	m2aqq0ss(4,4,2,2) = m2aqq0ss(2,2,4,4)
	m2aqq0tt(4,4,2,2) = m2aqq0tt(2,2,4,4)
	m2aqq0st(4,4,2,2) = m2aqq0st(2,2,4,4)
	m2aqq0ss(4,2,4,2) = m2aqq0ss(2,4,2,4)
	m2aqq0tt(4,2,4,2) = m2aqq0tt(2,4,2,4)
	m2aqq0st(4,2,4,2) = m2aqq0st(2,4,2,4)


c Type: ubar-u -> dbar-d
c----------------------- 

c*** generic amplitudes
	pres = 0d0
	pret = 0d0

c ubar-u -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
        if (checkss12) pres = qz*el3*PZS*PZS12*XMW/(XSW*XCW2)

c ubar-u -W-> dbar-d  (k1->-p1,k2->p3,k3->p4,k4->-p2)
	if (checkt11t22) pret = qw*el3*PWT11*PWT22*XMW/(2D0*XSW*XSW2)

 	do 202 g1=1,2
 	do 202 g2=1,2
 	do 202 g3=1,2+qb
 	do 202 g4=1,2+qb
 	  f1 = 2*g1
 	  f2 = 2*g2
 	  f3 = 2*g3-1
 	  f4 = 2*g4-1
 	  m2aqq0ss(f1,f2,f3,f4) = 0d0
 	  m2aqq0tt(f1,f2,f3,f4) = 0d0
 	  m2aqq0st(f1,f2,f3,f4) = 0d0

	do 202 i1=1,4

	  if (i1.eq.1) then
	    matt0  = 0d0
	    mats0  = pres*guu(+1)*gdd(-1)
	    fac    = m1243sq(-1,+1)
	  elseif (i1.eq.2) then
	    matt0  = -pret
	    mats0  = pres*guu(-1)*gdd(-1)
	    fac    = m1243sq(-1,-1)
	  elseif (i1.eq.3) then
	    matt0  = 0d0
	    mats0  = pres*guu(+1)*gdd(+1)
	    fac    = m1243sq(+1,+1)
	  elseif (i1.eq.4) then
	    matt0  = 0d0
	    mats0  = pres*guu(-1)*gdd(+1)
	    fac    = m1243sq(+1,-1)
	  endif

 	  wmatt0 = cv(g1,g3)*v(g2,g4)*matt0

 	  if ((f1.eq.f2).and.(f3.eq.f4)) then
 	    m2aqq0ss(f1,f2,f3,f4) = m2aqq0ss(f1,f2,f3,f4) 
     &		          + fac*9d0*abs(mats0)**2 *qch2 
 	    m2aqq0tt(f1,f2,f3,f4) = m2aqq0tt(f1,f2,f3,f4) 
     &		          + fac*9d0*abs(wmatt0)**2 *qch2
 	    m2aqq0st(f1,f2,f3,f4) = m2aqq0st(f1,f2,f3,f4) 
     &	          - fac*3d0*2d0*dreal(wmatt0*dconjg(mats0)) *qchint
 	  else
 	    m2aqq0tt(f1,f2,f3,f4) = m2aqq0tt(f1,f2,f3,f4) 
     &			 + fac*9d0*abs(wmatt0)**2 *qch2 
 	  endif
202	  continue


c Type: dbar-d -> dbar-d
c-----------------------

c*** generic amplitudes
	pres = 0d0
	pret = 0d0

c ubar-u -Z-> cbar-c  (k1->-p1,k2->-p2,k3->p4,k4->p3)
	if (checkss12) pres = qz*el3*PZS*PZS12*XMW/(XSW*XCW2)

c ubar-c -Z-> ubar-c  (k1->-p1,k2->p3,k3->p4,k4->-p2)
	if (checkt11t22) pret = qz*el3*PZT11*PZT22*XMW/(XSW*XCW2)

	m2aqq0ss(1,1,1,1) = 0d0
	m2aqq0tt(1,1,1,1) = 0d0
	m2aqq0st(1,1,1,1) = 0d0
	m2aqq0ss(1,1,3,3) = 0d0
	m2aqq0tt(1,1,3,3) = 0d0
	m2aqq0st(1,1,3,3) = 0d0
	m2aqq0ss(1,3,1,3) = 0d0
	m2aqq0tt(1,3,1,3) = 0d0
	m2aqq0st(1,3,1,3) = 0d0

	do 203 i1=1,6

	if (i1.eq.1) then
	  mats0  = 0d0
	  matt0  = pret*gdd(+1)*gdd(-1)
	  fac    = m4213sq(-1,+1)
	elseif (i1.eq.2) then
	  mats0  = -pres*gdd(-1)*gdd(-1)
	  matt0  =  pret*gdd(-1)*gdd(-1)
	  fac    = m4213sq(-1,-1)
	elseif (i1.eq.3) then
	  mats0  = -pres*gdd(+1)*gdd(+1)
	  matt0  =  pret*gdd(+1)*gdd(+1)
	  fac    = m4213sq(+1,+1)
	elseif (i1.eq.4) then
	  mats0  = 0d0
	  matt0  = pret*gdd(-1)*gdd(+1)
	  fac    = m4213sq(+1,-1)
	elseif (i1.eq.5) then
	  mats0  = pres*gdd(-1)*gdd(+1)
	  matt0  = 0d0
	  fac    = m1243sq(-1,+1)
	elseif (i1.eq.6) then
	  mats0  = pres*gdd(+1)*gdd(-1)
	  matt0  = 0d0
	  fac    = m1243sq(+1,-1)
	endif

c*** dbar-d -ZZ-> dbar-d    
	m2aqq0ss(1,1,1,1) = m2aqq0ss(1,1,1,1) 
     &			    + fac*9d0*abs(mats0)**2 *qch2
	m2aqq0tt(1,1,1,1) = m2aqq0tt(1,1,1,1) 
     &			    + fac*9d0*abs(matt0)**2 *qch2
	m2aqq0st(1,1,1,1) = m2aqq0st(1,1,1,1) 
     &	       - fac*3d0*2d0*dreal(mats0*dconjg(matt0)) *qchint
c*** dbar-d -Z-> sbar-s 
	m2aqq0ss(1,1,3,3) = m2aqq0ss(1,1,3,3) 
     &			    + fac*9d0*abs(mats0)**2 *qch2 
c*** dbar-s -Z-> dbar-s 
	m2aqq0tt(1,3,1,3) = m2aqq0tt(1,3,1,3) 
     &			    + fac*9d0*abs(matt0)**2 *qch2 
203	continue
	m2aqq0ss(3,3,3,3) = m2aqq0ss(1,1,1,1) 
	m2aqq0tt(3,3,3,3) = m2aqq0tt(1,1,1,1) 
	m2aqq0st(3,3,3,3) = m2aqq0st(1,1,1,1) 
	m2aqq0ss(3,3,1,1) = m2aqq0ss(1,1,3,3)
	m2aqq0tt(3,3,1,1) = m2aqq0tt(1,1,3,3)
	m2aqq0st(3,3,1,1) = m2aqq0st(1,1,3,3)
	m2aqq0ss(3,1,3,1) = m2aqq0ss(1,3,1,3)
	m2aqq0tt(3,1,3,1) = m2aqq0tt(1,3,1,3)
	m2aqq0st(3,1,3,1) = m2aqq0st(1,3,1,3)
	if (qb.eq.1) then
        m2aqq0ss(5,5,5,5) = m2aqq0ss(1,1,1,1)
        m2aqq0tt(5,5,5,5) = m2aqq0tt(1,1,1,1)
        m2aqq0st(5,5,5,5) = m2aqq0st(1,1,1,1)
        m2aqq0ss(1,1,5,5) = m2aqq0ss(1,1,3,3)
        m2aqq0tt(1,1,5,5) = m2aqq0tt(1,1,3,3)
        m2aqq0st(1,1,5,5) = m2aqq0st(1,1,3,3)
        m2aqq0ss(3,3,5,5) = m2aqq0ss(1,1,3,3)
        m2aqq0tt(3,3,5,5) = m2aqq0tt(1,1,3,3)
        m2aqq0st(3,3,5,5) = m2aqq0st(1,1,3,3)
        m2aqq0ss(5,5,1,1) = m2aqq0ss(1,1,3,3)
        m2aqq0tt(5,5,1,1) = m2aqq0tt(1,1,3,3)
        m2aqq0st(5,5,1,1) = m2aqq0st(1,1,3,3)
        m2aqq0ss(5,5,3,3) = m2aqq0ss(1,1,3,3)
        m2aqq0tt(5,5,3,3) = m2aqq0tt(1,1,3,3)
        m2aqq0st(5,5,3,3) = m2aqq0st(1,1,3,3)
        m2aqq0ss(1,5,1,5) = m2aqq0ss(1,3,1,3)
        m2aqq0tt(1,5,1,5) = m2aqq0tt(1,3,1,3)
        m2aqq0st(1,5,1,5) = m2aqq0st(1,3,1,3)
        m2aqq0ss(3,5,3,5) = m2aqq0ss(1,3,1,3)
        m2aqq0tt(3,5,3,5) = m2aqq0tt(1,3,1,3)
        m2aqq0st(3,5,3,5) = m2aqq0st(1,3,1,3)
        m2aqq0ss(5,1,5,1) = m2aqq0ss(1,3,1,3)
        m2aqq0tt(5,1,5,1) = m2aqq0tt(1,3,1,3)
        m2aqq0st(5,1,5,1) = m2aqq0st(1,3,1,3)
        m2aqq0ss(5,3,5,3) = m2aqq0ss(1,3,1,3)
        m2aqq0tt(5,3,5,3) = m2aqq0tt(1,3,1,3)
        m2aqq0st(5,3,5,3) = m2aqq0st(1,3,1,3)
	endif

c Type: dbar-d -> ubar-u
c-----------------------
	pres = 0d0
	pret = 0d0

c*** generic amplitudes

c dbar-d -Z-> cbar-c  (k3->-p1,k4->-p2,k1->p4,k2->p3)
        if (checkss12) pres = qz*el3*PZS*PZS12*XMW/(XSW*XCW2)

c dbar-s -W-> ubar-c  (k3->-p1,k4->p3,k1->p4,k2->-p2)
	if (checkt11t22) pret = qw*el3*PWT11*PWT22*XMW/(2D0*XSW*XSW2)

 	do 204 g1=1,2+qb
 	do 204 g2=1,2+qb
 	do 204 g3=1,2
 	do 204 g4=1,2
 	  f1 = 2*g1-1
 	  f2 = 2*g2-1
 	  f3 = 2*g3
 	  f4 = 2*g4
 	  m2aqq0ss(f1,f2,f3,f4) = 0d0
 	  m2aqq0tt(f1,f2,f3,f4) = 0d0
 	  m2aqq0st(f1,f2,f3,f4) = 0d0

	do 204 i1=1,4

	  if (i1.eq.1) then
	    matt0  = 0d0
	    mats0  = pres*guu(-1)*gdd(+1)
	    fac    = m1243sq(-1,+1)
	  elseif (i1.eq.2) then
	    matt0  = -pret
	    mats0  = pres*guu(-1)*gdd(-1)
	    fac    = m1243sq(-1,-1)
	  elseif (i1.eq.3) then
	    matt0  = 0d0
	    mats0  = pres*guu(+1)*gdd(+1)
	    fac    = m1243sq(+1,+1)
	  elseif (i1.eq.4) then
	    matt0  = 0d0
	    mats0  = pres*guu(+1)*gdd(-1)
	    fac    = m1243sq(+1,-1)
	  endif

 	  wmatt0 = v(g3,g1)*cv(g4,g2)*matt0

 	  if ((f1.eq.f2).and.(f3.eq.f4)) then
 	    m2aqq0ss(f1,f2,f3,f4) = m2aqq0ss(f1,f2,f3,f4) 
     &		         + fac*9d0*abs(mats0)**2 *qch2
 	    m2aqq0tt(f1,f2,f3,f4) = m2aqq0tt(f1,f2,f3,f4) 
     &		         + fac*9d0*abs(wmatt0)**2 *qch2
 	    m2aqq0st(f1,f2,f3,f4) = m2aqq0st(f1,f2,f3,f4) 
     &	          - fac*3d0*2d0*dreal(wmatt0*dconjg(mats0)) *qchint
 	  else
 	    m2aqq0tt(f1,f2,f3,f4) = m2aqq0tt(f1,f2,f3,f4) 
     &			 + fac*9d0*abs(wmatt0)**2 *qch2 
 	  endif
204	  continue

	end

************************************************************************
        subroutine Mat2endp(p,m2i,m2if)
************************************************************************
*       Endpoint contribution for subtraction function for
*	    parton1(p1) + parton2(p2) --> f(p3) + f'(p4) + H(p5)
*-----------------------------------------------------------------------
*       13.10.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
	complex*16 guu,gdd,gnn,gll     
        real*8 p(6,0:3),qp(-4:4),mp2(-4:4),s(6,6)
        real*8 m2i0(-5:5,-5:5),m2i(-5:5,-5:5)
        real*8 m2if0(-5:5,-5:5,-5:5,-5:5),m2if(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_22(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_33(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_44(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_nd(-5:5,-5:5,-5:5,-5:5)
	integer i1,i2,i3,i4,j1,j2,i,j,k
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        common/qf/qu,qd,ql,qn,qf(4),mu,mu2,md,md2,mlep,mlep2,
     &            guu(-1:1),gdd(-1:1),gnn(-1:1),gll(-1:1)
        common/constsub/constff,constfi,constif,constii
        COMMON/IR/LAMBDA,LAMBDA2

        L(p2,mi2,mj2) =  (log(mi2/p2)+log(mj2/p2)+2d0)*log(lambda2/p2)
     &                  -log(mi2/p2)**2/2d0+log(mi2/p2)/2d0
     &                  -log(mj2/p2)**2/2d0+log(mj2/p2)/2d0

	qp(1) = qd
	qp(2) = qu
	qp(3) = qd
	qp(4) = qu
	mp2(1) = md2
	mp2(2) = mu2
	mp2(3) = md2
	mp2(4) = mu2
	do i=1,4
	  qp(-i)  = -qp(i)
	  mp2(-i) = mp2(i)
	enddo

	cii = 2d0*constii+1d0
	cff = 2d0*constff+1d0
	cfi = constif+constfi+1d0

	do 100 i=1,5
	do 100 j=1,5
	  s(i,j) = 2d0*( p(i,0)*p(j,0)-p(i,1)*p(j,1)
     &		        -p(i,2)*p(j,2)-p(i,3)*p(j,3) )
100	continue

        call Mat2born(p,m2i0,m2if0,
     &               m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)

        do 200 i1=-4,4
        do 200 i2=-4,4
          m2i(i1,i2) = 0d0
          if (i1*i2.eq.0) goto 200
        do 300 j1=1,4
        do 300 j2=1,4
	  i3 = sign(j1,i1)
	  i4 = sign(j2,i2)
	  if (nint(qp(i1)+qp(i2)-qp(i3)-qp(i4)).ne.0) goto 300
	  m2if(i1,i2,i3,i4) = 0d0
	  if (qbos.ne.0) m2if(i1,i2,i3,i4) = m2if(i1,i2,i3,i4)
     &	    -alpha/2d0/pi*m2if0(i1,i2,i3,i4)*(
     &	       qp(i1)*qp(i2)*(L(s(1,2),mp2(i1),mp2(i2))+cii)
     &	      +qp(i3)*qp(i4)*(L(s(3,4),mp2(i3),mp2(i4))+cff)
     &	      -qp(i1)*qp(i3)*(L(s(1,3),mp2(i1),mp2(i3))+cfi)
     &	      -qp(i2)*qp(i4)*(L(s(2,4),mp2(i2),mp2(i4))+cfi)
     &	      -qp(i1)*qp(i4)*(L(s(1,4),mp2(i1),mp2(i4))+cfi)
     &	      -qp(i2)*qp(i3)*(L(s(2,3),mp2(i2),mp2(i3))+cfi) )
	  if (qqcddiag.ne.0) m2if(i1,i2,i3,i4) = m2if(i1,i2,i3,i4)
     &	    -alphas*2d0/3d0/pi*(
     &	      + ( sign(1,i1*i2)*(L(s(1,2),mp2(i1),mp2(i2))+cii)
     &	         +sign(1,i3*i4)*(L(s(3,4),mp2(i3),mp2(i4))+cff) )
     &	        *m2if0_22(i1,i2,i3,i4)
     &	      - ( sign(1,i1*i3)*(L(s(1,3),mp2(i1),mp2(i3))+cfi)
     &	         +sign(1,i2*i4)*(L(s(2,4),mp2(i2),mp2(i4))+cfi) )
     &	        *m2if0_33(i1,i2,i3,i4) 				  
     &	      - ( sign(1,i1*i4)*(L(s(1,4),mp2(i1),mp2(i4))+cfi)
     &	         +sign(1,i2*i3)*(L(s(2,3),mp2(i2),mp2(i3))+cfi) )
     &	        *m2if0_44(i1,i2,i3,i4)	   			  )
	  if (qqcdnondiag.ne.0) m2if(i1,i2,i3,i4) = m2if(i1,i2,i3,i4)
     &      -alphas*2d0/3d0/pi*m2if0_nd(i1,i2,i3,i4)*(
     &         sign(1,i1*i2)*(L(s(1,2),mp2(i1),mp2(i2))+cii)
     &        +sign(1,i3*i4)*(L(s(3,4),mp2(i3),mp2(i4))+cff)
     &        -sign(1,i1*i3)*(L(s(1,3),mp2(i1),mp2(i3))+cfi)
     &        -sign(1,i2*i4)*(L(s(2,4),mp2(i2),mp2(i4))+cfi) 
     &        -sign(1,i1*i4)*(L(s(1,4),mp2(i1),mp2(i4))+cfi)
     &        -sign(1,i2*i3)*(L(s(2,3),mp2(i2),mp2(i3))+cfi) )
          m2i(i1,i2) = m2i(i1,i2) + m2if(i1,i2,i3,i4)
300     continue
200     continue

	end

************************************************************************
        function delta_gdqcd(s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       relative QCD correction factor 
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*-----------------------------------------------------------------------
*       25.5.12 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 PRE,delta_gdqcd,loop,ct
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 dZuu,dZdd,dZqq(4)
        complex*16 guu,gdd,gnn,gll    
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
	integer i

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/qf/qu,qd,ql,qn,qf(4),mu,mu2,md,md2,mlep,mlep2,
     &            guu(-1:1),gdd(-1:1),gnn(-1:1),gll(-1:1)
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        COMMON/UV/MUDIM2
        COMMON/IR/LAMBDA,LAMBDA2
        common/constsub/constff,constfi,constif,constii

        L(p2,mi2,mj2) =  (log(mi2/p2)+log(mj2/p2)+2d0)*log(lambda2/p2)
     &                  -log(mi2/p2)**2/2d0+log(mi2/p2)/2d0
     &                  -log(mj2/p2)**2/2d0+log(mj2/p2)/2d0

        delta_gdqcd = 0d0

        dZuu = -1d0/3D0/PI*(log(mudim2/mu2)+4d0+4d0*log(lambda/mu))
        dZdd = -1d0/3D0/PI*(log(mudim2/md2)+4d0+4d0*log(lambda/md))

	do i=1,4
	  if (qf(i).eq.qu) dZqq(i) = dZuu
	  if (qf(i).eq.qd) dZqq(i) = dZdd
	enddo

	if (qf(1)*qf(2).ne.0d0) then

          CALL xC01234_(RMF2(2),S12,RMF2(1),NULL,CMF2(2),CMF2(1),
     &	  C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

          loop   = -4d0/3d0*alphas*(1D0-2D0*C2(0,0)+C1(1)*S12
     &                      +C1(2)*S12+C2(1,2)*S12+C0*S12)/(2D0*PI)
          ct     = alphas*(dZqq(1)+dZqq(2))/2d0

          if (t11*t12.lt.0d0) const = constif+constfi+1d0
          if ((t11.lt.0d0).and.(t12.lt.0d0)) const = 2d0*constii+1d0
          if ((t11.gt.0d0).and.(t12.gt.0d0)) const = 2d0*constff+1d0
          Gsubgd = alphas/3d0/pi*(L(abs(s12),mf2(1),mf2(2))+const)

          delta_gdqcd = delta_gdqcd + loop + ct + Gsubgd
	endif

	if (qf(3)*qf(4).ne.0d0) then
          CALL xC01234_(RMF2(3),S34,RMF2(4),NULL,CMF2(3),CMF2(4),
     &	  C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

          loop   = -4d0/3d0*alphas*(1D0-2D0*C2(0,0)+C1(1)*S34
     &                      +C1(2)*S34+C2(1,2)*S34+C0*S34)/(2D0*PI)
          ct     = alphas*(dZqq(3)+dZqq(4))/2d0

          if (t13*t14.lt.0d0) const = constif+constfi+1d0
          if ((t13.lt.0d0).and.(t14.lt.0d0)) const = 2d0*constii+1d0
          if ((t13.gt.0d0).and.(t14.gt.0d0)) const = 2d0*constff+1d0
          Gsubgd = alphas/3d0/pi*(L(abs(s34),mf2(3),mf2(4)) + const)

          delta_gdqcd = delta_gdqcd + loop + ct + Gsubgd
	endif

	end

************************************************************************
        subroutine Mat2aqqbornhvv(m2aqq0ss,m2aqq0tt,m2aqq0st,
     &	                          q1,q2,q3,q4,qb)
************************************************************************
*       generic Born structures needed for subtraction function for
*	    anti-q(p1) + q(p2) --> f(p3) + f'(p4) + H(p5)
*
*	including anomalous HVV couplings !!!
*
*       from generic amplitudes for
*	    H(p) --> fa(k1) + anti-fb(k2) + fc(k3) + anti-fd(k4)
*	         CC: f1     + anti-f2     + f3     + anti-f4     
*	         NC: f1     + anti-f1     + f3     + anti-f3     
*	             f2     + anti-f2     + f3     + anti-f3     
*	             f1     + anti-f1     + f4     + anti-f4     
*
*	fermions: f1,f4 = generic   up-type fermions
*	          f2,f3 = generic down-type fermions
*-----------------------------------------------------------------------
*       14.6.12 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 msH4f(-1:1,-1:1),mtH4f(-1:1,-1:1)
	complex*16 mats0,matt0,wmats0,wmatt0
	complex*16 sp(-4:4,-4:4),csp(-4:4,-4:4)
	complex*16 v,cv
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        real*8 m2aqq0ss(5,5,5,5),m2aqq0tt(5,5,5,5),m2aqq0st(5,5,5,5)
        real*8 vp(-4:4,-4:4)
	integer ia,ib,ic,id,q1,q2,q3,q4
	integer i1,i2,i3,i4,j,j1,j2,f1,f2,f3,f4,g1,g2,g3,g4,qb
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
	complex*16 guu,gdd,gnn,gll     

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/qf/qu,qd,ql,qn,qf(4),mu,mu2,md,md2,mlep,mlep2,
     &            guu(-1:1),gdd(-1:1),gnn(-1:1),gll(-1:1)
	common/prods3/sp,csp,vp

	fac = el**6

c invariants
        s   = vp(q1,q2)
	s12 = vp(q3,q4)
	t11 = vp(q1,q3)
	t22 = vp(q2,q4)

	call fixahvv(s,s12,
     &             a1hwws,a2hwws,a3hwws,a1haas,a2haas,a3haas,
     &             a1hazs,a2hazs,a3hazs,a1hzzs,a2hzzs,a3hzzs)
	call fixahvv(t11,t22,
     &             a1hwwt,a2hwwt,a3hwwt,a1haat,a2haat,a3haat,
     &             a1hazt,a2hazt,a3hazt,a1hzzt,a2hzzt,a3hzzt)

c qbar-q scattering
c
c   s-channel:                             t-channel:
c
c   fa(p1) \_          / fd(p3)            fa(p1) --<--*--<-- fb(p3)
c          |\        |/                                >
c            \       /-                                >
c             *vvvvv*                                  >
c           _/       \                                 >
c           /|        \|                               >
c   fb(p2) /          -\ fc(p4)            fd(p2) -->--*-->-- fc(p4)


c Type: ubar-d -> ubar-d
c-----------------------

c*** generic amplitudes
	do i1=-1,1,2
	do i2=-1,1,2
	  msH4f(i1,i2) = 0d0
	  mtH4f(i1,i2) = 0d0
	enddo
	enddo

c ubar-d -W-> cbar-s    (k1->-p1,k2->-p2,k3->p4,k4->p3)   
	if (qw.eq.1) call M_WW_hvv(msH4f,q1,q2,q4,q3,
     &	                  a1hwws,a2hwws,a3hwws)

c ubar-s -Z-> ubar-s    (k1->-p1,k2->p3,k3->p4,k4->-p2)   
	if (qz.eq.1) call M_ZZ_hvv(mtH4f,guu,gdd,qu,qd,q1,q3,q4,q2,
     &	                  a1haat,a2haat,a3haat,a1hazt,a2hazt,a3hazt,
     &	                  a1hzzt,a2hzzt,a3hzzt)

c*** individual channels
 	do 200 g1=1,2
 	do 200 g2=1,2+qb
 	do 200 g3=1,2
 	do 200 g4=1,2+qb
 	  f1 = 2*g1
 	  f2 = 2*g2-1
 	  f3 = 2*g3
 	  f4 = 2*g4-1
 	  m2aqq0ss(f1,f2,f3,f4) = 0d0
 	  m2aqq0tt(f1,f2,f3,f4) = 0d0
 	  m2aqq0st(f1,f2,f3,f4) = 0d0

	do 200 i1=-1,1,2
	do 200 i2=-1,1,2
	do 200 i3=-1,1,2
	  mats0  = 0d0
	  matt0  = 0d0

          if (i1.eq.-i2) mats0  = msH4f(i2,i3)
          if (i1.eq.-i3) matt0  = mtH4f(i3,i2)

 	  wmats0 = cv(g1,g2)*v(g3,g4)*mats0

 	  if ((f1.eq.f3).and.(f2.eq.f4)) then
 	    m2aqq0ss(f1,f2,f3,f4) = m2aqq0ss(f1,f2,f3,f4) 
     &		         + fac*9d0*abs(wmats0)**2 *qch2
 	    m2aqq0tt(f1,f2,f3,f4) = m2aqq0tt(f1,f2,f3,f4) 
     &		         + fac*9d0*abs(matt0)**2 *qch2
 	    m2aqq0st(f1,f2,f3,f4) = m2aqq0st(f1,f2,f3,f4) 
     &	          - fac*3d0*2d0*dreal(wmats0*dconjg(matt0)) *qchint 
 	  else
 	    m2aqq0ss(f1,f2,f3,f4) = m2aqq0ss(f1,f2,f3,f4) 
     &			 + fac*9d0*abs(wmats0)**2 *qch2 
 	  endif

200	continue

c Type: dbar-u -> dbar-u
c-----------------------

c*** generic amplitudes
	do i1=-1,1,2
	do i2=-1,1,2
	  msH4f(i1,i2) = 0d0
	  mtH4f(i1,i2) = 0d0
	enddo
	enddo

c dbar-u -W-> sbar-c    (k3->-p1,k4->-p2,k1->p4,k2->p3)   
	if (qw.eq.1) call M_WW_hvv(msH4f,q4,q3,q1,q2,
     &	                  a1hwws,a2hwws,a3hwws)

c dbar-c -Z-> dbar-c    (k3->-p1,k4->p3,k1->p4,k2->-p2)   
	if (qz.eq.1) call M_ZZ_hvv(mtH4f,guu,gdd,qu,qd,q4,q2,q1,q3,
     &	                  a1haat,a2haat,a3haat,a1hazt,a2hazt,a3hazt,
     &	                  a1hzzt,a2hzzt,a3hzzt)

 	do 205 g1=1,2+qb
 	do 205 g2=1,2
 	do 205 g3=1,2+qb
 	do 205 g4=1,2
 	  f1 = 2*g1-1
 	  f2 = 2*g2
 	  f3 = 2*g3-1
 	  f4 = 2*g4
 	  m2aqq0ss(f1,f2,f3,f4) = 0d0
 	  m2aqq0tt(f1,f2,f3,f4) = 0d0
 	  m2aqq0st(f1,f2,f3,f4) = 0d0

	do 205 i1=-1,1,2
	do 205 i2=-1,1,2
	do 205 i3=-1,1,2
	  mats0  = 0d0
	  matt0  = 0d0

	   if (i1.eq.-i2) mats0  = msH4f(i3,i2)
	   if (i1.eq.-i3) matt0  = mtH4f(i2,i3)

 	  wmats0 = v(g2,g1)*cv(g4,g3)*mats0

 	  if ((f1.eq.f3).and.(f2.eq.f4)) then
 	    m2aqq0ss(f1,f2,f3,f4) = m2aqq0ss(f1,f2,f3,f4) 
     &		         + fac*9d0*abs(wmats0)**2 *qch2 
 	    m2aqq0tt(f1,f2,f3,f4) = m2aqq0tt(f1,f2,f3,f4) 
     &		         + fac*9d0*abs(matt0)**2 *qch2 
 	    m2aqq0st(f1,f2,f3,f4) = m2aqq0st(f1,f2,f3,f4) 
     &	          - fac*3d0*2d0*dreal(wmats0*dconjg(matt0)) *qchint
 	  else
 	    m2aqq0ss(f1,f2,f3,f4) = m2aqq0ss(f1,f2,f3,f4) 
     &			 + fac*9d0*abs(wmats0)**2 *qch2 
 	  endif
205	continue


c Type: ubar-u -> ubar-u
c----------------------- 

c*** generic amplitudes
	do i1=-1,1,2
	do i2=-1,1,2
	  msH4f(i1,i2) = 0d0
	  mtH4f(i1,i2) = 0d0
	enddo
	enddo

c ubar-u -Z-> cbar-c  (k1->-p1,k2->-p2,k3->p4,k4->p3)
	if (qz.eq.1) call M_ZZ_hvv(msH4f,guu,guu,qu,qu,q1,q2,q4,q3,
     &	                  a1haas,a2haas,a3haas,a1hazs,a2hazs,a3hazs,
     &	                  a1hzzs,a2hzzs,a3hzzs)

c ubar-c -Z-> ubar-c  (k1->-p1,k2->p3,k3->p4,k4->-p2)
	if (qz.eq.1) call M_ZZ_hvv(mtH4f,guu,guu,qu,qu,q1,q3,q4,q2,
     &	                  a1haat,a2haat,a3haat,a1hazt,a2hazt,a3hazt,
     &	                  a1hzzt,a2hzzt,a3hzzt)

	m2aqq0ss(2,2,2,2) = 0d0
	m2aqq0tt(2,2,2,2) = 0d0
	m2aqq0st(2,2,2,2) = 0d0
	m2aqq0ss(2,2,4,4) = 0d0
	m2aqq0tt(2,2,4,4) = 0d0
	m2aqq0st(2,2,4,4) = 0d0
	m2aqq0ss(2,4,2,4) = 0d0
	m2aqq0tt(2,4,2,4) = 0d0
	m2aqq0st(2,4,2,4) = 0d0

	do 201 i1=-1,1,2
	do 201 i2=-1,1,2
	do 201 i3=-1,1,2
	  mats0  = 0d0
	  matt0  = 0d0

	  if (i1.eq.-i2) mats0  = msH4f(i2,i3)
	  if (i1.eq.-i3) matt0  = mtH4f(i3,i2)

c*** ubar-u -ZZ-> ubar-u    
	m2aqq0ss(2,2,2,2) = m2aqq0ss(2,2,2,2) 
     &			    + fac*9d0*abs(mats0)**2 *qch2
	m2aqq0tt(2,2,2,2) = m2aqq0tt(2,2,2,2) 
     &			    + fac*9d0*abs(matt0)**2 *qch2 
	m2aqq0st(2,2,2,2) = m2aqq0st(2,2,2,2) 
     &	      - fac*3d0*2d0*dreal(mats0*dconjg(matt0)) *qchint
c*** ubar-u -Z-> cbar-c 
	m2aqq0ss(2,2,4,4) = m2aqq0ss(2,2,4,4) 
     &			    + fac*9d0*abs(mats0)**2 *qch2 
c*** ubar-c -Z-> ubar-c 
	m2aqq0tt(2,4,2,4) = m2aqq0tt(2,4,2,4) 
     &			    + fac*9d0*abs(matt0)**2 *qch2 
201	continue
	m2aqq0ss(4,4,4,4) = m2aqq0ss(2,2,2,2) 
	m2aqq0tt(4,4,4,4) = m2aqq0tt(2,2,2,2) 
	m2aqq0st(4,4,4,4) = m2aqq0st(2,2,2,2) 
	m2aqq0ss(4,4,2,2) = m2aqq0ss(2,2,4,4)
	m2aqq0tt(4,4,2,2) = m2aqq0tt(2,2,4,4)
	m2aqq0st(4,4,2,2) = m2aqq0st(2,2,4,4)
	m2aqq0ss(4,2,4,2) = m2aqq0ss(2,4,2,4)
	m2aqq0tt(4,2,4,2) = m2aqq0tt(2,4,2,4)
	m2aqq0st(4,2,4,2) = m2aqq0st(2,4,2,4)


c Type: ubar-u -> dbar-d
c----------------------- 

c*** generic amplitudes
	do i1=-1,1,2
	do i2=-1,1,2
	  msH4f(i1,i2) = 0d0
	  mtH4f(i1,i2) = 0d0
	enddo
	enddo

c ubar-u -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
	if (qz.eq.1) call M_ZZ_hvv(msH4f,guu,gdd,qu,qd,q1,q2,q4,q3,
     &	                  a1haas,a2haas,a3haas,a1hazs,a2hazs,a3hazs,
     &	                  a1hzzs,a2hzzs,a3hzzs)

c ubar-u -W-> dbar-d  (k1->-p1,k2->p3,k3->p4,k4->-p2)
	if (qw.eq.1) call M_WW_hvv(mtH4f,q1,q3,q4,q2,
     &	                  a1hwwt,a2hwwt,a3hwwt)

 	do 202 g1=1,2
 	do 202 g2=1,2
 	do 202 g3=1,2+qb
 	do 202 g4=1,2+qb
 	  f1 = 2*g1
 	  f2 = 2*g2
 	  f3 = 2*g3-1
 	  f4 = 2*g4-1
 	  m2aqq0ss(f1,f2,f3,f4) = 0d0
 	  m2aqq0tt(f1,f2,f3,f4) = 0d0
 	  m2aqq0st(f1,f2,f3,f4) = 0d0

	do 202 i1=-1,1,2
	do 202 i2=-1,1,2
	do 202 i3=-1,1,2
	  mats0  = 0d0
	  matt0  = 0d0

	  if (i1.eq.-i2) mats0  = msH4f(i2,i3)
	  if (i1.eq.-i3) matt0  = mtH4f(i3,i2)

 	  wmatt0 = cv(g1,g3)*v(g2,g4)*matt0

 	  if ((f1.eq.f2).and.(f3.eq.f4)) then
 	    m2aqq0ss(f1,f2,f3,f4) = m2aqq0ss(f1,f2,f3,f4) 
     &		          + fac*9d0*abs(mats0)**2 *qch2 
 	    m2aqq0tt(f1,f2,f3,f4) = m2aqq0tt(f1,f2,f3,f4) 
     &		          + fac*9d0*abs(wmatt0)**2 *qch2
 	    m2aqq0st(f1,f2,f3,f4) = m2aqq0st(f1,f2,f3,f4) 
     &	          - fac*3d0*2d0*dreal(wmatt0*dconjg(mats0)) *qchint
 	  else
 	    m2aqq0tt(f1,f2,f3,f4) = m2aqq0tt(f1,f2,f3,f4) 
     &			 + fac*9d0*abs(wmatt0)**2 *qch2 
 	  endif
202	  continue


c Type: dbar-d -> dbar-d
c-----------------------

c*** generic amplitudes
	do i1=-1,1,2
	do i2=-1,1,2
	  msH4f(i1,i2) = 0d0
	  mtH4f(i1,i2) = 0d0
	enddo
	enddo

c ubar-u -Z-> cbar-c  (k1->-p1,k2->-p2,k3->p4,k4->p3)
	if (qz.eq.1) call M_ZZ_hvv(msH4f,gdd,gdd,qd,qd,q1,q2,q4,q3,
     &	                  a1haas,a2haas,a3haas,a1hazs,a2hazs,a3hazs,
     &	                  a1hzzs,a2hzzs,a3hzzs)

c ubar-c -Z-> ubar-c  (k1->-p1,k2->p3,k3->p4,k4->-p2)
	if (qz.eq.1) call M_ZZ_hvv(mtH4f,gdd,gdd,qd,qd,q1,q3,q4,q2,
     &	                  a1haat,a2haat,a3haat,a1hazt,a2hazt,a3hazt,
     &	                  a1hzzt,a2hzzt,a3hzzt)

	m2aqq0ss(1,1,1,1) = 0d0
	m2aqq0tt(1,1,1,1) = 0d0
	m2aqq0st(1,1,1,1) = 0d0
	m2aqq0ss(1,1,3,3) = 0d0
	m2aqq0tt(1,1,3,3) = 0d0
	m2aqq0st(1,1,3,3) = 0d0
	m2aqq0ss(1,3,1,3) = 0d0
	m2aqq0tt(1,3,1,3) = 0d0
	m2aqq0st(1,3,1,3) = 0d0

	do 203 i1=-1,1,2
	do 203 i2=-1,1,2
	do 203 i3=-1,1,2
	  mats0  = 0d0
	  matt0  = 0d0

	  if (i1.eq.-i2) mats0  = msH4f(i2,i3)
	  if (i1.eq.-i3) matt0  = mtH4f(i3,i2)

c*** dbar-d -ZZ-> dbar-d    
	m2aqq0ss(1,1,1,1) = m2aqq0ss(1,1,1,1) 
     &			    + fac*9d0*abs(mats0)**2 *qch2
	m2aqq0tt(1,1,1,1) = m2aqq0tt(1,1,1,1) 
     &			    + fac*9d0*abs(matt0)**2 *qch2
	m2aqq0st(1,1,1,1) = m2aqq0st(1,1,1,1) 
     &	       - fac*3d0*2d0*dreal(mats0*dconjg(matt0)) *qchint
c*** dbar-d -Z-> sbar-s 
	m2aqq0ss(1,1,3,3) = m2aqq0ss(1,1,3,3) 
     &			    + fac*9d0*abs(mats0)**2 *qch2 
c*** dbar-s -Z-> dbar-s 
	m2aqq0tt(1,3,1,3) = m2aqq0tt(1,3,1,3) 
     &			    + fac*9d0*abs(matt0)**2 *qch2 
203	continue
	m2aqq0ss(3,3,3,3) = m2aqq0ss(1,1,1,1) 
	m2aqq0tt(3,3,3,3) = m2aqq0tt(1,1,1,1) 
	m2aqq0st(3,3,3,3) = m2aqq0st(1,1,1,1) 
	m2aqq0ss(3,3,1,1) = m2aqq0ss(1,1,3,3)
	m2aqq0tt(3,3,1,1) = m2aqq0tt(1,1,3,3)
	m2aqq0st(3,3,1,1) = m2aqq0st(1,1,3,3)
	m2aqq0ss(3,1,3,1) = m2aqq0ss(1,3,1,3)
	m2aqq0tt(3,1,3,1) = m2aqq0tt(1,3,1,3)
	m2aqq0st(3,1,3,1) = m2aqq0st(1,3,1,3)
	if (qb.eq.1) then
        m2aqq0ss(5,5,5,5) = m2aqq0ss(1,1,1,1)
        m2aqq0tt(5,5,5,5) = m2aqq0tt(1,1,1,1)
        m2aqq0st(5,5,5,5) = m2aqq0st(1,1,1,1)
        m2aqq0ss(1,1,5,5) = m2aqq0ss(1,1,3,3)
        m2aqq0tt(1,1,5,5) = m2aqq0tt(1,1,3,3)
        m2aqq0st(1,1,5,5) = m2aqq0st(1,1,3,3)
        m2aqq0ss(3,3,5,5) = m2aqq0ss(1,1,3,3)
        m2aqq0tt(3,3,5,5) = m2aqq0tt(1,1,3,3)
        m2aqq0st(3,3,5,5) = m2aqq0st(1,1,3,3)
        m2aqq0ss(5,5,1,1) = m2aqq0ss(1,1,3,3)
        m2aqq0tt(5,5,1,1) = m2aqq0tt(1,1,3,3)
        m2aqq0st(5,5,1,1) = m2aqq0st(1,1,3,3)
        m2aqq0ss(5,5,3,3) = m2aqq0ss(1,1,3,3)
        m2aqq0tt(5,5,3,3) = m2aqq0tt(1,1,3,3)
        m2aqq0st(5,5,3,3) = m2aqq0st(1,1,3,3)
        m2aqq0ss(1,5,1,5) = m2aqq0ss(1,3,1,3)
        m2aqq0tt(1,5,1,5) = m2aqq0tt(1,3,1,3)
        m2aqq0st(1,5,1,5) = m2aqq0st(1,3,1,3)
        m2aqq0ss(3,5,3,5) = m2aqq0ss(1,3,1,3)
        m2aqq0tt(3,5,3,5) = m2aqq0tt(1,3,1,3)
        m2aqq0st(3,5,3,5) = m2aqq0st(1,3,1,3)
        m2aqq0ss(5,1,5,1) = m2aqq0ss(1,3,1,3)
        m2aqq0tt(5,1,5,1) = m2aqq0tt(1,3,1,3)
        m2aqq0st(5,1,5,1) = m2aqq0st(1,3,1,3)
        m2aqq0ss(5,3,5,3) = m2aqq0ss(1,3,1,3)
        m2aqq0tt(5,3,5,3) = m2aqq0tt(1,3,1,3)
        m2aqq0st(5,3,5,3) = m2aqq0st(1,3,1,3)
	endif

c Type: dbar-d -> ubar-u
c-----------------------
	do i1=-1,1,2
	do i2=-1,1,2
	  msH4f(i1,i2) = 0d0
	  mtH4f(i1,i2) = 0d0
	enddo
	enddo

c*** generic amplitudes

c dbar-d -Z-> cbar-c  (k3->-p1,k4->-p2,k1->p4,k2->p3)
	if (qz.eq.1) call M_ZZ_hvv(msH4f,guu,gdd,qu,qd,q4,q3,q1,q2,
     &	                  a1haas,a2haas,a3haas,a1hazs,a2hazs,a3hazs,
     &	                  a1hzzs,a2hzzs,a3hzzs)

c dbar-s -W-> ubar-c  (k3->-p1,k4->p3,k1->p4,k2->-p2)
	if (qw.eq.1) call M_WW_hvv(mtH4f,q4,q2,q1,q3,
     &	                  a1hwwt,a2hwwt,a3hwwt)

 	do 204 g1=1,2+qb
 	do 204 g2=1,2+qb
 	do 204 g3=1,2
 	do 204 g4=1,2
 	  f1 = 2*g1-1
 	  f2 = 2*g2-1
 	  f3 = 2*g3
 	  f4 = 2*g4
 	  m2aqq0ss(f1,f2,f3,f4) = 0d0
 	  m2aqq0tt(f1,f2,f3,f4) = 0d0
 	  m2aqq0st(f1,f2,f3,f4) = 0d0

	do 204 i1=-1,1,2
	do 204 i2=-1,1,2
	do 204 i3=-1,1,2
	  mats0  = 0d0
	  matt0  = 0d0

	  if (i1.eq.-i2) mats0  = msH4f(i3,i2)
	  if (i1.eq.-i3) matt0  = mtH4f(i2,i3)

 	  wmatt0 = v(g3,g1)*cv(g4,g2)*matt0

 	  if ((f1.eq.f2).and.(f3.eq.f4)) then
 	    m2aqq0ss(f1,f2,f3,f4) = m2aqq0ss(f1,f2,f3,f4) 
     &		         + fac*9d0*abs(mats0)**2 *qch2
 	    m2aqq0tt(f1,f2,f3,f4) = m2aqq0tt(f1,f2,f3,f4) 
     &		         + fac*9d0*abs(wmatt0)**2 *qch2
 	    m2aqq0st(f1,f2,f3,f4) = m2aqq0st(f1,f2,f3,f4) 
     &	          - fac*3d0*2d0*dreal(wmatt0*dconjg(mats0)) *qchint
 	  else
 	    m2aqq0tt(f1,f2,f3,f4) = m2aqq0tt(f1,f2,f3,f4) 
     &			 + fac*9d0*abs(wmatt0)**2 *qch2 
 	  endif
204	  continue

	end

************************************************************************
        subroutine fixahvv(q1,q2,
     &             a1hwwf,a2hwwf,a3hwwf,a1haaf,a2haaf,a3haaf,
     &             a1hazf,a2hazf,a3hazf,a1hzzf,a2hzzf,a3hzzf)
************************************************************************
*       rescale anomalous HVV couplings by form factor
*       q1,q2 = virtualities of vector bosons
*-----------------------------------------------------------------------
*       14.6.12 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 v,cv
        integer qhvv

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/hvv/rsm,d,db,dt,dtb,lambdahvv,
     &             a1hww,a2hww,a3hww,a1haa,a2haa,a3haa,
     &             a1haz,a2haz,a3haz,a1hzz,a2hzz,a3hzz,qhvv

c Form factor for high momentum transfer
        if (lambdahvv.gt.0d0) then
          formfac_ww = lambdahvv**4/(lambdahvv**2+abs(q1))
     &                             /(lambdahvv**2+abs(q2))
        else
          formfac_ww = 1d0
        endif

        formfac_zz = formfac_ww
        formfac_aa = formfac_ww
        formfac_az = formfac_ww

c Suppression factor for too low momentum transfer
        m0 = 1d0
        suppress   = abs(q1)/(abs(q1)+m0**2)*abs(q2)/(abs(q2)+m0**2)

c HVV couplings
        a1hwwf = a1hww
        a2hwwf = a2hww * formfac_ww
        a3hwwf = a3hww * formfac_ww
        a1haaf = a1haa               * suppress
        a2haaf = a2haa * formfac_aa  * suppress
        a3haaf = a3haa * formfac_aa  * suppress
        a1hazf = a1haz               * suppress
        a2hazf = a2haz * formfac_az  * suppress
        a3hazf = a3haz * formfac_az  * suppress
        a1hzzf = a1hzz               * suppress
        a2hzzf = a2hzz * formfac_zz  * suppress
        a3hzzf = a3hzz * formfac_zz  * suppress

        end

************************************************************************
        subroutine M_WW_hvv(mH4f,fa,fb,fc,fd,a1,a2,a3)
************************************************************************
*       Helicity amplitudes for
*       H -> WW -> fa + fb-bar + fc + fd-bar 
*       with anomalous HVV couplings
*-----------------------------------------------------------------------
*       14.6.12 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 sp(-4:4,-4:4),csp(-4:4,-4:4)
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
        complex*16 pwab,pwcd
        complex*16 Amm,mH4f(-1:1,-1:1)
        complex*16 fac
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        real*8 vp(-4:4,-4:4)
        integer fa,fb,fc,fd,ia,ib,ic,id,i1,i2,i3
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        logical check

        common/prods3/sp,csp,vp
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	Amm(ia,ib,ic,id,a1,a2,a3) = 2d0*a1*sp(ia,ic)*csp(ib,id)
     &	  + dcmplx(a2,+a3)*sp(ic,ia)*csp(ib,ia)*sp(ia,ic)*csp(id,ic)
     &	  + dcmplx(a2,-a3)*sp(ia,ib)*csp(id,ib)*sp(ic,id)*csp(ib,id)

        sab  = vp(fa,fb)
        scd  = vp(fc,fd)

        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(sab.lt.0d0))) then
          pwab = 1d0/(sab-mw2)
        else
          pwab = 1d0/(sab-cmw2)
        endif
        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(scd.lt.0d0))) then
          pwcd = 1d0/(scd-mw2)
        else
          pwcd = 1d0/(scd-cmw2)
        endif

        check = ((qschan.eq.1).and.(sab.gt.0d0).and.(scd.gt.0d0))
     &     .or. ((qtchan.eq.1).and.(sab.lt.0d0).and.(scd.lt.0d0))

        if (.not.check) pwab = 0d0

	mH4f(+1,+1) = 0d0
	mH4f(+1,-1) = 0d0
	mH4f(-1,+1) = 0d0
	mH4f(-1,-1) = pwab*pwcd/2d0/xsw2*Amm(fa,fb,fc,fd,a1,a2,a3)

	end

************************************************************************
        subroutine M_ZZ_hvv(mH4f,gaz,gcz,qa,qc,fa,fb,fc,fd,
     &	             a1aa,a2aa,a3aa,a1az,a2az,a3az,a1zz,a2zz,a3zz)
************************************************************************
*       Helicity amplitudes for
*       H -> AA/AZ/ZZ -> fa + fb-bar + fc + fd-bar 
*       with anomalous HVV couplings
*-----------------------------------------------------------------------
*       14.6.12 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 sp(-4:4,-4:4),csp(-4:4,-4:4)
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
        complex*16 pzab,pzcd
        complex*16 App,Apm,Amp,Amm,mH4f(-1:1,-1:1)
        complex*16 fac
        complex*16 gaz(-1:1),gcz(-1:1)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        real*8 vp(-4:4,-4:4)
        integer fa,fb,fc,fd,ia,ib,ic,id,i1,i2,i3
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        logical check

        common/prods3/sp,csp,vp
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	App(ia,ib,ic,id,a1,a2,a3) = 2d0*a1*csp(ia,ic)*sp(ib,id)
     &	  + dcmplx(a2,-a3)*csp(ic,ia)*sp(ib,ia)*csp(ia,ic)*sp(id,ic)
     &	  + dcmplx(a2,+a3)*csp(ia,ib)*sp(id,ib)*csp(ic,id)*sp(ib,id)

	Apm(ia,ib,ic,id,a1,a2,a3) = 2d0*a1*csp(ia,id)*sp(ib,ic)
     &	  + dcmplx(a2,-a3)*csp(id,ia)*sp(ib,ia)*csp(ia,id)*sp(ic,id)
     &	  + dcmplx(a2,+a3)*csp(ia,ib)*sp(ic,ib)*csp(id,ic)*sp(ib,ic)

	Amm(ia,ib,ic,id,a1,a2,a3) = 2d0*a1*sp(ia,ic)*csp(ib,id)
     &	  + dcmplx(a2,+a3)*sp(ic,ia)*csp(ib,ia)*sp(ia,ic)*csp(id,ic)
     &	  + dcmplx(a2,-a3)*sp(ia,ib)*csp(id,ib)*sp(ic,id)*csp(ib,id)

	Amp(ia,ib,ic,id,a1,a2,a3) = 2d0*a1*sp(ia,id)*csp(ib,ic)
     &	  + dcmplx(a2,+a3)*sp(id,ia)*csp(ib,ia)*sp(ia,id)*csp(ic,id)
     &	  + dcmplx(a2,-a3)*sp(ia,ib)*csp(ic,ib)*sp(id,ic)*csp(ib,ic)

        sab  = vp(fa,fb)
        scd  = vp(fc,fd)

        paab = 1d0/sab
        pacd = 1d0/scd
        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(sab.lt.0d0))) then
          pzab = 1d0/(sab-mz2)
        else
          pzab = 1d0/(sab-cmz2)
        endif
        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(scd.lt.0d0))) then
          pzcd = 1d0/(scd-mz2)
        else
          pzcd = 1d0/(scd-cmz2)
        endif

        check = ((qschan.eq.1).and.(sab.gt.0d0).and.(scd.gt.0d0))
     &     .or. ((qtchan.eq.1).and.(sab.lt.0d0).and.(scd.lt.0d0))

        if (.not.check) paab = 0d0
        if (.not.check) pzab = 0d0

	mH4f(+1,+1) = ((-qa)*(-qc)*paab*pacd)
     &	              *App(fa,fb,fc,fd,a1aa,a2aa,a3aa)
     &	             +((-qa)*gcz(+1)*paab*pzcd+gaz(+1)*(-qc)*pzab*pacd)
     &	              *App(fa,fb,fc,fd,a1az,a2az,a3az)
     &	             +gaz(+1)*gcz(+1)*pzab*pzcd
     &	              *App(fa,fb,fc,fd,a1zz,a2zz,a3zz)	

	mH4f(+1,-1) = ((-qa)*(-qc)*paab*pacd)
     &	              *Apm(fa,fb,fc,fd,a1aa,a2aa,a3aa)
     &	             +((-qa)*gcz(-1)*paab*pzcd+gaz(+1)*(-qc)*pzab*pacd)
     &	              *Apm(fa,fb,fc,fd,a1az,a2az,a3az)
     &	             +gaz(+1)*gcz(-1)*pzab*pzcd
     &	              *Apm(fa,fb,fc,fd,a1zz,a2zz,a3zz)	

	mH4f(-1,+1) = ((-qa)*(-qc)*paab*pacd)
     &	              *Amp(fa,fb,fc,fd,a1aa,a2aa,a3aa)
     &	             +((-qa)*gcz(+1)*paab*pzcd+gaz(-1)*(-qc)*pzab*pacd)
     &	              *Amp(fa,fb,fc,fd,a1az,a2az,a3az)
     &	             +gaz(-1)*gcz(+1)*pzab*pzcd
     &	              *Amp(fa,fb,fc,fd,a1zz,a2zz,a3zz)	

	mH4f(-1,-1) = ((-qa)*(-qc)*paab*pacd)
     &	              *Amm(fa,fb,fc,fd,a1aa,a2aa,a3aa)
     &	             +((-qa)*gcz(-1)*paab*pzcd+gaz(-1)*(-qc)*pzab*pacd)
     &	              *Amm(fa,fb,fc,fd,a1az,a2az,a3az)
     &	             +gaz(-1)*gcz(-1)*pzab*pzcd
     &	              *Amm(fa,fb,fc,fd,a1zz,a2zz,a3zz)	

	end
